/*
  speaker test
  sweeps speaker and plots microphone in Arduino IDE plot utility
*/
//*******Sampling ISR variables and objects*******
// Create an IntervalTimer object to call buffer ISR
IntervalTimer samplingTimer;
static float sineincrement = 1;
static float monitorsineincrement = 1;
static unsigned long ISRlasttime = 0;
//https://www.wolframalpha.com/input/?i=table+round%28127*%28sin%282*pi*t%2F100%29%2B1%29%29+from+0+to+99
const int16_t sinetable[100] = { 127, 135, 143, 151, 159, 166, 174, 181, 188,
                                 195, 202, 208, 214, 220, 225, 230, 234, 238, 242, 245, 248, 250, 252, 253,
                                 254, 254, 254, 253, 252, 250, 248, 245, 242, 238, 234, 230, 225, 220, 214,
                                 208, 202, 195, 188, 181, 174, 166, 159, 151, 143, 135, 127, 119, 111, 103,
                                 95, 88, 80, 73, 66, 59, 52, 46, 40, 34, 29, 24, 20, 16, 12, 9, 6, 4, 2, 1,
                                 0, 0, 0, 1, 2, 4, 6, 9, 12, 16, 20, 24, 29, 34, 40, 46, 52, 59, 66, 73, 80,
                                 88, 95, 103, 111, 119 };
int LEDpin = 13;
const int mouthSpkrOutput = 15;  //mouth speaker output pwm 12
const int micInputPin = A0;      //mouth microphone
float drivefrequency = 880;
static volatile byte driveval;
float speakergain = 1;
unsigned long timer1 = 0;

const int BUFFSIZE = 610;  //sample at 20 us equals 81 HZ limit
static volatile int h;     //bufferindex
static volatile float rawmicbuffer[BUFFSIZE];
float shadowbuffer1[BUFFSIZE];

unsigned long lasthit;

// the setup routine runs once when you press reset:
void setup()

{

  analogWriteResolution(10);  //A/D too slow for 10 bits
  Serial.begin(38400);
  // audio bus between synth objects.  Set by looking at CPU usage

  analogWriteResolution(8);  //do I need this?
  analogWriteFrequency(mouthSpkrOutput, 30000);


  samplingTimer.begin(grabdata, 20);  // ISR to grab data (mic and drive wave)every 20 us
  samplingTimer.priority(200);        //0 is bad make this get interrupted by something, why?

  pinMode(mouthSpkrOutput, OUTPUT);  //mouth sine output
  pinMode(LEDpin, OUTPUT);           //led
  pinMode(micInputPin, INPUT);       //microphone A0

  delay(1000);
}


void loop()
{

  if ((timer1 + 10) < millis())
  {
    drivefrequency = drivefrequency + 1;
    timer1 = millis();
  }
  if (drivefrequency > 1440) drivefrequency = 300;

  sineincrement = (10000 / drivefrequency);  //test for drivefreq change?



  if (lasthit < millis())
  {
    lasthit = millis() + 100;  //lock out averaging

    int trigger_h = h;                  //grab current buffer pointer
    for (int x = 0; x < BUFFSIZE; x++)  //get copy and left justify
    {
      shadowbuffer1[x] = rawmicbuffer[trigger_h];
      trigger_h++;
      if (trigger_h > BUFFSIZE - 1) trigger_h = 0;
    }

    for (int x = 0; x < 600; x++)
    {
      if ((x % 3) == 0)
      {
        Serial.print("shadowbuffer1:");
        Serial.print(int(shadowbuffer1[x]));
        Serial.print(",");
        Serial.print("low:");
        Serial.print(0);
        Serial.print(",");
        Serial.print("high:");
        Serial.println(2000);
      }
    }
    for (int x = 0; x < 6; x++)
    {
      Serial.print("shadowbuffer1:");
      Serial.print(0);
      Serial.print(",");
      Serial.print("low:");
      Serial.print(0);
      Serial.print(",");
      Serial.print("high:");
      Serial.println(2000);
    }
  }
}

//////////////////////////////////////////////////////////
// GRABDATA FUNCTION  ISR to buffer microphone samples for analysis
/////////////////////////////////////////////////////////
void grabdata()
{

  //Sine wave output to mouth speaker
  unsigned long temptime = micros();  //figure out sine table lookup
  int tableindex = int((temptime - ISRlasttime) / sineincrement);
  if (tableindex >= 100)  //rising edge is always
  {
    tableindex = 0;
    ISRlasttime = temptime;
  }


  driveval = int(sinetable[tableindex] * speakergain);

  analogWrite(mouthSpkrOutput, driveval);  //output to speaker

  rawmicbuffer[h] = analogRead(micInputPin);
  h++;
  if (h >= BUFFSIZE) h = 0;
}
