/* ------------------------------------------------------------
  copyright: "(c)Romain Michon, CCRMA (Stanford University), GRAME"
  license: "MIT"
  name: "flute", "Flute"
  Code generated with Faust 2.37.6 (https://faust.grame.fr)
  Compilation options: -a /usr/local/share/faust/teensy/teensy.cpp -lang cpp -es 1 -single -ftz 0
  ------------------------------------------------------------ */

#ifndef  __mydsp_H__
#define  __mydsp_H__

/************************************************************************
  IMPORTANT NOTE : this file contains two clearly delimited sections :
  the ARCHITECTURE section (in two parts) and the USER section. Each section
  is governed by its own copyright and license. Please check individually
  each section for license and copyright information.
 *************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
  FAUST Architecture File
  Copyright (C) 2019-2020 GRAME, Centre National de Creation Musicale &
  Aalborg University (Copenhagen, Denmark)
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.

 ************************************************************************
 ************************************************************************/

#include <string.h> // for memset

#include "flute.h"

// IMPORTANT: in order for MapUI to work, the teensy linker must be g++
/************************** BEGIN MapUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_MAPUI_H
#define FAUST_MAPUI_H

#include <vector>
#include <map>
#include <string>
#include <stdio.h>

/************************** BEGIN UI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2020 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __UI_H__
#define __UI_H__

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

/*******************************************************************************
   UI : Faust DSP User Interface
   User Interface as expected by the buildUserInterface() method of a DSP.
   This abstract class contains only the method that the Faust compiler can
   generate to describe a DSP user interface.
 ******************************************************************************/

struct Soundfile;

template <typename REAL>
struct UIReal
{
  UIReal() {}
  virtual ~UIReal() {}

  // -- widget's layouts

  virtual void openTabBox(const char* label) = 0;
  virtual void openHorizontalBox(const char* label) = 0;
  virtual void openVerticalBox(const char* label) = 0;
  virtual void closeBox() = 0;

  // -- active widgets

  virtual void addButton(const char* label, REAL* zone) = 0;
  virtual void addCheckButton(const char* label, REAL* zone) = 0;
  virtual void addVerticalSlider(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step) = 0;
  virtual void addHorizontalSlider(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step) = 0;
  virtual void addNumEntry(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step) = 0;

  // -- passive widgets

  virtual void addHorizontalBargraph(const char* label, REAL* zone, REAL min, REAL max) = 0;
  virtual void addVerticalBargraph(const char* label, REAL* zone, REAL min, REAL max) = 0;

  // -- soundfiles

  virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) = 0;

  // -- metadata declarations

  virtual void declare(REAL* zone, const char* key, const char* val) {}

  // To be used by LLVM client
  virtual int sizeOfFAUSTFLOAT() {
    return sizeof(FAUSTFLOAT);
  }
};

struct UI : public UIReal<FAUSTFLOAT>
{
  UI() {}
  virtual ~UI() {}
};

#endif
/**************************  END  UI.h **************************/
/************************** BEGIN PathBuilder.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_PATHBUILDER_H
#define FAUST_PATHBUILDER_H

#include <vector>
#include <string>
#include <algorithm>

/*******************************************************************************
   PathBuilder : Faust User Interface
   Helper class to build complete hierarchical path for UI items.
 ******************************************************************************/

class PathBuilder
{

  protected:

    std::vector<std::string> fControlsLevel;

  public:

    PathBuilder() {}
    virtual ~PathBuilder() {}

    std::string replaceCharList(std::string str, const std::vector<char>& ch1, char ch2)
    {
      std::vector<char>::const_iterator beg = ch1.begin();
      std::vector<char>::const_iterator end = ch1.end();
      for (size_t i = 0; i < str.length(); ++i) {
        if (std::find(beg, end, str[i]) != end) {
          str[i] = ch2;
        }
      }
      return str;
    }

    std::string buildPath(const std::string& label)
    {
      std::string res = "/";
      for (size_t i = 0; i < fControlsLevel.size(); i++) {
        res += fControlsLevel[i];
        res += "/";
      }
      res += label;
      std::vector<char> rep = {' ', '#', '*', ',', '/', '?', '[', ']', '{', '}', '(', ')'};
      replaceCharList(res, rep, '_');
      return res;
    }

    void pushLabel(const std::string& label) {
      fControlsLevel.push_back(label);
    }
    void popLabel() {
      fControlsLevel.pop_back();
    }

};

#endif  // FAUST_PATHBUILDER_H
/**************************  END  PathBuilder.h **************************/

/*******************************************************************************
   MapUI : Faust User Interface
   This class creates a map of complete hierarchical path and zones for each UI items.
 ******************************************************************************/

class MapUI : public UI, public PathBuilder
{

  protected:

    // Complete path map
    std::map<std::string, FAUSTFLOAT*> fPathZoneMap;

    // Label zone map
    std::map<std::string, FAUSTFLOAT*> fLabelZoneMap;

  public:

    MapUI() {}
    virtual ~MapUI() {}

    // -- widget's layouts
    void openTabBox(const char* label)
    {
      pushLabel(label);
    }
    void openHorizontalBox(const char* label)
    {
      pushLabel(label);
    }
    void openVerticalBox(const char* label)
    {
      pushLabel(label);
    }
    void closeBox()
    {
      popLabel();
    }

    // -- active widgets
    void addButton(const char* label, FAUSTFLOAT* zone)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }
    void addCheckButton(const char* label, FAUSTFLOAT* zone)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }
    void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }
    void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }
    void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }

    // -- passive widgets
    void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }
    void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
    {
      fPathZoneMap[buildPath(label)] = zone;
      fLabelZoneMap[label] = zone;
    }

    // -- soundfiles
    virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) {}

    // -- metadata declarations
    virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
    {}

    // setParamValue/getParamValue
    void setParamValue(const std::string& path, FAUSTFLOAT value)
    {
      if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
        *fPathZoneMap[path] = value;
      } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
        *fLabelZoneMap[path] = value;
      } else {
        fprintf(stderr, "ERROR : setParamValue '%s' not found\n", path.c_str());
      }
    }

    FAUSTFLOAT getParamValue(const std::string& path)
    {
      if (fPathZoneMap.find(path) != fPathZoneMap.end()) {
        return *fPathZoneMap[path];
      } else if (fLabelZoneMap.find(path) != fLabelZoneMap.end()) {
        return *fLabelZoneMap[path];
      } else {
        fprintf(stderr, "ERROR : getParamValue '%s' not found\n", path.c_str());
        return 0;
      }
    }

    // map access
    std::map<std::string, FAUSTFLOAT*>& getMap() {
      return fPathZoneMap;
    }

    int getParamsCount() {
      return int(fPathZoneMap.size());
    }

    std::string getParamAddress(int index)
    {
      if (index < 0 || index > int(fPathZoneMap.size())) {
        return "";
      } else {
        auto it = fPathZoneMap.begin();
        while (index-- > 0 && it++ != fPathZoneMap.end()) {}
        return it->first;
      }
    }

    const char* getParamAddress1(int index)
    {
      if (index < 0 || index > int(fPathZoneMap.size())) {
        return nullptr;
      } else {
        auto it = fPathZoneMap.begin();
        while (index-- > 0 && it++ != fPathZoneMap.end()) {}
        return it->first.c_str();
      }
    }

    std::string getParamAddress(FAUSTFLOAT* zone)
    {
      for (const auto& it : fPathZoneMap) {
        if (it.second == zone) return it.first;
      }
      return "";
    }

    FAUSTFLOAT* getParamZone(const std::string& str)
    {
      if (fPathZoneMap.find(str) != fPathZoneMap.end()) {
        return fPathZoneMap[str];
      } else if (fLabelZoneMap.find(str) != fLabelZoneMap.end()) {
        return fLabelZoneMap[str];
      }
      return nullptr;
    }

    FAUSTFLOAT* getParamZone(int index)
    {
      if (index < 0 || index > int(fPathZoneMap.size())) {
        return nullptr;
      } else {
        auto it = fPathZoneMap.begin();
        while (index-- > 0 && it++ != fPathZoneMap.end()) {}
        return it->second;
      }
    }

    static bool endsWith(const std::string& str, const std::string& end)
    {
      size_t l1 = str.length();
      size_t l2 = end.length();
      return (l1 >= l2) && (0 == str.compare(l1 - l2, l2, end));
    }
};


#endif // FAUST_MAPUI_H
/**************************  END  MapUI.h **************************/
/************************** BEGIN meta.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __meta__
#define __meta__

/**
  The base class of Meta handler to be used in dsp::metadata(Meta* m) method to retrieve (key, value) metadata.
*/
struct Meta
{
  virtual ~Meta() {};
  virtual void declare(const char* key, const char* value) = 0;
};

#endif
/**************************  END  meta.h **************************/
/************************** BEGIN dsp.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __dsp__
#define __dsp__

#include <string>
#include <vector>

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

struct UI;
struct Meta;

/**
   DSP memory manager.
*/

struct dsp_memory_manager {

  virtual ~dsp_memory_manager() {}

  virtual void* allocate(size_t size) = 0;
  virtual void destroy(void* ptr) = 0;

};

/**
  Signal processor definition.
*/

class dsp {

  public:

    dsp() {}
    virtual ~dsp() {}

    /* Return instance number of audio inputs */
    virtual int getNumInputs() = 0;

    /* Return instance number of audio outputs */
    virtual int getNumOutputs() = 0;

    /**
       Trigger the ui_interface parameter with instance specific calls
       to 'openTabBox', 'addButton', 'addVerticalSlider'... in order to build the UI.

       @param ui_interface - the user interface builder
    */
    virtual void buildUserInterface(UI* ui_interface) = 0;

    /* Return the sample rate currently used by the instance */
    virtual int getSampleRate() = 0;

    /**
       Global init, calls the following methods:
       - static class 'classInit': static tables initialization
       - 'instanceInit': constants and instance state initialization

       @param sample_rate - the sampling rate in Hz
    */
    virtual void init(int sample_rate) = 0;

    /**
       Init instance state

       @param sample_rate - the sampling rate in Hz
    */
    virtual void instanceInit(int sample_rate) = 0;

    /**
       Init instance constant state

       @param sample_rate - the sampling rate in Hz
    */
    virtual void instanceConstants(int sample_rate) = 0;

    /* Init default control parameters values */
    virtual void instanceResetUserInterface() = 0;

    /* Init instance state (like delay lines...) but keep the control parameter values */
    virtual void instanceClear() = 0;

    /**
       Return a clone of the instance.

       @return a copy of the instance on success, otherwise a null pointer.
    */
    virtual dsp* clone() = 0;

    /**
       Trigger the Meta* parameter with instance specific calls to 'declare' (key, value) metadata.

       @param m - the Meta* meta user
    */
    virtual void metadata(Meta* m) = 0;

    /**
       DSP instance computation, to be called with successive in/out audio buffers.

       @param count - the number of frames to compute
       @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)
       @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (eiher float, double or quad)

    */
    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) = 0;

    /**
       DSP instance computation: alternative method to be used by subclasses.

       @param date_usec - the timestamp in microsec given by audio driver.
       @param count - the number of frames to compute
       @param inputs - the input audio buffers as an array of non-interleaved FAUSTFLOAT samples (either float, double or quad)
       @param outputs - the output audio buffers as an array of non-interleaved FAUSTFLOAT samples (either float, double or quad)

    */
    virtual void compute(double /*date_usec*/, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }

};

/**
   Generic DSP decorator.
*/

class decorator_dsp : public dsp {

  protected:

    dsp* fDSP;

  public:

    decorator_dsp(dsp* dsp = nullptr): fDSP(dsp) {}
    virtual ~decorator_dsp() {
      delete fDSP;
    }

    virtual int getNumInputs() {
      return fDSP->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP->getNumOutputs();
    }
    virtual void buildUserInterface(UI* ui_interface) {
      fDSP->buildUserInterface(ui_interface);
    }
    virtual int getSampleRate() {
      return fDSP->getSampleRate();
    }
    virtual void init(int sample_rate) {
      fDSP->init(sample_rate);
    }
    virtual void instanceInit(int sample_rate) {
      fDSP->instanceInit(sample_rate);
    }
    virtual void instanceConstants(int sample_rate) {
      fDSP->instanceConstants(sample_rate);
    }
    virtual void instanceResetUserInterface() {
      fDSP->instanceResetUserInterface();
    }
    virtual void instanceClear() {
      fDSP->instanceClear();
    }
    virtual decorator_dsp* clone() {
      return new decorator_dsp(fDSP->clone());
    }
    virtual void metadata(Meta* m) {
      fDSP->metadata(m);
    }
    // Beware: subclasses usually have to overload the two 'compute' methods
    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      fDSP->compute(count, inputs, outputs);
    }
    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      fDSP->compute(date_usec, count, inputs, outputs);
    }

};

/**
   DSP factory class, used with LLVM and Interpreter backends
   to create DSP instances from a compiled DSP program.
*/

class dsp_factory {

  protected:

    // So that to force sub-classes to use deleteDSPFactory(dsp_factory* factory);
    virtual ~dsp_factory() {}

  public:

    virtual std::string getName() = 0;
    virtual std::string getSHAKey() = 0;
    virtual std::string getDSPCode() = 0;
    virtual std::string getCompileOptions() = 0;
    virtual std::vector<std::string> getLibraryList() = 0;
    virtual std::vector<std::string> getIncludePathnames() = 0;

    virtual dsp* createDSPInstance() = 0;

    virtual void setMemoryManager(dsp_memory_manager* manager) = 0;
    virtual dsp_memory_manager* getMemoryManager() = 0;

};

// Denormal handling

#if defined (__SSE__)
#include <xmmintrin.h>
#endif

class ScopedNoDenormals
{
  private:

    intptr_t fpsr;

    void setFpStatusRegister(intptr_t fpsr_aux) noexcept
    {
#if defined (__arm64__) || defined (__aarch64__)
      asm volatile("msr fpcr, %0" : : "ri" (fpsr_aux));
#elif defined (__SSE__)
      _mm_setcsr(static_cast<uint32_t>(fpsr_aux));
#endif
    }

    void getFpStatusRegister() noexcept
    {
#if defined (__arm64__) || defined (__aarch64__)
      asm volatile("mrs %0, fpcr" : "=r" (fpsr));
#elif defined ( __SSE__)
      fpsr = static_cast<intptr_t>(_mm_getcsr());
#endif
    }

  public:

    ScopedNoDenormals() noexcept
    {
#if defined (__arm64__) || defined (__aarch64__)
      intptr_t mask = (1 << 24 /* FZ */);
#else
#if defined(__SSE__)
#if defined(__SSE2__)
      intptr_t mask = 0x8040;
#else
      intptr_t mask = 0x8000;
#endif
#else
      intptr_t mask = 0x0000;
#endif
#endif
      getFpStatusRegister();
      setFpStatusRegister(fpsr | mask);
    }

    ~ScopedNoDenormals() noexcept
    {
      setFpStatusRegister(fpsr);
    }

};

#define AVOIDDENORMALS ScopedNoDenormals();

#endif

/************************** END dsp.h **************************/

// MIDI support
#if MIDICTRL
/************************** BEGIN MidiUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_MIDIUI_H
#define FAUST_MIDIUI_H

#include <vector>
#include <string>
#include <utility>
#include <cstdlib>
#include <cmath>

/************************** BEGIN GUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __GUI_H__
#define __GUI_H__

#include <list>
#include <map>
#include <vector>
#include <assert.h>

#ifdef _WIN32
# pragma warning (disable: 4100)
#else
# pragma GCC diagnostic ignored "-Wunused-parameter"
#endif

/************************** BEGIN ValueConverter.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __ValueConverter__
#define __ValueConverter__

/***************************************************************************************
  ValueConverter.h
  (GRAME, Copyright 2015-2019)

  Set of conversion objects used to map user interface values (for example a gui slider
  delivering values between 0 and 1) to faust values (for example a vslider between
  20 and 20000) using a log scale.

  -- Utilities

  Range(lo,hi) : clip a value x between lo and hi
  Interpolator(lo,hi,v1,v2) : Maps a value x between lo and hi to a value y between v1 and v2
  Interpolator3pt(lo,mi,hi,v1,vm,v2) : Map values between lo mid hi to values between v1 vm v2

  -- Value Converters

  ValueConverter::ui2faust(x)
  ValueConverter::faust2ui(x)

  -- ValueConverters used for sliders depending of the scale

  LinearValueConverter(umin, umax, fmin, fmax)
  LinearValueConverter2(lo, mi, hi, v1, vm, v2) using 2 segments
  LogValueConverter(umin, umax, fmin, fmax)
  ExpValueConverter(umin, umax, fmin, fmax)

  -- ValueConverters used for accelerometers based on 3 points

  AccUpConverter(amin, amid, amax, fmin, fmid, fmax)        -- curve 0
  AccDownConverter(amin, amid, amax, fmin, fmid, fmax)      -- curve 1
  AccUpDownConverter(amin, amid, amax, fmin, fmid, fmax)    -- curve 2
  AccDownUpConverter(amin, amid, amax, fmin, fmid, fmax)    -- curve 3

  -- lists of ZoneControl are used to implement accelerometers metadata for each axes

  ZoneControl(zone, valueConverter) : a zone with an accelerometer data converter

  -- ZoneReader are used to implement screencolor metadata

  ZoneReader(zone, valueConverter) : a zone with a data converter

****************************************************************************************/

#include <float.h>
#include <algorithm>    // std::max
#include <cmath>
#include <vector>
#include <assert.h>

//--------------------------------------------------------------------------------------
// Interpolator(lo,hi,v1,v2)
// Maps a value x between lo and hi to a value y between v1 and v2
// y = v1 + (x-lo)/(hi-lo)*(v2-v1)
// y = v1 + (x-lo) * coef           with coef = (v2-v1)/(hi-lo)
// y = v1 + x*coef - lo*coef
// y = v1 - lo*coef + x*coef
// y = offset + x*coef              with offset = v1 - lo*coef
//--------------------------------------------------------------------------------------
class Interpolator
{
  private:

    //--------------------------------------------------------------------------------------
    // Range(lo,hi) clip a value between lo and hi
    //--------------------------------------------------------------------------------------
    struct Range
    {
      double fLo;
      double fHi;

      Range(double x, double y) : fLo(std::min<double>(x, y)), fHi(std::max<double>(x, y)) {}
      double operator()(double x) {
        return (x < fLo) ? fLo : (x > fHi) ? fHi : x;
      }
    };


    Range fRange;
    double fCoef;
    double fOffset;

  public:

    Interpolator(double lo, double hi, double v1, double v2) : fRange(lo, hi)
    {
      if (hi != lo) {
        // regular case
        fCoef = (v2 - v1) / (hi - lo);
        fOffset = v1 - lo * fCoef;
      } else {
        // degenerate case, avoids division by zero
        fCoef = 0;
        fOffset = (v1 + v2) / 2;
      }
    }
    double operator()(double v)
    {
      double x = fRange(v);
      return  fOffset + x * fCoef;
    }

    void getLowHigh(double& amin, double& amax)
    {
      amin = fRange.fLo;
      amax = fRange.fHi;
    }
};

//--------------------------------------------------------------------------------------
// Interpolator3pt(lo,mi,hi,v1,vm,v2)
// Map values between lo mid hi to values between v1 vm v2
//--------------------------------------------------------------------------------------
class Interpolator3pt
{

  private:

    Interpolator fSegment1;
    Interpolator fSegment2;
    double fMid;

  public:

    Interpolator3pt(double lo, double mi, double hi, double v1, double vm, double v2) :
      fSegment1(lo, mi, v1, vm),
      fSegment2(mi, hi, vm, v2),
      fMid(mi) {}
    double operator()(double x) {
      return  (x < fMid) ? fSegment1(x) : fSegment2(x);
    }

    void getMappingValues(double& amin, double& amid, double& amax)
    {
      fSegment1.getLowHigh(amin, amid);
      fSegment2.getLowHigh(amid, amax);
    }
};

//--------------------------------------------------------------------------------------
// Abstract ValueConverter class. Converts values between UI and Faust representations
//--------------------------------------------------------------------------------------
class ValueConverter // Identity by default
{

  public:

    virtual ~ValueConverter() {}
    virtual double ui2faust(double x) {
      return x;
    };
    virtual double faust2ui(double x) {
      return x;
    };
};

//--------------------------------------------------------------------------------------
// A converter than can be updated
//--------------------------------------------------------------------------------------

class UpdatableValueConverter : public ValueConverter {

  protected:

    bool fActive;

  public:

    UpdatableValueConverter(): fActive(true)
    {}
    virtual ~UpdatableValueConverter()
    {}

    virtual void setMappingValues(double amin, double amid, double amax, double min, double init, double max) = 0;
    virtual void getMappingValues(double& amin, double& amid, double& amax) = 0;

    void setActive(bool on_off) {
      fActive = on_off;
    }
    bool getActive() {
      return fActive;
    }

};

//--------------------------------------------------------------------------------------
// Linear conversion between ui and Faust values
//--------------------------------------------------------------------------------------
class LinearValueConverter : public ValueConverter
{

  private:

    Interpolator fUI2F;
    Interpolator fF2UI;

  public:

    LinearValueConverter(double umin, double umax, double fmin, double fmax) :
      fUI2F(umin, umax, fmin, fmax), fF2UI(fmin, fmax, umin, umax)
    {}

    LinearValueConverter() : fUI2F(0., 0., 0., 0.), fF2UI(0., 0., 0., 0.)
    {}
    virtual double ui2faust(double x) {
      return fUI2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2UI(x);
    }

};

//--------------------------------------------------------------------------------------
// Two segments linear conversion between ui and Faust values
//--------------------------------------------------------------------------------------
class LinearValueConverter2 : public UpdatableValueConverter
{

  private:

    Interpolator3pt fUI2F;
    Interpolator3pt fF2UI;

  public:

    LinearValueConverter2(double amin, double amid, double amax, double min, double init, double max) :
      fUI2F(amin, amid, amax, min, init, max), fF2UI(min, init, max, amin, amid, amax)
    {}

    LinearValueConverter2() : fUI2F(0., 0., 0., 0., 0., 0.), fF2UI(0., 0., 0., 0., 0., 0.)
    {}

    virtual double ui2faust(double x) {
      return fUI2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2UI(x);
    }

    virtual void setMappingValues(double amin, double amid, double amax, double min, double init, double max)
    {
      fUI2F = Interpolator3pt(amin, amid, amax, min, init, max);
      fF2UI = Interpolator3pt(min, init, max, amin, amid, amax);
    }

    virtual void getMappingValues(double& amin, double& amid, double& amax)
    {
      fUI2F.getMappingValues(amin, amid, amax);
    }

};

//--------------------------------------------------------------------------------------
// Logarithmic conversion between ui and Faust values
//--------------------------------------------------------------------------------------
class LogValueConverter : public LinearValueConverter
{

  public:

    LogValueConverter(double umin, double umax, double fmin, double fmax) :
      LinearValueConverter(umin, umax, std::log(std::max<double>(DBL_MIN, fmin)), std::log(std::max<double>(DBL_MIN, fmax)))
    {}

    virtual double ui2faust(double x) {
      return std::exp(LinearValueConverter::ui2faust(x));
    }
    virtual double faust2ui(double x) {
      return LinearValueConverter::faust2ui(std::log(std::max<double>(x, DBL_MIN)));
    }

};

//--------------------------------------------------------------------------------------
// Exponential conversion between ui and Faust values
//--------------------------------------------------------------------------------------
class ExpValueConverter : public LinearValueConverter
{

  public:

    ExpValueConverter(double umin, double umax, double fmin, double fmax) :
      LinearValueConverter(umin, umax, std::min<double>(DBL_MAX, std::exp(fmin)), std::min<double>(DBL_MAX, std::exp(fmax)))
    {}

    virtual double ui2faust(double x) {
      return std::log(LinearValueConverter::ui2faust(x));
    }
    virtual double faust2ui(double x) {
      return LinearValueConverter::faust2ui(std::min<double>(DBL_MAX, std::exp(x)));
    }

};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using an Up curve (curve 0)
//--------------------------------------------------------------------------------------
class AccUpConverter : public UpdatableValueConverter
{

  private:

    Interpolator3pt fA2F;
    Interpolator3pt fF2A;

  public:

    AccUpConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
      fA2F(amin, amid, amax, fmin, fmid, fmax),
      fF2A(fmin, fmid, fmax, amin, amid, amax)
    {}

    virtual double ui2faust(double x) {
      return fA2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2A(x);
    }

    virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
    {
      //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccUpConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
      fA2F = Interpolator3pt(amin, amid, amax, fmin, fmid, fmax);
      fF2A = Interpolator3pt(fmin, fmid, fmax, amin, amid, amax);
    }

    virtual void getMappingValues(double& amin, double& amid, double& amax)
    {
      fA2F.getMappingValues(amin, amid, amax);
    }

};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using a Down curve (curve 1)
//--------------------------------------------------------------------------------------
class AccDownConverter : public UpdatableValueConverter
{

  private:

    Interpolator3pt	fA2F;
    Interpolator3pt	fF2A;

  public:

    AccDownConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
      fA2F(amin, amid, amax, fmax, fmid, fmin),
      fF2A(fmin, fmid, fmax, amax, amid, amin)
    {}

    virtual double ui2faust(double x) {
      return fA2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2A(x);
    }

    virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
    {
      //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccDownConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
      fA2F = Interpolator3pt(amin, amid, amax, fmax, fmid, fmin);
      fF2A = Interpolator3pt(fmin, fmid, fmax, amax, amid, amin);
    }

    virtual void getMappingValues(double& amin, double& amid, double& amax)
    {
      fA2F.getMappingValues(amin, amid, amax);
    }
};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using an Up-Down curve (curve 2)
//--------------------------------------------------------------------------------------
class AccUpDownConverter : public UpdatableValueConverter
{

  private:

    Interpolator3pt	fA2F;
    Interpolator fF2A;

  public:

    AccUpDownConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
      fA2F(amin, amid, amax, fmin, fmax, fmin),
      fF2A(fmin, fmax, amin, amax)				// Special, pseudo inverse of a non monotonic function
    {}

    virtual double ui2faust(double x) {
      return fA2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2A(x);
    }

    virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
    {
      //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccUpDownConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
      fA2F = Interpolator3pt(amin, amid, amax, fmin, fmax, fmin);
      fF2A = Interpolator(fmin, fmax, amin, amax);
    }

    virtual void getMappingValues(double& amin, double& amid, double& amax)
    {
      fA2F.getMappingValues(amin, amid, amax);
    }
};

//--------------------------------------------------------------------------------------
// Convert accelerometer or gyroscope values to Faust values
// Using a Down-Up curve (curve 3)
//--------------------------------------------------------------------------------------
class AccDownUpConverter : public UpdatableValueConverter
{

  private:

    Interpolator3pt	fA2F;
    Interpolator fF2A;

  public:

    AccDownUpConverter(double amin, double amid, double amax, double fmin, double fmid, double fmax) :
      fA2F(amin, amid, amax, fmax, fmin, fmax),
      fF2A(fmin, fmax, amin, amax)				// Special, pseudo inverse of a non monotonic function
    {}

    virtual double ui2faust(double x) {
      return fA2F(x);
    }
    virtual double faust2ui(double x) {
      return fF2A(x);
    }

    virtual void setMappingValues(double amin, double amid, double amax, double fmin, double fmid, double fmax)
    {
      //__android_log_print(ANDROID_LOG_ERROR, "Faust", "AccDownUpConverter update %f %f %f %f %f %f", amin,amid,amax,fmin,fmid,fmax);
      fA2F = Interpolator3pt(amin, amid, amax, fmax, fmin, fmax);
      fF2A = Interpolator(fmin, fmax, amin, amax);
    }

    virtual void getMappingValues(double& amin, double& amid, double& amax)
    {
      fA2F.getMappingValues(amin, amid, amax);
    }
};

//--------------------------------------------------------------------------------------
// Base class for ZoneControl
//--------------------------------------------------------------------------------------
class ZoneControl
{

  protected:

    FAUSTFLOAT*	fZone;

  public:

    ZoneControl(FAUSTFLOAT* zone) : fZone(zone) {}
    virtual ~ZoneControl() {}

    virtual void update(double v) const {}

    virtual void setMappingValues(int curve, double amin, double amid, double amax, double min, double init, double max) {}
    virtual void getMappingValues(double& amin, double& amid, double& amax) {}

    FAUSTFLOAT* getZone() {
      return fZone;
    }

    virtual void setActive(bool on_off) {}
    virtual bool getActive() {
      return false;
    }

    virtual int getCurve() {
      return -1;
    }

};

//--------------------------------------------------------------------------------------
//  Useful to implement accelerometers metadata as a list of ZoneControl for each axes
//--------------------------------------------------------------------------------------
class ConverterZoneControl : public ZoneControl
{

  protected:

    ValueConverter* fValueConverter;

  public:

    ConverterZoneControl(FAUSTFLOAT* zone, ValueConverter* converter) : ZoneControl(zone), fValueConverter(converter) {}
    virtual ~ConverterZoneControl() {
      delete fValueConverter;  // Assuming fValueConverter is not kept elsewhere...
    }

    virtual void update(double v) const {
      *fZone = fValueConverter->ui2faust(v);
    }

    ValueConverter* getConverter() {
      return fValueConverter;
    }

};

//--------------------------------------------------------------------------------------
// Association of a zone and a four value converter, each one for each possible curve.
// Useful to implement accelerometers metadata as a list of ZoneControl for each axes
//--------------------------------------------------------------------------------------
class CurveZoneControl : public ZoneControl
{

  private:

    std::vector<UpdatableValueConverter*> fValueConverters;
    int fCurve;

  public:

    CurveZoneControl(FAUSTFLOAT* zone, int curve, double amin, double amid, double amax, double min, double init, double max) : ZoneControl(zone), fCurve(0)
    {
      assert(curve >= 0 && curve <= 3);
      fValueConverters.push_back(new AccUpConverter(amin, amid, amax, min, init, max));
      fValueConverters.push_back(new AccDownConverter(amin, amid, amax, min, init, max));
      fValueConverters.push_back(new AccUpDownConverter(amin, amid, amax, min, init, max));
      fValueConverters.push_back(new AccDownUpConverter(amin, amid, amax, min, init, max));
      fCurve = curve;
    }
    virtual ~CurveZoneControl()
    {
      std::vector<UpdatableValueConverter*>::iterator it;
      for (it = fValueConverters.begin(); it != fValueConverters.end(); it++) {
        delete(*it);
      }
    }
    void update(double v) const {
      if (fValueConverters[fCurve]->getActive()) *fZone = fValueConverters[fCurve]->ui2faust(v);
    }

    void setMappingValues(int curve, double amin, double amid, double amax, double min, double init, double max)
    {
      fValueConverters[curve]->setMappingValues(amin, amid, amax, min, init, max);
      fCurve = curve;
    }

    void getMappingValues(double& amin, double& amid, double& amax)
    {
      fValueConverters[fCurve]->getMappingValues(amin, amid, amax);
    }

    void setActive(bool on_off)
    {
      std::vector<UpdatableValueConverter*>::iterator it;
      for (it = fValueConverters.begin(); it != fValueConverters.end(); it++) {
        (*it)->setActive(on_off);
      }
    }

    int getCurve() {
      return fCurve;
    }
};

class ZoneReader
{

  private:

    FAUSTFLOAT* fZone;
    Interpolator fInterpolator;

  public:

    ZoneReader(FAUSTFLOAT* zone, double lo, double hi) : fZone(zone), fInterpolator(lo, hi, 0, 255) {}

    virtual ~ZoneReader() {}

    int getValue()
    {
      return (fZone != nullptr) ? int(fInterpolator(*fZone)) : 127;
    }

};

#endif
/**************************  END  ValueConverter.h **************************/
/************************** BEGIN MetaDataUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef MetaData_UI_H
#define MetaData_UI_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

#include <map>
#include <set>
#include <string>
#include <string.h>
#include <assert.h>
#include <stdio.h> // We use the lighter fprintf code

/************************** BEGIN SimpleParser.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef SIMPLEPARSER_H
#define SIMPLEPARSER_H

// ---------------------------------------------------------------------
//                          Simple Parser
// A parser returns true if it was able to parse what it is
// supposed to parse and advance the pointer. Otherwise it returns false
// and the pointer is not advanced so that another parser can be tried.
// ---------------------------------------------------------------------

#include <vector>
#include <map>
#include <string>
#include <cmath>
#include <fstream>
#include <sstream>
#include <stdio.h> // We use the lighter fprintf code
#include <ctype.h>

#ifndef _WIN32
# pragma GCC diagnostic ignored "-Wunused-function"
#endif

struct itemInfo {
  std::string type;
  std::string label;
  std::string url;
  std::string address;
  int index;
  double init;
  double fmin;
  double fmax;
  double step;
  std::vector<std::pair<std::string, std::string> > meta;

  itemInfo(): index(0), init(0.), fmin(0.), fmax(0.), step(0.)
  {}
};

// ---------------------------------------------------------------------
//                          Elementary parsers
// ---------------------------------------------------------------------

// Report a parsing error
static bool parseError(const char*& p, const char* errmsg)
{
  fprintf(stderr, "Parse error : %s here : %s\n", errmsg, p);
  return true;
}

/**
   @brief skipBlank : advance pointer p to the first non blank character
   @param p the string to parse, then the remaining string
*/
static void skipBlank(const char*& p)
{
  while (isspace(*p)) {
    p++;
  }
}

// Parse character x, but don't report error if fails
static bool tryChar(const char*& p, char x)
{
  skipBlank(p);
  if (x == *p) {
    p++;
    return true;
  } else {
    return false;
  }
}

/**
   @brief parseChar : parse a specific character x
   @param p the string to parse, then the remaining string
   @param x the character to recognize
   @return true if x was found at the begin of p
*/
static bool parseChar(const char*& p, char x)
{
  skipBlank(p);
  if (x == *p) {
    p++;
    return true;
  } else {
    return false;
  }
}

/**
   @brief parseWord : parse a specific string w
   @param p the string to parse, then the remaining string
   @param w the string to recognize
   @return true if string w was found at the begin of p
*/
static bool parseWord(const char*& p, const char* w)
{
  skipBlank(p);
  const char* saved = p;  // to restore position if we fail
  while ((*w == *p) && (*w)) {
    ++w;
    ++p;
  }
  if (*w) {
    p = saved;
    return false;
  } else {
    return true;
  }
}

/**
   @brief parseDouble : parse number [s]dddd[.dddd] or [s]d[.dddd][E|e][s][dddd] and store the result in x
   @param p the string to parse, then the remaining string
   @param x the float number found if any
   @return true if a float number was found at the begin of p
*/
static bool parseDouble(const char*& p, double& x)
{
  double sign = 1.0;     // sign of the number
  double ipart = 0;      // integral part of the number
  double dpart = 0;      // decimal part of the number before division
  double dcoef = 1.0;    // division factor for the decimal part
  double expsign = 1.0;  // sign of the E|e part
  double expcoef = 0.0;  // multiplication factor of E|e part

  bool valid = false;    // true if the number contains at least one digit

  skipBlank(p);
  const char* saved = p;  // to restore position if we fail

  // Sign
  if (parseChar(p, '+')) {
    sign = 1.0;
  } else if (parseChar(p, '-')) {
    sign = -1.0;
  }

  // Integral part
  while (isdigit(*p)) {
    valid = true;
    ipart = ipart * 10 + (*p - '0');
    p++;
  }

  // Possible decimal part
  if (parseChar(p, '.')) {
    while (isdigit(*p)) {
      valid = true;
      dpart = dpart * 10 + (*p - '0');
      dcoef *= 10.0;
      p++;
    }
  }

  // Possible E|e part
  if (parseChar(p, 'E') || parseChar(p, 'e')) {
    if (parseChar(p, '+')) {
      expsign = 1.0;
    } else if (parseChar(p, '-')) {
      expsign = -1.0;
    }
    while (isdigit(*p)) {
      expcoef = expcoef * 10 + (*p - '0');
      p++;
    }
  }

  if (valid)  {
    x = (sign * (ipart + dpart / dcoef)) * std::pow(10.0, expcoef * expsign);
  } else {
    p = saved;
  }
  return valid;
}

/**
   @brief parseString, parse an arbitrary quoted string q...q and store the result in s
   @param p the string to parse, then the remaining string
   @param quote the character used to quote the string
   @param s the (unquoted) string found if any
   @return true if a string was found at the begin of p
*/
static bool parseString(const char*& p, char quote, std::string& s)
{
  std::string str;
  skipBlank(p);

  const char* saved = p;  // to restore position if we fail
  if (*p++ == quote) {
    while ((*p != 0) && (*p != quote)) {
      str += *p++;
    }
    if (*p++ == quote) {
      s = str;
      return true;
    }
  }
  p = saved;
  return false;
}

/**
   @brief parseSQString, parse a single quoted string '...' and store the result in s
   @param p the string to parse, then the remaining string
   @param s the (unquoted) string found if any
   @return true if a string was found at the begin of p
*/
static bool parseSQString(const char*& p, std::string& s)
{
  return parseString(p, '\'', s);
}

/**
   @brief parseDQString, parse a double quoted string "..." and store the result in s
   @param p the string to parse, then the remaining string
   @param s the (unquoted) string found if any
   @return true if a string was found at the begin of p
*/
static bool parseDQString(const char*& p, std::string& s)
{
  return parseString(p, '"', s);
}

// ---------------------------------------------------------------------
//
//                          IMPLEMENTATION
//
// ---------------------------------------------------------------------

/**
   @brief parseMenuItem, parse a menu item ...'low':440.0...
   @param p the string to parse, then the remaining string
   @param name the name found
   @param value the value found
   @return true if a nemu item was found
*/
static bool parseMenuItem(const char*& p, std::string& name, double& value)
{
  const char* saved = p;  // to restore position if we fail
  if (parseSQString(p, name) && parseChar(p, ':') && parseDouble(p, value)) {
    return true;
  } else {
    p = saved;
    return false;
  }
}

static bool parseMenuItem2(const char*& p, std::string& name)
{
  const char* saved = p;  // to restore position if we fail
  // single quoted
  if (parseSQString(p, name)) {
    return true;
  } else {
    p = saved;
    return false;
  }
}

/**
   @brief parseMenuList, parse a menu list {'low' : 440.0; 'mid' : 880.0; 'hi' : 1760.0}...
   @param p the string to parse, then the remaining string
   @param names the vector of names found
   @param values the vector of values found
   @return true if a menu list was found
*/
static bool parseMenuList(const char*& p, std::vector<std::string>& names, std::vector<double>& values)
{
  std::vector<std::string> tmpnames;
  std::vector<double> tmpvalues;
  const char* saved = p; // to restore position if we fail

  if (parseChar(p, '{')) {
    do {
      std::string n;
      double v;
      if (parseMenuItem(p, n, v)) {
        tmpnames.push_back(n);
        tmpvalues.push_back(v);
      } else {
        p = saved;
        return false;
      }
    } while (parseChar(p, ';'));
    if (parseChar(p, '}')) {
      // we suceeded
      names = tmpnames;
      values = tmpvalues;
      return true;
    }
  }
  p = saved;
  return false;
}

static bool parseMenuList2(const char*& p, std::vector<std::string>& names, bool debug)
{
  std::vector<std::string> tmpnames;
  const char* saved = p;  // to restore position if we fail

  if (parseChar(p, '{')) {
    do {
      std::string n;
      if (parseMenuItem2(p, n)) {
        tmpnames.push_back(n);
      } else {
        goto error;
      }
    } while (parseChar(p, ';'));
    if (parseChar(p, '}')) {
      // we suceeded
      names = tmpnames;
      return true;
    }
  }

error:
  if (debug) {
    fprintf(stderr, "parseMenuList2 : (%s) is not a valid list !\n", p);
  }
  p = saved;
  return false;
}

/// ---------------------------------------------------------------------
// Parse list of strings
/// ---------------------------------------------------------------------
static bool parseList(const char*& p, std::vector<std::string>& items)
{
  const char* saved = p;  // to restore position if we fail
  if (parseChar(p, '[')) {
    do {
      std::string item;
      if (!parseDQString(p, item)) {
        p = saved;
        return false;
      }
      items.push_back(item);
    } while (tryChar(p, ','));
    return parseChar(p, ']');
  } else {
    p = saved;
    return false;
  }
}

static bool parseMetaData(const char*& p, std::map<std::string, std::string>& metadatas)
{
  const char* saved = p; // to restore position if we fail
  std::string metaKey, metaValue;
  if (parseChar(p, ':') && parseChar(p, '[')) {
    do {
      if (parseChar(p, '{') && parseDQString(p, metaKey) && parseChar(p, ':') && parseDQString(p, metaValue) && parseChar(p, '}')) {
        metadatas[metaKey] = metaValue;
      }
    } while (tryChar(p, ','));
    return parseChar(p, ']');
  } else {
    p = saved;
    return false;
  }
}

static bool parseItemMetaData(const char*& p, std::vector<std::pair<std::string, std::string> >& metadatas)
{
  const char* saved = p; // to restore position if we fail
  std::string metaKey, metaValue;
  if (parseChar(p, ':') && parseChar(p, '[')) {
    do {
      if (parseChar(p, '{') && parseDQString(p, metaKey) && parseChar(p, ':') && parseDQString(p, metaValue) && parseChar(p, '}')) {
        metadatas.push_back(std::make_pair(metaKey, metaValue));
      }
    } while (tryChar(p, ','));
    return parseChar(p, ']');
  } else {
    p = saved;
    return false;
  }
}

// ---------------------------------------------------------------------
// Parse metadatas of the interface:
// "name" : "...", "inputs" : "...", "outputs" : "...", ...
// and store the result as key/value
/// ---------------------------------------------------------------------
static bool parseGlobalMetaData(const char*& p, std::string& key, std::string& value, double& dbl, std::map<std::string, std::string>& metadatas, std::vector<std::string>& items)
{
  const char* saved = p; // to restore position if we fail
  if (parseDQString(p, key)) {
    if (key == "meta") {
      return parseMetaData(p, metadatas);
    } else {
      return parseChar(p, ':') && (parseDQString(p, value) || parseList(p, items) || parseDouble(p, dbl));
    }
  } else {
    p = saved;
    return false;
  }
}

// ---------------------------------------------------------------------
// Parse gui:
// "type" : "...", "label" : "...", "address" : "...", ...
// and store the result in uiItems Vector
/// ---------------------------------------------------------------------
static bool parseUI(const char*& p, std::vector<itemInfo>& uiItems, int& numItems)
{
  const char* saved = p; // to restore position if we fail
  if (parseChar(p, '{')) {

    std::string label;
    std::string value;
    double dbl = 0;

    do {
      if (parseDQString(p, label)) {
        if (label == "type") {
          if (uiItems.size() != 0) {
            numItems++;
          }
          if (parseChar(p, ':') && parseDQString(p, value)) {
            itemInfo item;
            item.type = value;
            uiItems.push_back(item);
          }
        }

        else if (label == "label") {
          if (parseChar(p, ':') && parseDQString(p, value)) {
            uiItems[numItems].label = value;
          }
        }

        else if (label == "url") {
          if (parseChar(p, ':') && parseDQString(p, value)) {
            uiItems[numItems].url = value;
          }
        }

        else if (label == "address") {
          if (parseChar(p, ':') && parseDQString(p, value)) {
            uiItems[numItems].address = value;
          }
        }

        else if (label == "index") {
          if (parseChar(p, ':') && parseDouble(p, dbl)) {
            uiItems[numItems].index = int(dbl);
          }
        }

        else if (label == "meta") {
          if (!parseItemMetaData(p, uiItems[numItems].meta)) {
            return false;
          }
        }

        else if (label == "init") {
          if (parseChar(p, ':') && parseDouble(p, dbl)) {
            uiItems[numItems].init = dbl;
          }
        }

        else if (label == "min") {
          if (parseChar(p, ':') && parseDouble(p, dbl)) {
            uiItems[numItems].fmin = dbl;
          }
        }

        else if (label == "max") {
          if (parseChar(p, ':') && parseDouble(p, dbl)) {
            uiItems[numItems].fmax = dbl;
          }
        }

        else if (label == "step") {
          if (parseChar(p, ':') && parseDouble(p, dbl)) {
            uiItems[numItems].step = dbl;
          }
        }

        else if (label == "items") {
          if (parseChar(p, ':') && parseChar(p, '[')) {
            do {
              if (!parseUI(p, uiItems, numItems)) {
                p = saved;
                return false;
              }
            } while (tryChar(p, ','));
            if (parseChar(p, ']')) {
              itemInfo item;
              item.type = "close";
              uiItems.push_back(item);
              numItems++;
            }
          }
        }
      } else {
        p = saved;
        return false;
      }

    } while (tryChar(p, ','));

    return parseChar(p, '}');
  } else {
    return true; // "items": [] is valid
  }
}

// ---------------------------------------------------------------------
// Parse full JSON record describing a JSON/Faust interface :
// {"metadatas": "...", "ui": [{ "type": "...", "label": "...", "items": [...], "address": "...","init": "...", "min": "...", "max": "...","step": "..."}]}
//
// and store the result in map Metadatas and vector containing the items of the interface. Returns true if parsing was successfull.
/// ---------------------------------------------------------------------
static bool parseJson(const char*& p,
                      std::map<std::string, std::pair<std::string, double> >& metaDatas0,
                      std::map<std::string, std::string>& metaDatas1,
                      std::map<std::string, std::vector<std::string> >& metaDatas2,
                      std::vector<itemInfo>& uiItems)
{
  parseChar(p, '{');

  do {
    std::string key;
    std::string value;
    double dbl = 0;
    std::vector<std::string> items;
    if (parseGlobalMetaData(p, key, value, dbl, metaDatas1, items)) {
      if (key != "meta") {
        // keep "name", "inputs", "outputs" key/value pairs
        if (items.size() > 0) {
          metaDatas2[key] = items;
          items.clear();
        } else if (value != "") {
          metaDatas0[key].first = value;
        } else {
          metaDatas0[key].second = dbl;
        }
      }
    } else if (key == "ui") {
      int numItems = 0;
      parseChar(p, '[') && parseUI(p, uiItems, numItems);
    }
  } while (tryChar(p, ','));

  return parseChar(p, '}');
}

#endif // SIMPLEPARSER_H
/**************************  END  SimpleParser.h **************************/

static bool startWith(const std::string& str, const std::string& prefix)
{
  return (str.substr(0, prefix.size()) == prefix);
}

/**
   Convert a dB value into a scale between 0 and 1 (following IEC standard ?)
*/
static FAUSTFLOAT dB2Scale(FAUSTFLOAT dB)
{
  FAUSTFLOAT scale = FAUSTFLOAT(1.0);

  /*if (dB < -70.0f)
    scale = 0.0f;
    else*/
  if (dB < FAUSTFLOAT(-60.0))
    scale = (dB + FAUSTFLOAT(70.0)) * FAUSTFLOAT(0.0025);
  else if (dB < FAUSTFLOAT(-50.0))
    scale = (dB + FAUSTFLOAT(60.0)) * FAUSTFLOAT(0.005) + FAUSTFLOAT(0.025);
  else if (dB < FAUSTFLOAT(-40.0))
    scale = (dB + FAUSTFLOAT(50.0)) * FAUSTFLOAT(0.0075) + FAUSTFLOAT(0.075);
  else if (dB < FAUSTFLOAT(-30.0))
    scale = (dB + FAUSTFLOAT(40.0)) * FAUSTFLOAT(0.015) + FAUSTFLOAT(0.15);
  else if (dB < FAUSTFLOAT(-20.0))
    scale = (dB + FAUSTFLOAT(30.0)) * FAUSTFLOAT(0.02) + FAUSTFLOAT(0.3);
  else if (dB < FAUSTFLOAT(-0.001) || dB > FAUSTFLOAT(0.001))  /* if (dB < 0.0) */
    scale = (dB + FAUSTFLOAT(20.0)) * FAUSTFLOAT(0.025) + FAUSTFLOAT(0.5);

  return scale;
}

/*******************************************************************************
   MetaDataUI : Common class for MetaData handling
 ******************************************************************************/

//============================= BEGIN GROUP LABEL METADATA===========================
// Unlike widget's label, metadata inside group's label are not extracted directly by
// the Faust compiler. Therefore they must be extracted within the architecture file
//-----------------------------------------------------------------------------------

class MetaDataUI {

  protected:

    std::string                         fGroupTooltip;
    std::map<FAUSTFLOAT*, FAUSTFLOAT>   fGuiSize;            // map widget zone with widget size coef
    std::map<FAUSTFLOAT*, std::string>  fTooltip;            // map widget zone with tooltip strings
    std::map<FAUSTFLOAT*, std::string>  fUnit;               // map widget zone to unit string (i.e. "dB")
    std::map<FAUSTFLOAT*, std::string>  fRadioDescription;   // map zone to {'low':440; ...; 'hi':1000.0}
    std::map<FAUSTFLOAT*, std::string>  fMenuDescription;    // map zone to {'low':440; ...; 'hi':1000.0}
    std::set<FAUSTFLOAT*>               fKnobSet;            // set of widget zone to be knobs
    std::set<FAUSTFLOAT*>               fLedSet;             // set of widget zone to be LEDs
    std::set<FAUSTFLOAT*>               fNumSet;             // set of widget zone to be numerical bargraphs
    std::set<FAUSTFLOAT*>               fLogSet;             // set of widget zone having a log UI scale
    std::set<FAUSTFLOAT*>               fExpSet;             // set of widget zone having an exp UI scale
    std::set<FAUSTFLOAT*>               fHiddenSet;          // set of hidden widget zone

    void clearMetadata()
    {
      fGuiSize.clear();
      fTooltip.clear();
      fUnit.clear();
      fRadioDescription.clear();
      fMenuDescription.clear();
      fKnobSet.clear();
      fLedSet.clear();
      fNumSet.clear();
      fLogSet.clear();
      fExpSet.clear();
      fHiddenSet.clear();
      fGroupTooltip = "";
    }

    /**
       rmWhiteSpaces(): Remove the leading and trailing white spaces of a string
       (but not those in the middle of the string)
    */
    static std::string rmWhiteSpaces(const std::string& s)
    {
      size_t i = s.find_first_not_of(" \t");
      size_t j = s.find_last_not_of(" \t");
      if ((i != std::string::npos) && (j != std::string::npos)) {
        return s.substr(i, 1 + j - i);
      } else {
        return "";
      }
    }

    /**
       Format tooltip string by replacing some white spaces by
       return characters so that line width doesn't exceed n.
       Limitation : long words exceeding n are not cut.
    */
    std::string formatTooltip(int n, const std::string& tt)
    {
      std::string ss = tt;  // ss string we are going to format
      int lws = 0;          // last white space encountered
      int lri = 0;          // last return inserted
      for (int i = 0; i < (int)tt.size(); i++) {
        if (tt[i] == ' ') lws = i;
        if (((i - lri) >= n) && (lws > lri)) {
          // insert return here
          ss[lws] = '\n';
          lri = lws;
        }
      }
      return ss;
    }

  public:

    virtual ~MetaDataUI()
    {}

    enum Scale {
      kLin,
      kLog,
      kExp
    };

    Scale getScale(FAUSTFLOAT* zone)
    {
      if (fLogSet.count(zone) > 0) return kLog;
      if (fExpSet.count(zone) > 0) return kExp;
      return kLin;
    }

    bool isKnob(FAUSTFLOAT* zone)
    {
      return fKnobSet.count(zone) > 0;
    }

    bool isRadio(FAUSTFLOAT* zone)
    {
      return fRadioDescription.count(zone) > 0;
    }

    bool isMenu(FAUSTFLOAT* zone)
    {
      return fMenuDescription.count(zone) > 0;
    }

    bool isLed(FAUSTFLOAT* zone)
    {
      return fLedSet.count(zone) > 0;
    }

    bool isNumerical(FAUSTFLOAT* zone)
    {
      return fNumSet.count(zone) > 0;
    }

    bool isHidden(FAUSTFLOAT* zone)
    {
      return fHiddenSet.count(zone) > 0;
    }

    /**
       Extracts metadata from a label : 'vol [unit: dB]' -> 'vol' + metadata(unit=dB)
    */
    static void extractMetadata(const std::string& fulllabel, std::string& label, std::map<std::string, std::string>& metadata)
    {
      enum {kLabel, kEscape1, kEscape2, kEscape3, kKey, kValue};
      int state = kLabel; int deep = 0;
      std::string key, value;

      for (unsigned int i = 0; i < fulllabel.size(); i++) {
        char c = fulllabel[i];
        switch (state) {
          case kLabel :
            assert(deep == 0);
            switch (c) {
              case '\\' : state = kEscape1; break;
              case '[' : state = kKey; deep++; break;
              default : label += c;
            }
            break;

          case kEscape1:
            label += c;
            state = kLabel;
            break;

          case kEscape2:
            key += c;
            state = kKey;
            break;

          case kEscape3:
            value += c;
            state = kValue;
            break;

          case kKey:
            assert(deep > 0);
            switch (c) {
              case '\\':
                state = kEscape2;
                break;

              case '[':
                deep++;
                key += c;
                break;

              case ':':
                if (deep == 1) {
                  state = kValue;
                } else {
                  key += c;
                }
                break;
              case ']':
                deep--;
                if (deep < 1) {
                  metadata[rmWhiteSpaces(key)] = "";
                  state = kLabel;
                  key = "";
                  value = "";
                } else {
                  key += c;
                }
                break;
              default : key += c;
            }
            break;

          case kValue:
            assert(deep > 0);
            switch (c) {
              case '\\':
                state = kEscape3;
                break;

              case '[':
                deep++;
                value += c;
                break;

              case ']':
                deep--;
                if (deep < 1) {
                  metadata[rmWhiteSpaces(key)] = rmWhiteSpaces(value);
                  state = kLabel;
                  key = "";
                  value = "";
                } else {
                  value += c;
                }
                break;
              default : value += c;
            }
            break;

          default:
            fprintf(stderr, "ERROR unrecognized state %d\n", state);
        }
      }
      label = rmWhiteSpaces(label);
    }

    /**
       Analyses the widget zone metadata declarations and takes appropriate actions.
    */
    void declare(FAUSTFLOAT* zone, const char* key, const char* value)
    {
      if (zone == 0) {
        // special zone 0 means group metadata
        if (strcmp(key, "tooltip") == 0) {
          // only group tooltip are currently implemented
          fGroupTooltip = formatTooltip(30, value);
        } else if (strcmp(key, "hidden") == 0) {
          fHiddenSet.insert(zone);
        }
      } else {
        if (strcmp(key, "size") == 0) {
          fGuiSize[zone] = atof(value);
        }
        else if (strcmp(key, "tooltip") == 0) {
          fTooltip[zone] = formatTooltip(30, value);
        }
        else if (strcmp(key, "unit") == 0) {
          fUnit[zone] = value;
        }
        else if (strcmp(key, "hidden") == 0) {
          fHiddenSet.insert(zone);
        }
        else if (strcmp(key, "scale") == 0) {
          if (strcmp(value, "log") == 0) {
            fLogSet.insert(zone);
          } else if (strcmp(value, "exp") == 0) {
            fExpSet.insert(zone);
          }
        }
        else if (strcmp(key, "style") == 0) {
          if (strcmp(value, "knob") == 0) {
            fKnobSet.insert(zone);
          } else if (strcmp(value, "led") == 0) {
            fLedSet.insert(zone);
          } else if (strcmp(value, "numerical") == 0) {
            fNumSet.insert(zone);
          } else {
            const char* p = value;
            if (parseWord(p, "radio")) {
              fRadioDescription[zone] = std::string(p);
            } else if (parseWord(p, "menu")) {
              fMenuDescription[zone] = std::string(p);
            }
          }
        }
      }
    }

};

#endif
/**************************  END  MetaDataUI.h **************************/
/************************** BEGIN ring-buffer.h **************************/
/*
  Copyright (C) 2000 Paul Davis
  Copyright (C) 2003 Rohan Drape
  Copyright (C) 2016 GRAME (renaming for internal use)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ISO/POSIX C version of Paul Davis's lock free ringbuffer C++ code.
  This is safe for the case of one read thread and one write thread.
*/

#ifndef __ring_buffer__
#define __ring_buffer__

#include <stdlib.h>
#include <string.h>

#ifdef WIN32
# pragma warning (disable: 4334)
#else
# pragma GCC diagnostic ignored "-Wunused-function"
#endif

typedef struct {
  char *buf;
  size_t len;
}
ringbuffer_data_t;

typedef struct {
  char *buf;
  volatile size_t write_ptr;
  volatile size_t read_ptr;
  size_t	size;
  size_t	size_mask;
  int	mlocked;
}
ringbuffer_t;

static ringbuffer_t *ringbuffer_create(size_t sz);
static void ringbuffer_free(ringbuffer_t *rb);
static void ringbuffer_get_read_vector(const ringbuffer_t *rb,
                                       ringbuffer_data_t *vec);
static void ringbuffer_get_write_vector(const ringbuffer_t *rb,
                                        ringbuffer_data_t *vec);
static size_t ringbuffer_read(ringbuffer_t *rb, char *dest, size_t cnt);
static size_t ringbuffer_peek(ringbuffer_t *rb, char *dest, size_t cnt);
static void ringbuffer_read_advance(ringbuffer_t *rb, size_t cnt);
static size_t ringbuffer_read_space(const ringbuffer_t *rb);
static int ringbuffer_mlock(ringbuffer_t *rb);
static void ringbuffer_reset(ringbuffer_t *rb);
static void ringbuffer_reset_size (ringbuffer_t * rb, size_t sz);
static size_t ringbuffer_write(ringbuffer_t *rb, const char *src,
                               size_t cnt);
static void ringbuffer_write_advance(ringbuffer_t *rb, size_t cnt);
static size_t ringbuffer_write_space(const ringbuffer_t *rb);

/* Create a new ringbuffer to hold at least `sz' bytes of data. The
   actual buffer size is rounded up to the next power of two. */

static ringbuffer_t *
ringbuffer_create (size_t sz)
{
  size_t power_of_two;
  ringbuffer_t *rb;

  if ((rb = (ringbuffer_t *) malloc (sizeof (ringbuffer_t))) == NULL) {
    return NULL;
  }

  for (power_of_two = 1u; 1u << power_of_two < sz; power_of_two++);

  rb->size = 1u << power_of_two;
  rb->size_mask = rb->size;
  rb->size_mask -= 1;
  rb->write_ptr = 0;
  rb->read_ptr = 0;
  if ((rb->buf = (char *) malloc (rb->size)) == NULL) {
    free (rb);
    return NULL;
  }
  rb->mlocked = 0;

  return rb;
}

/* Free all data associated with the ringbuffer `rb'. */

static void
ringbuffer_free (ringbuffer_t * rb)
{
#ifdef USE_MLOCK
  if (rb->mlocked) {
    munlock (rb->buf, rb->size);
  }
#endif /* USE_MLOCK */
  free (rb->buf);
  free (rb);
}

/* Lock the data block of `rb' using the system call 'mlock'.  */

static int
ringbuffer_mlock (ringbuffer_t * rb)
{
#ifdef USE_MLOCK
  if (mlock (rb->buf, rb->size)) {
    return -1;
  }
#endif /* USE_MLOCK */
  rb->mlocked = 1;
  return 0;
}

/* Reset the read and write pointers to zero. This is not thread
   safe. */

static void
ringbuffer_reset (ringbuffer_t * rb)
{
  rb->read_ptr = 0;
  rb->write_ptr = 0;
  memset(rb->buf, 0, rb->size);
}

/* Reset the read and write pointers to zero. This is not thread
   safe. */

static void
ringbuffer_reset_size (ringbuffer_t * rb, size_t sz)
{
  rb->size = sz;
  rb->size_mask = rb->size;
  rb->size_mask -= 1;
  rb->read_ptr = 0;
  rb->write_ptr = 0;
}

/* Return the number of bytes available for reading. This is the
   number of bytes in front of the read pointer and behind the write
   pointer.  */

static size_t
ringbuffer_read_space (const ringbuffer_t * rb)
{
  size_t w, r;

  w = rb->write_ptr;
  r = rb->read_ptr;

  if (w > r) {
    return w - r;
  } else {
    return (w - r + rb->size) & rb->size_mask;
  }
}

/* Return the number of bytes available for writing. This is the
   number of bytes in front of the write pointer and behind the read
   pointer.  */

static size_t
ringbuffer_write_space (const ringbuffer_t * rb)
{
  size_t w, r;

  w = rb->write_ptr;
  r = rb->read_ptr;

  if (w > r) {
    return ((r - w + rb->size) & rb->size_mask) - 1;
  } else if (w < r) {
    return (r - w) - 1;
  } else {
    return rb->size - 1;
  }
}

/* The copying data reader. Copy at most `cnt' bytes from `rb' to
   `dest'.  Returns the actual number of bytes copied. */

static size_t
ringbuffer_read (ringbuffer_t * rb, char *dest, size_t cnt)
{
  size_t free_cnt;
  size_t cnt2;
  size_t to_read;
  size_t n1, n2;

  if ((free_cnt = ringbuffer_read_space (rb)) == 0) {
    return 0;
  }

  to_read = cnt > free_cnt ? free_cnt : cnt;

  cnt2 = rb->read_ptr + to_read;

  if (cnt2 > rb->size) {
    n1 = rb->size - rb->read_ptr;
    n2 = cnt2 & rb->size_mask;
  } else {
    n1 = to_read;
    n2 = 0;
  }

  memcpy (dest, &(rb->buf[rb->read_ptr]), n1);
  rb->read_ptr = (rb->read_ptr + n1) & rb->size_mask;

  if (n2) {
    memcpy (dest + n1, &(rb->buf[rb->read_ptr]), n2);
    rb->read_ptr = (rb->read_ptr + n2) & rb->size_mask;
  }

  return to_read;
}

/* The copying data reader w/o read pointer advance. Copy at most
   `cnt' bytes from `rb' to `dest'.  Returns the actual number of bytes
   copied. */

static size_t
ringbuffer_peek (ringbuffer_t * rb, char *dest, size_t cnt)
{
  size_t free_cnt;
  size_t cnt2;
  size_t to_read;
  size_t n1, n2;
  size_t tmp_read_ptr;

  tmp_read_ptr = rb->read_ptr;

  if ((free_cnt = ringbuffer_read_space (rb)) == 0) {
    return 0;
  }

  to_read = cnt > free_cnt ? free_cnt : cnt;

  cnt2 = tmp_read_ptr + to_read;

  if (cnt2 > rb->size) {
    n1 = rb->size - tmp_read_ptr;
    n2 = cnt2 & rb->size_mask;
  } else {
    n1 = to_read;
    n2 = 0;
  }

  memcpy (dest, &(rb->buf[tmp_read_ptr]), n1);
  tmp_read_ptr = (tmp_read_ptr + n1) & rb->size_mask;

  if (n2) {
    memcpy (dest + n1, &(rb->buf[tmp_read_ptr]), n2);
  }

  return to_read;
}

/* The copying data writer. Copy at most `cnt' bytes to `rb' from
   `src'.  Returns the actual number of bytes copied. */

static size_t
ringbuffer_write (ringbuffer_t * rb, const char *src, size_t cnt)
{
  size_t free_cnt;
  size_t cnt2;
  size_t to_write;
  size_t n1, n2;

  if ((free_cnt = ringbuffer_write_space (rb)) == 0) {
    return 0;
  }

  to_write = cnt > free_cnt ? free_cnt : cnt;

  cnt2 = rb->write_ptr + to_write;

  if (cnt2 > rb->size) {
    n1 = rb->size - rb->write_ptr;
    n2 = cnt2 & rb->size_mask;
  } else {
    n1 = to_write;
    n2 = 0;
  }

  memcpy (&(rb->buf[rb->write_ptr]), src, n1);
  rb->write_ptr = (rb->write_ptr + n1) & rb->size_mask;

  if (n2) {
    memcpy (&(rb->buf[rb->write_ptr]), src + n1, n2);
    rb->write_ptr = (rb->write_ptr + n2) & rb->size_mask;
  }

  return to_write;
}

/* Advance the read pointer `cnt' places. */

static void
ringbuffer_read_advance (ringbuffer_t * rb, size_t cnt)
{
  size_t tmp = (rb->read_ptr + cnt) & rb->size_mask;
  rb->read_ptr = tmp;
}

/* Advance the write pointer `cnt' places. */

static void
ringbuffer_write_advance (ringbuffer_t * rb, size_t cnt)
{
  size_t tmp = (rb->write_ptr + cnt) & rb->size_mask;
  rb->write_ptr = tmp;
}

/* The non-copying data reader. `vec' is an array of two places. Set
   the values at `vec' to hold the current readable data at `rb'. If
   the readable data is in one segment the second segment has zero
   length. */

static void
ringbuffer_get_read_vector (const ringbuffer_t * rb,
                            ringbuffer_data_t * vec)
{
  size_t free_cnt;
  size_t cnt2;
  size_t w, r;

  w = rb->write_ptr;
  r = rb->read_ptr;

  if (w > r) {
    free_cnt = w - r;
  } else {
    free_cnt = (w - r + rb->size) & rb->size_mask;
  }

  cnt2 = r + free_cnt;

  if (cnt2 > rb->size) {

    /* Two part vector: the rest of the buffer after the current write
       ptr, plus some from the start of the buffer. */

    vec[0].buf = &(rb->buf[r]);
    vec[0].len = rb->size - r;
    vec[1].buf = rb->buf;
    vec[1].len = cnt2 & rb->size_mask;

  } else {

    /* Single part vector: just the rest of the buffer */

    vec[0].buf = &(rb->buf[r]);
    vec[0].len = free_cnt;
    vec[1].len = 0;
  }
}

/* The non-copying data writer. `vec' is an array of two places. Set
   the values at `vec' to hold the current writeable data at `rb'. If
   the writeable data is in one segment the second segment has zero
   length. */

static void
ringbuffer_get_write_vector (const ringbuffer_t * rb,
                             ringbuffer_data_t * vec)
{
  size_t free_cnt;
  size_t cnt2;
  size_t w, r;

  w = rb->write_ptr;
  r = rb->read_ptr;

  if (w > r) {
    free_cnt = ((r - w + rb->size) & rb->size_mask) - 1;
  } else if (w < r) {
    free_cnt = (r - w) - 1;
  } else {
    free_cnt = rb->size - 1;
  }

  cnt2 = w + free_cnt;

  if (cnt2 > rb->size) {

    /* Two part vector: the rest of the buffer after the current write
       ptr, plus some from the start of the buffer. */

    vec[0].buf = &(rb->buf[w]);
    vec[0].len = rb->size - w;
    vec[1].buf = rb->buf;
    vec[1].len = cnt2 & rb->size_mask;
  } else {
    vec[0].buf = &(rb->buf[w]);
    vec[0].len = free_cnt;
    vec[1].len = 0;
  }
}

#endif // __ring_buffer__
/**************************  END  ring-buffer.h **************************/

/*******************************************************************************
   GUI : Abstract Graphic User Interface
   Provides additional mechanisms to synchronize widgets and zones. Widgets
   should both reflect the value of a zone and allow to change this value.
 ******************************************************************************/

class uiItem;
class GUI;
struct clist;

typedef void (*uiCallback)(FAUSTFLOAT val, void* data);

/**
   Base class for uiTypedItem: memory zones that can be grouped and synchronized, using an internal cache.
*/
struct uiItemBase
{

  uiItemBase(GUI* ui, FAUSTFLOAT* zone)
  {
    assert(ui);
    assert(zone);
  }

  virtual ~uiItemBase()
  {}

  /**
     This method will be called when the value changes externally,
     and will signal the new value to all linked uItem
     when the value is different from the cached one.

     @param v - the new value
  */
  virtual void modifyZone(FAUSTFLOAT v) = 0;

  /**
     This method will be called when the value changes externally,
     and will signal the new value to all linked uItem
     when the value is different from the cached one.

     @param date - the timestamp of the received value in usec
     @param v - the new value
  */
  virtual void modifyZone(double date, FAUSTFLOAT v) {}

  /**
     This method is called by the synchronisation mecanism and is expected
     to 'reflect' the new value, by changing the Widget layout for instance,
     or sending a message (OSC, MIDI...)
  */
  virtual void reflectZone() = 0;

  /**
     Return the cached value.

     @return - the cached value
  */
  virtual double cache() = 0;

};

// Declared as 'static' to avoid code duplication at link time
static void deleteClist(clist* cl);

/**
   A list containing all groupe uiItemBase objects.
*/
struct clist : public std::list<uiItemBase*>
{

  virtual ~clist()
  {
    deleteClist(this);
  }

};

static void createUiCallbackItem(GUI* ui, FAUSTFLOAT* zone, uiCallback foo, void* data);

typedef std::map<FAUSTFLOAT*, clist*> zmap;

typedef std::map<FAUSTFLOAT*, ringbuffer_t*> ztimedmap;

class GUI : public UI
{

  private:

    static std::list<GUI*> fGuiList;
    zmap fZoneMap;
    bool fStopped;

  public:

    GUI(): fStopped(false)
    {
      fGuiList.push_back(this);
    }

    virtual ~GUI()
    {
      // delete all items
      for (const auto& it : fZoneMap) {
        delete it.second;
      }
      // suppress 'this' in static fGuiList
      fGuiList.remove(this);
    }

    // -- registerZone(z,c) : zone management

    void registerZone(FAUSTFLOAT* z, uiItemBase* c)
    {
      if (fZoneMap.find(z) == fZoneMap.end()) fZoneMap[z] = new clist();
      fZoneMap[z]->push_back(c);
    }

    void updateZone(FAUSTFLOAT* z)
    {
      FAUSTFLOAT v = *z;
      clist* cl = fZoneMap[z];
      for (const auto& c : *cl) {
        if (c->cache() != v) c->reflectZone();
      }
    }

    void updateAllZones()
    {
      for (const auto& m : fZoneMap) {
        updateZone(m.first);
      }
    }

    static void updateAllGuis()
    {
      for (const auto& g : fGuiList) {
        g->updateAllZones();
      }
    }

    void addCallback(FAUSTFLOAT* zone, uiCallback foo, void* data)
    {
      createUiCallbackItem(this, zone, foo, data);
    }

    // Start event or message processing
    virtual bool run() {
      return false;
    };
    // Stop event or message processing
    virtual void stop() {
      fStopped = true;
    }
    bool stopped() {
      return fStopped;
    }

    // -- widget's layouts

    virtual void openTabBox(const char* label) {};
    virtual void openHorizontalBox(const char* label) {}
    virtual void openVerticalBox(const char* label) {}
    virtual void closeBox() {}

    // -- active widgets

    virtual void addButton(const char* label, FAUSTFLOAT* zone) {}
    virtual void addCheckButton(const char* label, FAUSTFLOAT* zone) {}
    virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
    virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
    virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}

    // -- passive widgets

    virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}
    virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}

    // -- soundfiles

    virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) {}

    // -- metadata declarations

    virtual void declare(FAUSTFLOAT*, const char*, const char*) {}

    // Static global for timed zones, shared between all UI that will set timed values
    static ztimedmap gTimedZoneMap;

};

/**
   User Interface Item: abstract definition.
*/
template <typename REAL>
class uiTypedItemReal : public uiItemBase
{
  protected:

    GUI* fGUI;
    REAL* fZone;
    REAL fCache;

    uiTypedItemReal(GUI* ui, REAL* zone): uiItemBase(ui, static_cast<FAUSTFLOAT*>(zone)),
      fGUI(ui), fZone(zone), fCache(REAL(-123456.654321))
    {
      ui->registerZone(zone, this);
    }

  public:

    virtual ~uiTypedItemReal()
    {}

    void modifyZone(REAL v)
    {
      fCache = v;
      if (*fZone != v) {
        *fZone = v;
        fGUI->updateZone(fZone);
      }
    }

    double cache() {
      return fCache;
    }

};

class uiItem : public uiTypedItemReal<FAUSTFLOAT> {

  protected:

    uiItem(GUI* ui, FAUSTFLOAT* zone): uiTypedItemReal<FAUSTFLOAT>(ui, zone)
    {}

  public:

    virtual ~uiItem()
    {}

    void modifyZone(FAUSTFLOAT v)
    {
      fCache = v;
      if (*fZone != v) {
        *fZone = v;
        fGUI->updateZone(fZone);
      }
    }

};

/**
   Base class for items with a value converter.
*/
struct uiConverter {

  ValueConverter* fConverter;

  uiConverter(MetaDataUI::Scale scale, FAUSTFLOAT umin, FAUSTFLOAT umax, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
  {
    // Select appropriate converter according to scale mode
    if (scale == MetaDataUI::kLog) {
      fConverter = new LogValueConverter(umin, umax, fmin, fmax);
    } else if (scale == MetaDataUI::kExp) {
      fConverter = new ExpValueConverter(umin, umax, fmin, fmax);
    } else {
      fConverter = new LinearValueConverter(umin, umax, fmin, fmax);
    }
  }

  virtual ~uiConverter()
  {
    delete fConverter;
  }
};

/**
   User Interface item owned (and so deleted) by external code.
*/
class uiOwnedItem : public uiItem {

  protected:

    uiOwnedItem(GUI* ui, FAUSTFLOAT* zone): uiItem(ui, zone)
    {}

  public:

    virtual ~uiOwnedItem()
    {}

    virtual void reflectZone() {}
};

/**
   Callback Item.
*/
class uiCallbackItem : public uiItem {

  protected:

    uiCallback fCallback;
    void* fData;

  public:

    uiCallbackItem(GUI* ui, FAUSTFLOAT* zone, uiCallback foo, void* data)
      : uiItem(ui, zone), fCallback(foo), fData(data) {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      fCallback(v, fData);
    }
};

/**
    For timestamped control.
*/
struct DatedControl {

  double fDate;
  FAUSTFLOAT fValue;

  DatedControl(double d = 0., FAUSTFLOAT v = FAUSTFLOAT(0)): fDate(d), fValue(v) {}

};

/**
   Base class for timed items.
*/
class uiTimedItem : public uiItem
{

  protected:

    bool fDelete;

  public:

    using uiItem::modifyZone;

    uiTimedItem(GUI* ui, FAUSTFLOAT* zone): uiItem(ui, zone)
    {
      if (GUI::gTimedZoneMap.find(fZone) == GUI::gTimedZoneMap.end()) {
        GUI::gTimedZoneMap[fZone] = ringbuffer_create(8192);
        fDelete = true;
      } else {
        fDelete = false;
      }
    }

    virtual ~uiTimedItem()
    {
      ztimedmap::iterator it;
      if (fDelete && ((it = GUI::gTimedZoneMap.find(fZone)) != GUI::gTimedZoneMap.end())) {
        ringbuffer_free((*it).second);
        GUI::gTimedZoneMap.erase(it);
      }
    }

    virtual void modifyZone(double date, FAUSTFLOAT v)
    {
      size_t res;
      DatedControl dated_val(date, v);
      if ((res = ringbuffer_write(GUI::gTimedZoneMap[fZone], (const char*)&dated_val, sizeof(DatedControl))) != sizeof(DatedControl)) {
        fprintf(stderr, "ringbuffer_write error DatedControl\n");
      }
    }

};

/**
   Allows to group a set of zones.
*/
class uiGroupItem : public uiItem
{
  protected:

    std::vector<FAUSTFLOAT*> fZoneMap;

  public:

    uiGroupItem(GUI* ui, FAUSTFLOAT* zone): uiItem(ui, zone)
    {}
    virtual ~uiGroupItem()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;

      // Update all zones of the same group
      for (const auto& it : fZoneMap) {
        *it = v;
      }
    }

    void addZone(FAUSTFLOAT* zone) {
      fZoneMap.push_back(zone);
    }

};

// Cannot be defined as method in the classes.

static void createUiCallbackItem(GUI* ui, FAUSTFLOAT* zone, uiCallback foo, void* data)
{
  new uiCallbackItem(ui, zone, foo, data);
}

static void deleteClist(clist* cl)
{
  for (const auto& it : *cl) {
    // This specific code is only used in JUCE context. TODO: use proper 'shared_ptr' based memory management.
#if defined(JUCE_32BIT) || defined(JUCE_64BIT)
    uiOwnedItem* owned = dynamic_cast<uiOwnedItem*>(it);
    // owned items are deleted by external code
    if (!owned) {
      delete it;
    }
#else
    delete it;
#endif
  }
}

#endif
/**************************  END  GUI.h **************************/
/************************** BEGIN JSONUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef FAUST_JSONUI_H
#define FAUST_JSONUI_H

#include <vector>
#include <map>
#include <string>
#include <iomanip>
#include <sstream>
#include <algorithm>
#include <limits>


/*******************************************************************************
   JSONUI : Faust User Interface
   This class produce a complete JSON decription of the DSP instance.
 ******************************************************************************/

template <typename REAL>
class JSONUIReal : public PathBuilder, public Meta, public UIReal<REAL>
{

  protected:

    std::stringstream fUI;
    std::stringstream fMeta;
    std::vector<std::pair <std::string, std::string> > fMetaAux;
    std::string fVersion;           // Compiler version
    std::string fCompileOptions;    // Compilation options
    std::vector<std::string> fLibraryList;
    std::vector<std::string> fIncludePathnames;
    std::string fName;
    std::string fFileName;
    std::string fExpandedCode;
    std::string fSHAKey;
    int fDSPSize;                   // In bytes
    std::map<std::string, int> fPathTable;
    bool fExtended;

    char fCloseUIPar;
    char fCloseMetaPar;
    int fTab;

    int fInputs, fOutputs, fSRIndex;

    void tab(int n, std::ostream& fout)
    {
      fout << '\n';
      while (n-- > 0) {
        fout << '\t';
      }
    }

    std::string flatten(const std::string& src)
    {
      std::string dst;
      for (size_t i = 0; i < src.size(); i++) {
        switch (src[i]) {
          case '\n':
          case '\t':
            break;
          default:
            dst += src[i];
            break;
        }
      }
      return dst;
    }

    void addMeta(int tab_val, bool quote = true)
    {
      if (fMetaAux.size() > 0) {
        tab(tab_val, fUI); fUI << "\"meta\": [";
        std::string sep = "";
        for (size_t i = 0; i < fMetaAux.size(); i++) {
          fUI << sep;
          tab(tab_val + 1, fUI); fUI << "{ \"" << fMetaAux[i].first << "\": \"" << fMetaAux[i].second << "\" }";
          sep = ",";
        }
        tab(tab_val, fUI); fUI << ((quote) ? "]," : "]");
        fMetaAux.clear();
      }
    }

    int getAddressIndex(const std::string& path)
    {
      return (fPathTable.find(path) != fPathTable.end()) ? fPathTable[path] : -1;
    }

  public:

    JSONUIReal(const std::string& name,
               const std::string& filename,
               int inputs,
               int outputs,
               int sr_index,
               const std::string& sha_key,
               const std::string& dsp_code,
               const std::string& version,
               const std::string& compile_options,
               const std::vector<std::string>& library_list,
               const std::vector<std::string>& include_pathnames,
               int size,
               const std::map<std::string, int>& path_table)
    {
      init(name, filename, inputs, outputs, sr_index, sha_key, dsp_code, version, compile_options, library_list, include_pathnames, size, path_table);
    }

    JSONUIReal(const std::string& name, const std::string& filename, int inputs, int outputs)
    {
      init(name, filename, inputs, outputs, -1, "", "", "", "", std::vector<std::string>(), std::vector<std::string>(), -1, std::map<std::string, int>());
    }

    JSONUIReal(int inputs, int outputs)
    {
      init("", "", inputs, outputs, -1, "", "", "", "", std::vector<std::string>(), std::vector<std::string>(), -1, std::map<std::string, int>());
    }

    JSONUIReal()
    {
      init("", "", -1, -1, -1, "", "", "", "", std::vector<std::string>(), std::vector<std::string>(), -1, std::map<std::string, int>());
    }

    virtual ~JSONUIReal() {}

    void setInputs(int inputs) {
      fInputs = inputs;
    }
    void setOutputs(int outputs) {
      fOutputs = outputs;
    }

    void setSRIndex(int sr_index) {
      fSRIndex = sr_index;
    }

    // Init may be called multiple times so fMeta and fUI are reinitialized
    void init(const std::string& name,
              const std::string& filename,
              int inputs,
              int outputs,
              int sr_index,
              const std::string& sha_key,
              const std::string& dsp_code,
              const std::string& version,
              const std::string& compile_options,
              const std::vector<std::string>& library_list,
              const std::vector<std::string>& include_pathnames,
              int size,
              const std::map<std::string, int>& path_table,
              bool extended = false)
    {
      fTab = 1;
      fExtended = extended;
      if (fExtended) {
        fUI << std::setprecision(std::numeric_limits<REAL>::max_digits10);
        fMeta << std::setprecision(std::numeric_limits<REAL>::max_digits10);
      }

      // Start Meta generation
      fMeta.str("");
      tab(fTab, fMeta); fMeta << "\"meta\": [";
      fCloseMetaPar = ' ';

      // Start UI generation
      fUI.str("");
      tab(fTab, fUI); fUI << "\"ui\": [";
      fCloseUIPar = ' ';
      fTab += 1;

      fName = name;
      fFileName = filename;
      fInputs = inputs;
      fOutputs = outputs;
      fSRIndex = sr_index;
      fExpandedCode = dsp_code;
      fSHAKey = sha_key;
      fDSPSize = size;
      fPathTable = path_table;
      fVersion = version;
      fCompileOptions = compile_options;
      fLibraryList = library_list;
      fIncludePathnames = include_pathnames;
    }

    // -- widget's layouts

    virtual void openGenericGroup(const char* label, const char* name)
    {
      pushLabel(label);
      fUI << fCloseUIPar;
      tab(fTab, fUI); fUI << "{";
      fTab += 1;
      tab(fTab, fUI); fUI << "\"type\": \"" << name << "\",";
      tab(fTab, fUI); fUI << "\"label\": \"" << label << "\",";
      addMeta(fTab);
      tab(fTab, fUI); fUI << "\"items\": [";
      fCloseUIPar = ' ';
      fTab += 1;
    }

    virtual void openTabBox(const char* label)
    {
      openGenericGroup(label, "tgroup");
    }

    virtual void openHorizontalBox(const char* label)
    {
      openGenericGroup(label, "hgroup");
    }

    virtual void openVerticalBox(const char* label)
    {
      openGenericGroup(label, "vgroup");
    }

    virtual void closeBox()
    {
      popLabel();
      fTab -= 1;
      tab(fTab, fUI); fUI << "]";
      fTab -= 1;
      tab(fTab, fUI); fUI << "}";
      fCloseUIPar = ',';
    }

    // -- active widgets

    virtual void addGenericButton(const char* label, const char* name)
    {
      std::string path = buildPath(label);

      fUI << fCloseUIPar;
      tab(fTab, fUI); fUI << "{";
      fTab += 1;
      tab(fTab, fUI); fUI << "\"type\": \"" << name << "\",";
      tab(fTab, fUI); fUI << "\"label\": \"" << label << "\",";
      if (fPathTable.size() > 0) {
        tab(fTab, fUI); fUI << "\"address\": \"" << path << "\",";
        tab(fTab, fUI); fUI << "\"index\": " << getAddressIndex(path) << ((fMetaAux.size() > 0) ? "," : "");
      } else {
        tab(fTab, fUI); fUI << "\"address\": \"" << path << "\"" << ((fMetaAux.size() > 0) ? "," : "");
      }
      addMeta(fTab, false);
      fTab -= 1;
      tab(fTab, fUI); fUI << "}";
      fCloseUIPar = ',';
    }

    virtual void addButton(const char* label, REAL* zone)
    {
      addGenericButton(label, "button");
    }

    virtual void addCheckButton(const char* label, REAL* zone)
    {
      addGenericButton(label, "checkbox");
    }

    virtual void addGenericEntry(const char* label, const char* name, REAL init, REAL min, REAL max, REAL step)
    {
      std::string path = buildPath(label);

      fUI << fCloseUIPar;
      tab(fTab, fUI); fUI << "{";
      fTab += 1;
      tab(fTab, fUI); fUI << "\"type\": \"" << name << "\",";
      tab(fTab, fUI); fUI << "\"label\": \"" << label << "\",";
      tab(fTab, fUI); fUI << "\"address\": \"" << path << "\",";
      if (fPathTable.size() > 0) {
        tab(fTab, fUI); fUI << "\"index\": " << getAddressIndex(path) << ",";
      }
      addMeta(fTab);
      tab(fTab, fUI); fUI << "\"init\": " << init << ",";
      tab(fTab, fUI); fUI << "\"min\": " << min << ",";
      tab(fTab, fUI); fUI << "\"max\": " << max << ",";
      tab(fTab, fUI); fUI << "\"step\": " << step;
      fTab -= 1;
      tab(fTab, fUI); fUI << "}";
      fCloseUIPar = ',';
    }

    virtual void addVerticalSlider(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step)
    {
      addGenericEntry(label, "vslider", init, min, max, step);
    }

    virtual void addHorizontalSlider(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step)
    {
      addGenericEntry(label, "hslider", init, min, max, step);
    }

    virtual void addNumEntry(const char* label, REAL* zone, REAL init, REAL min, REAL max, REAL step)
    {
      addGenericEntry(label, "nentry", init, min, max, step);
    }

    // -- passive widgets

    virtual void addGenericBargraph(const char* label, const char* name, REAL min, REAL max)
    {
      std::string path = buildPath(label);

      fUI << fCloseUIPar;
      tab(fTab, fUI); fUI << "{";
      fTab += 1;
      tab(fTab, fUI); fUI << "\"type\": \"" << name << "\",";
      tab(fTab, fUI); fUI << "\"label\": \"" << label << "\",";
      tab(fTab, fUI); fUI << "\"address\": \"" << path << "\",";
      if (fPathTable.size() > 0) {
        tab(fTab, fUI); fUI << "\"index\": " << getAddressIndex(path) << ",";
      }
      addMeta(fTab);
      tab(fTab, fUI); fUI << "\"min\": " << min << ",";
      tab(fTab, fUI); fUI << "\"max\": " << max;
      fTab -= 1;
      tab(fTab, fUI); fUI << "}";
      fCloseUIPar = ',';
    }

    virtual void addHorizontalBargraph(const char* label, REAL* zone, REAL min, REAL max)
    {
      addGenericBargraph(label, "hbargraph", min, max);
    }

    virtual void addVerticalBargraph(const char* label, REAL* zone, REAL min, REAL max)
    {
      addGenericBargraph(label, "vbargraph", min, max);
    }

    virtual void addSoundfile(const char* label, const char* url, Soundfile** zone)
    {
      std::string path = buildPath(label);

      fUI << fCloseUIPar;
      tab(fTab, fUI); fUI << "{";
      fTab += 1;
      tab(fTab, fUI); fUI << "\"type\": \"" << "soundfile" << "\",";
      tab(fTab, fUI); fUI << "\"label\": \"" << label << "\"" << ",";
      tab(fTab, fUI); fUI << "\"url\": \"" << url << "\"" << ",";
      tab(fTab, fUI); fUI << "\"address\": \"" << path << "\"" << ((fPathTable.size() > 0) ? "," : "");
      if (fPathTable.size() > 0) {
        tab(fTab, fUI); fUI << "\"index\": " << getAddressIndex(path);
      }
      fTab -= 1;
      tab(fTab, fUI); fUI << "}";
      fCloseUIPar = ',';
    }

    // -- metadata declarations

    virtual void declare(REAL* zone, const char* key, const char* val)
    {
      fMetaAux.push_back(std::make_pair(key, val));
    }

    // Meta interface
    virtual void declare(const char* key, const char* value)
    {
      fMeta << fCloseMetaPar;
      // fName found in metadata
      if ((strcmp(key, "name") == 0) && (fName == "")) fName = value;
      // fFileName found in metadata
      if ((strcmp(key, "filename") == 0) && (fFileName == "")) fFileName = value;
      tab(fTab, fMeta); fMeta << "{ " << "\"" << key << "\"" << ": " << "\"" << value << "\" }";
      fCloseMetaPar = ',';
    }

    std::string JSON(bool flat = false)
    {
      fTab = 0;
      std::stringstream JSON;
      if (fExtended) {
        JSON << std::setprecision(std::numeric_limits<REAL>::max_digits10);
      }
      JSON << "{";
      fTab += 1;
      tab(fTab, JSON); JSON << "\"name\": \"" << fName << "\",";
      tab(fTab, JSON); JSON << "\"filename\": \"" << fFileName << "\",";
      if (fVersion != "") {
        tab(fTab, JSON);
        JSON << "\"version\": \"" << fVersion << "\",";
      }
      if (fCompileOptions != "") {
        tab(fTab, JSON);
        JSON << "\"compile_options\": \"" <<  fCompileOptions << "\",";
      }
      if (fLibraryList.size() > 0) {
        tab(fTab, JSON);
        JSON << "\"library_list\": [";
        for (size_t i = 0; i < fLibraryList.size(); i++) {
          JSON << "\"" << fLibraryList[i] << "\"";
          if (i < (fLibraryList.size() - 1)) JSON << ",";
        }
        JSON << "],";
      }
      if (fIncludePathnames.size() > 0) {
        tab(fTab, JSON);
        JSON << "\"include_pathnames\": [";
        for (size_t i = 0; i < fIncludePathnames.size(); i++) {
          JSON << "\"" << fIncludePathnames[i] << "\"";
          if (i < (fIncludePathnames.size() - 1)) JSON << ",";
        }
        JSON << "],";
      }
      if (fDSPSize != -1) {
        tab(fTab, JSON);
        JSON << "\"size\": " << fDSPSize << ",";
      }
      if (fSHAKey != "") {
        tab(fTab, JSON);
        JSON << "\"sha_key\": \"" << fSHAKey << "\",";
      }
      if (fExpandedCode != "") {
        tab(fTab, JSON);
        JSON << "\"code\": \"" << fExpandedCode << "\",";
      }
      tab(fTab, JSON); JSON << "\"inputs\": " << fInputs << ",";
      tab(fTab, JSON); JSON << "\"outputs\": " << fOutputs << ",";
      if (fSRIndex != -1) {
        tab(fTab, JSON);
        JSON << "\"sr_index\": " << fSRIndex << ",";
      }
      tab(fTab, fMeta); fMeta << "],";
      tab(fTab, fUI); fUI << "]";
      fTab -= 1;
      if (fCloseMetaPar == ',') { // If "declare" has been called, fCloseMetaPar state is now ','
        JSON << fMeta.str() << fUI.str();
      } else {
        JSON << fUI.str();
      }
      tab(fTab, JSON); JSON << "}";
      return (flat) ? flatten(JSON.str()) : JSON.str();
    }

};

// Externally available class using FAUSTFLOAT

struct JSONUI : public JSONUIReal<FAUSTFLOAT>, public UI
{

  JSONUI(const std::string& name,
         const std::string& filename,
         int inputs,
         int outputs,
         int sr_index,
         const std::string& sha_key,
         const std::string& dsp_code,
         const std::string& version,
         const std::string& compile_options,
         const std::vector<std::string>& library_list,
         const std::vector<std::string>& include_pathnames,
         int size,
         const std::map<std::string, int>& path_table):
    JSONUIReal<FAUSTFLOAT>(name, filename,
                           inputs, outputs,
                           sr_index,
                           sha_key, dsp_code,
                           version, compile_options,
                           library_list, include_pathnames,
                           size, path_table)
  {}

  JSONUI(const std::string& name, const std::string& filename, int inputs, int outputs):
    JSONUIReal<FAUSTFLOAT>(name, filename, inputs, outputs)
  {}

  JSONUI(int inputs, int outputs): JSONUIReal<FAUSTFLOAT>(inputs, outputs)
  {}

  JSONUI(): JSONUIReal<FAUSTFLOAT>()
  {}

  virtual void openTabBox(const char* label)
  {
    JSONUIReal<FAUSTFLOAT>::openTabBox(label);
  }
  virtual void openHorizontalBox(const char* label)
  {
    JSONUIReal<FAUSTFLOAT>::openHorizontalBox(label);
  }
  virtual void openVerticalBox(const char* label)
  {
    JSONUIReal<FAUSTFLOAT>::openVerticalBox(label);
  }
  virtual void closeBox()
  {
    JSONUIReal<FAUSTFLOAT>::closeBox();
  }

  // -- active widgets

  virtual void addButton(const char* label, FAUSTFLOAT* zone)
  {
    JSONUIReal<FAUSTFLOAT>::addButton(label, zone);
  }
  virtual void addCheckButton(const char* label, FAUSTFLOAT* zone)
  {
    JSONUIReal<FAUSTFLOAT>::addCheckButton(label, zone);
  }
  virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
  {
    JSONUIReal<FAUSTFLOAT>::addVerticalSlider(label, zone, init, min, max, step);
  }
  virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
  {
    JSONUIReal<FAUSTFLOAT>::addHorizontalSlider(label, zone, init, min, max, step);
  }
  virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
  {
    JSONUIReal<FAUSTFLOAT>::addNumEntry(label, zone, init, min, max, step);
  }

  // -- passive widgets

  virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
  {
    JSONUIReal<FAUSTFLOAT>::addHorizontalBargraph(label, zone, min, max);
  }
  virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
  {
    JSONUIReal<FAUSTFLOAT>::addVerticalBargraph(label, zone, min, max);
  }

  // -- soundfiles

  virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone)
  {
    JSONUIReal<FAUSTFLOAT>::addSoundfile(label, filename, sf_zone);
  }

  // -- metadata declarations

  virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
  {
    JSONUIReal<FAUSTFLOAT>::declare(zone, key, val);
  }

  virtual void declare(const char* key, const char* val)
  {
    JSONUIReal<FAUSTFLOAT>::declare(key, val);
  }

  virtual ~JSONUI() {}

};

#endif // FAUST_JSONUI_H
/**************************  END  JSONUI.h **************************/
/************************** BEGIN midi.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __midi__
#define __midi__

#include <vector>
#include <string>
#include <algorithm>
#include <assert.h>

class MapUI;

/**
   A timestamped short MIDI message used with SOUL.
*/

// Force contiguous memory layout
#pragma pack (push, 1)
struct MIDIMessage
{
  uint32_t frameIndex;
  uint8_t byte0, byte1, byte2;
};
#pragma pack (pop)

/**
   For timestamped MIDI messages.
*/
struct DatedMessage {

  double fDate;
  unsigned char fBuffer[3];
  size_t fSize;

  DatedMessage(double date, unsigned char* buffer, size_t size)
    : fDate(date), fSize(size)
  {
    assert(size <= 3);
    memcpy(fBuffer, buffer, size);
  }

  DatedMessage(): fDate(0.0), fSize(0)
  {}

};

/**
   MIDI processor definition.

   MIDI input or output handling classes will implement this interface,
   so the same method names (keyOn, keyOff, ctrlChange...) will be used either
   when decoding MIDI input or encoding MIDI output events.
   MIDI channel is numbered in [0..15] in this layer.
*/
class midi {

  public:

    midi() {}
    virtual ~midi() {}

    // Additional time-stamped API for MIDI input
    virtual MapUI* keyOn(double, int channel, int pitch, int velocity)
    {
      return keyOn(channel, pitch, velocity);
    }

    virtual void keyOff(double, int channel, int pitch, int velocity = 0)
    {
      keyOff(channel, pitch, velocity);
    }

    virtual void keyPress(double, int channel, int pitch, int press)
    {
      keyPress(channel, pitch, press);
    }

    virtual void chanPress(double date, int channel, int press)
    {
      chanPress(channel, press);
    }

    virtual void pitchWheel(double, int channel, int wheel)
    {
      pitchWheel(channel, wheel);
    }

    virtual void ctrlChange(double, int channel, int ctrl, int value)
    {
      ctrlChange(channel, ctrl, value);
    }

    virtual void ctrlChange14bits(double, int channel, int ctrl, int value)
    {
      ctrlChange14bits(channel, ctrl, value);
    }

    virtual void rpn(double, int channel, int ctrl, int value)
    {
      rpn(channel, ctrl, value);
    }

    virtual void progChange(double, int channel, int pgm)
    {
      progChange(channel, pgm);
    }

    virtual void sysEx(double, std::vector<unsigned char>& message)
    {
      sysEx(message);
    }

    // MIDI sync
    virtual void startSync(double date)  {}
    virtual void stopSync(double date)   {}
    virtual void clock(double date)  {}

    // Standard MIDI API
    virtual MapUI* keyOn(int channel, int pitch, int velocity)      {
      return nullptr;
    }
    virtual void keyOff(int channel, int pitch, int velocity)       {}
    virtual void keyPress(int channel, int pitch, int press)        {}
    virtual void chanPress(int channel, int press)                  {}
    virtual void ctrlChange(int channel, int ctrl, int value)       {}
    virtual void ctrlChange14bits(int channel, int ctrl, int value) {}
    virtual void rpn(int channel, int ctrl, int value)              {}
    virtual void pitchWheel(int channel, int wheel)                 {}
    virtual void progChange(int channel, int pgm)                   {}
    virtual void sysEx(std::vector<unsigned char>& message)         {}

    enum MidiStatus {
      // channel voice messages
      MIDI_NOTE_OFF = 0x80,
      MIDI_NOTE_ON = 0x90,
      MIDI_CONTROL_CHANGE = 0xB0,
      MIDI_PROGRAM_CHANGE = 0xC0,
      MIDI_PITCH_BEND = 0xE0,
      MIDI_AFTERTOUCH = 0xD0,         // aka channel pressure
      MIDI_POLY_AFTERTOUCH = 0xA0,    // aka key pressure
      MIDI_CLOCK = 0xF8,
      MIDI_START = 0xFA,
      MIDI_CONT = 0xFB,
      MIDI_STOP = 0xFC,
      MIDI_SYSEX_START = 0xF0,
      MIDI_SYSEX_STOP = 0xF7
    };

    enum MidiCtrl {
      ALL_NOTES_OFF = 123,
      ALL_SOUND_OFF = 120
    };

    enum MidiNPN {
      PITCH_BEND_RANGE = 0
    };

};

/**
   A class to decode NRPN and RPN messages, adapted from JUCE forum message:
   https://forum.juce.com/t/14bit-midi-controller-support/11517
*/
class MidiNRPN {

  private:

    bool ctrlnew;
    int ctrlnum;
    int ctrlval;

    int nrpn_lsb, nrpn_msb;
    int data_lsb, data_msb;

    enum
    {
      midi_nrpn_lsb = 98,
      midi_nrpn_msb = 99,
      midi_rpn_lsb  = 100,
      midi_rpn_msb  = 101,
      midi_data_lsb = 38,
      midi_data_msb = 6
    };

  public:

    MidiNRPN(): ctrlnew(false), nrpn_lsb(-1), nrpn_msb(-1), data_lsb(-1), data_msb(-1)
    {}

    // return true if the message has been filtered
    bool process(int data1, int data2)
    {
      switch (data1)
      {
        case midi_nrpn_lsb: nrpn_lsb = data2; return true;
        case midi_nrpn_msb: nrpn_msb = data2; return true;
        case midi_rpn_lsb: {
            if (data2 == 127) {
              nrpn_lsb = data_lsb = -1;
            } else {
              nrpn_lsb = 0;
              data_lsb = -1;
            }
            return true;
          }
        case midi_rpn_msb: {
            if (data2 == 127) {
              nrpn_msb = data_msb = -1;
            } else {
              nrpn_msb = 0;
              data_msb = -1;
            }
            return true;
          }
        case midi_data_lsb:
        case midi_data_msb:
          {
            if (data1 == midi_data_msb) {
              if (nrpn_msb < 0) {
                return false;
              }
              data_msb = data2;
            } else { // midi_data_lsb
              if (nrpn_lsb < 0) {
                return false;
              }
              data_lsb = data2;
            }
            if (data_lsb >= 0 && data_msb >= 0) {
              ctrlnum = (nrpn_msb << 7) | nrpn_lsb;
              ctrlval = (data_msb << 7) | data_lsb;
              data_lsb = data_msb = -1;
              nrpn_msb = nrpn_lsb = -1;
              ctrlnew = true;
            }
            return true;
          }
        default: return false;
      };
    }

    bool hasNewNRPN() {
      bool res = ctrlnew;
      ctrlnew = false;
      return res;
    }

    // results in [0, 16383]
    int getCtrl() const {
      return ctrlnum;
    }
    int getVal() const {
      return ctrlval;
    }

};

/**
   A pure interface for MIDI handlers that can send/receive MIDI messages to/from 'midi' objects.
*/
struct midi_interface {
  virtual void addMidiIn(midi* midi_dsp)      = 0;
  virtual void removeMidiIn(midi* midi_dsp)   = 0;
  virtual ~midi_interface() {}
};

/****************************************************
   Base class for MIDI input handling.

   Shared common code used for input handling:
   - decoding Real-Time messages: handleSync
   - decoding one data byte messages: handleData1
   - decoding two data byte messages: handleData2
   - getting ready messages in polling mode
 ****************************************************/
class midi_handler : public midi, public midi_interface {

  protected:

    std::vector<midi*> fMidiInputs;
    std::string fName;
    MidiNRPN fNRPN;

    int range(int min, int max, int val) {
      return (val < min) ? min : ((val >= max) ? max : val);
    }

  public:

    midi_handler(const std::string& name = "MIDIHandler"): midi_interface(), fName(name) {}
    virtual ~midi_handler() {}

    void addMidiIn(midi* midi_dsp) {
      if (midi_dsp) fMidiInputs.push_back(midi_dsp);
    }
    void removeMidiIn(midi* midi_dsp)
    {
      std::vector<midi*>::iterator it = std::find(fMidiInputs.begin(), fMidiInputs.end(), midi_dsp);
      if (it != fMidiInputs.end()) {
        fMidiInputs.erase(it);
      }
    }

    // Those 2 methods have to be implemented by subclasses
    virtual bool startMidi() {
      return true;
    }
    virtual void stopMidi() {}

    void setName(const std::string& name) {
      fName = name;
    }
    std::string getName() {
      return fName;
    }

    // To be used in polling mode
    virtual int recvMessages(std::vector<MIDIMessage>* message) {
      return 0;
    }
    virtual void sendMessages(std::vector<MIDIMessage>* message, int count) {}

    // MIDI Real-Time
    void handleClock(double time)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->clock(time);
      }
    }

    void handleStart(double time)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->startSync(time);
      }
    }

    void handleStop(double time)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->stopSync(time);
      }
    }

    void handleSync(double time, int type)
    {
      if (type == MIDI_CLOCK) {
        handleClock(time);
        // We can consider start and continue as identical messages
      } else if ((type == MIDI_START) || (type == MIDI_CONT)) {
        handleStart(time);
      } else if (type == MIDI_STOP) {
        handleStop(time);
      }
    }

    // MIDI 1 data
    void handleProgChange(double time, int channel, int data1)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->progChange(time, channel, data1);
      }
    }

    void handleAfterTouch(double time, int channel, int data1)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->chanPress(time, channel, data1);
      }
    }

    void handleData1(double time, int type, int channel, int data1)
    {
      if (type == MIDI_PROGRAM_CHANGE) {
        handleProgChange(time, channel, data1);
      } else if (type == MIDI_AFTERTOUCH) {
        handleAfterTouch(time, channel, data1);
      }
    }

    // MIDI 2 datas
    void handleKeyOff(double time, int channel, int data1, int data2)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->keyOff(time, channel, data1, data2);
      }
    }

    void handleKeyOn(double time, int channel, int data1, int data2)
    {
      if (data2 == 0) {
        handleKeyOff(time, channel, data1, data2);
      } else {
        for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
          fMidiInputs[i]->keyOn(time, channel, data1, data2);
        }
      }
    }

    void handleCtrlChange(double time, int channel, int data1, int data2)
    {
      // Special processing for NRPN and RPN
      if (fNRPN.process(data1, data2)) {
        if (fNRPN.hasNewNRPN()) {
          for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
            fMidiInputs[i]->rpn(time, channel, fNRPN.getCtrl(), fNRPN.getVal());
          }
        }
      } else {
        for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
          fMidiInputs[i]->ctrlChange(time, channel, data1, data2);
        }
      }
    }

    void handlePitchWheel(double time, int channel, int data1, int data2)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->pitchWheel(time, channel, (data2 << 7) + data1);
      }
    }

    void handlePitchWheel(double time, int channel, int bend)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->pitchWheel(time, channel, bend);
      }
    }

    void handlePolyAfterTouch(double time, int channel, int data1, int data2)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->keyPress(time, channel, data1, data2);
      }
    }

    void handleData2(double time, int type, int channel, int data1, int data2)
    {
      if (type == MIDI_NOTE_OFF) {
        handleKeyOff(time, channel,  data1, data2);
      } else if (type == MIDI_NOTE_ON) {
        handleKeyOn(time, channel, data1, data2);
      } else if (type == MIDI_CONTROL_CHANGE) {
        handleCtrlChange(time, channel, data1, data2);
      } else if (type == MIDI_PITCH_BEND) {
        handlePitchWheel(time, channel, data1, data2);
      } else if (type == MIDI_POLY_AFTERTOUCH) {
        handlePolyAfterTouch(time, channel, data1, data2);
      }
    }

    // SysEx
    void handleSysex(double time, std::vector<unsigned char>& message)
    {
      for (unsigned int i = 0; i < fMidiInputs.size(); i++) {
        fMidiInputs[i]->sysEx(time, message);
      }
    }

    void handleMessage(double time, int type, std::vector<unsigned char>& message)
    {
      if (type == MIDI_SYSEX_START) {
        handleSysex(time, message);
      }
    }

};

#endif // __midi__
/**************************  END  midi.h **************************/

#ifdef _MSC_VER
#define gsscanf sscanf_s
#else
#define gsscanf sscanf
#endif

/**
   Helper code for MIDI meta and polyphonic 'nvoices' parsing.
*/
struct MidiMeta : public Meta, public std::map<std::string, std::string> {

  void declare(const char* key, const char* value)
  {
    (*this)[key] = value;
  }

  const std::string get(const char* key, const char* def)
  {
    return (this->find(key) != this->end()) ? (*this)[key] : def;
  }

  static void analyse(dsp* mono_dsp, bool& midi_sync, int& nvoices)
  {
    JSONUI jsonui;
    mono_dsp->buildUserInterface(&jsonui);
    std::string json = jsonui.JSON();
    midi_sync = ((json.find("midi") != std::string::npos) &&
                 ((json.find("start") != std::string::npos) ||
                  (json.find("stop") != std::string::npos) ||
                  (json.find("clock") != std::string::npos) ||
                  (json.find("timestamp") != std::string::npos)));

#if defined(NVOICES) && NVOICES!=NUM_VOICES
    nvoices = NVOICES;
#else
    MidiMeta meta;
    mono_dsp->metadata(&meta);
    bool found_voices = false;
    // If "options" metadata is used
    std::string options = meta.get("options", "");
    if (options != "") {
      std::map<std::string, std::string> metadata;
      std::string res;
      MetaDataUI::extractMetadata(options, res, metadata);
      if (metadata.find("nvoices") != metadata.end()) {
        nvoices = std::atoi(metadata["nvoices"].c_str());
        found_voices = true;
      }
    }
    // Otherwise test for "nvoices" metadata
    if (!found_voices) {
      std::string numVoices = meta.get("nvoices", "0");
      nvoices = std::atoi(numVoices.c_str());
    }
    nvoices = std::max<int>(0, nvoices);
#endif
  }

  static bool checkPolyphony(dsp* mono_dsp)
  {
    MapUI map_ui;
    mono_dsp->buildUserInterface(&map_ui);
    bool has_freq = false;
    bool has_gate = false;
    bool has_gain = false;
    for (int i = 0; i < map_ui.getParamsCount(); i++) {
      std::string path = map_ui.getParamAddress(i);
      has_freq |= MapUI::endsWith(path, "/freq");
      has_gate |= MapUI::endsWith(path, "/gate");
      has_gain |= MapUI::endsWith(path, "/gain");
    }
    return (has_freq && has_gate && has_gain);
  }

};

/**
   uiMidi : Faust User Interface
   This class decodes MIDI meta data and maps incoming MIDI messages to them.
   Currently ctrlChange, keyOn/keyOff, keyPress, progChange, chanPress, pitchWheel/pitchBend
   start/stop/clock meta data is handled.
   MIDI channel is numbered in [1..16] in this layer.
   Channel 0 means "all channels" when receiving or sending.
*/
class uiMidi {

    friend class MidiUI;

  protected:

    midi* fMidiOut;
    bool fInputCtrl;
    int fChan;

    bool inRange(FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT v) {
      return (min <= v && v <= max);
    }

  public:

    uiMidi(midi* midi_out, bool input, int chan = 0): fMidiOut(midi_out), fInputCtrl(input), fChan(chan)
    {}
    virtual ~uiMidi()
    {}

};

/**
   Base class for MIDI aware UI items.
*/
class uiMidiItem : public uiMidi, public uiItem {

  public:

    uiMidiItem(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true, int chan = 0)
      : uiMidi(midi_out, input, chan), uiItem(ui, zone)
    {}
    virtual ~uiMidiItem()
    {}

    virtual void reflectZone() {}

};

/**
   Base class for MIDI aware UI items with timestamp support.
*/
class uiMidiTimedItem : public uiMidi, public uiTimedItem {

  public:

    uiMidiTimedItem(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true, int chan = 0)
      : uiMidi(midi_out, input, chan), uiTimedItem(ui, zone)
    {}
    virtual ~uiMidiTimedItem()
    {}

    virtual void reflectZone() {}

};

/**
   MIDI sync.
*/
class uiMidiStart : public uiMidiTimedItem
{

  public:

    uiMidiStart(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
      : uiMidiTimedItem(midi_out, ui, zone, input)
    {}
    virtual ~uiMidiStart()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (v != FAUSTFLOAT(0)) {
        fMidiOut->startSync(0);
      }
    }
    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(v));
      }
    }

};

class uiMidiStop : public uiMidiTimedItem {

  public:

    uiMidiStop(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
      : uiMidiTimedItem(midi_out, ui, zone, input)
    {}
    virtual ~uiMidiStop()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (v != FAUSTFLOAT(1)) {
        fMidiOut->stopSync(0);
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(v));
      }
    }
};

class uiMidiClock : public uiMidiTimedItem {

  private:

    bool fState;

  public:

    uiMidiClock(midi* midi_out, GUI* ui, FAUSTFLOAT* zone, bool input = true)
      : uiMidiTimedItem(midi_out, ui, zone, input), fState(false)
    {}
    virtual ~uiMidiClock()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      fMidiOut->clock(0);
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        fState = !fState;
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fState));
      }
    }

};

/**
   Standard MIDI events.
*/

/**
   uiMidiProgChange uses the [min...max] range.
*/
class uiMidiProgChange : public uiMidiTimedItem {

  public:

    FAUSTFLOAT fMin, fMax;

    uiMidiProgChange(midi* midi_out, GUI* ui, FAUSTFLOAT* zone,
                     FAUSTFLOAT min, FAUSTFLOAT max,
                     bool input = true, int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), fMin(min), fMax(max)
    {}
    virtual ~uiMidiProgChange()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (inRange(fMin, fMax, v)) {
        if (fChan == 0) {
          // Send on [0..15] channels on the MIDI layer
          for (int chan = 0; chan < 16; chan++) {
            fMidiOut->progChange(chan, v);
          }
        } else {
          fMidiOut->progChange(fChan - 1, v);
        }
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl && inRange(fMin, fMax, v)) {
        uiItem::modifyZone(v);
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl && inRange(fMin, fMax, v)) {
        uiMidiTimedItem::modifyZone(date, v);
      }
    }

};

/**
   uiMidiChanPress.
*/
class uiMidiChanPress : public uiMidiTimedItem, public uiConverter {

  public:

    uiMidiChanPress(midi* midi_out, GUI* ui,
                    FAUSTFLOAT* zone,
                    FAUSTFLOAT min, FAUSTFLOAT max,
                    bool input = true,
                    MetaDataUI::Scale scale = MetaDataUI::kLin,
                    int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), uiConverter(scale, 0., 127., min, max)
    {}
    virtual ~uiMidiChanPress()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->chanPress(chan, fConverter->faust2ui(v));
        }
      } else {
        fMidiOut->chanPress(fChan - 1, fConverter->faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

};

/**
   uiMidiCtrlChange does scale (kLin/kLog/kExp) mapping.
*/
class uiMidiCtrlChange : public uiMidiTimedItem, public uiConverter {

  private:

    int fCtrl;

  public:

    uiMidiCtrlChange(midi* midi_out, int ctrl, GUI* ui,
                     FAUSTFLOAT* zone,
                     FAUSTFLOAT min, FAUSTFLOAT max,
                     bool input = true,
                     MetaDataUI::Scale scale = MetaDataUI::kLin,
                     int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), uiConverter(scale, 0., 127., min, max), fCtrl(ctrl)
    {}
    virtual ~uiMidiCtrlChange()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->ctrlChange(chan, fCtrl, fConverter->faust2ui(v));
        }
      } else {
        fMidiOut->ctrlChange(fChan - 1, fCtrl, fConverter->faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }
};

class uiMidiPitchWheel : public uiMidiTimedItem {

  private:

    LinearValueConverter2 fConverter;

  public:

    uiMidiPitchWheel(midi* midi_out, GUI* ui, FAUSTFLOAT* zone,
                     FAUSTFLOAT min, FAUSTFLOAT max,
                     bool input = true, int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan)
    {
      if (min <= 0 && max >= 0) {
        fConverter = LinearValueConverter2(0., 8191., 16383., double(min), 0., double(max));
      } else {
        // Degenerated case...
        fConverter = LinearValueConverter2(0., 8191., 16383., double(min), double(min + (max - min) / FAUSTFLOAT(2)), double(max));
      }
    }

    virtual ~uiMidiPitchWheel()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->pitchWheel(chan, fConverter.faust2ui(v));
        }
      } else {
        fMidiOut->pitchWheel(fChan - 1, fConverter.faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(FAUSTFLOAT(fConverter.ui2faust(v)));
      }
    }

    void setRange(int val)
    {
      double semi = (val / 128) + ((val % 128) / 100.);
      fConverter.setMappingValues(0., 8191., 16383., -semi, 0., semi);
    }

};

/**
   uiMidiKeyOn does scale (kLin/kLog/kExp) mapping for velocity.
*/
class uiMidiKeyOn : public uiMidiTimedItem, public uiConverter {

  private:

    int fKeyOn;

  public:

    uiMidiKeyOn(midi* midi_out, int key, GUI* ui,
                FAUSTFLOAT* zone,
                FAUSTFLOAT min, FAUSTFLOAT max,
                bool input = true,
                MetaDataUI::Scale scale = MetaDataUI::kLin,
                int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), uiConverter(scale, 0., 127., min, max), fKeyOn(key)
    {}
    virtual ~uiMidiKeyOn()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->keyOn(chan, fKeyOn, fConverter->faust2ui(v));
        }
      } else {
        fMidiOut->keyOn(fChan - 1, fKeyOn, fConverter->faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

};

/**
   uiMidiKeyOff does scale (kLin/kLog/kExp) mapping for velocity.
*/
class uiMidiKeyOff : public uiMidiTimedItem, public uiConverter {

  private:

    int fKeyOff;

  public:

    uiMidiKeyOff(midi* midi_out, int key, GUI* ui,
                 FAUSTFLOAT* zone,
                 FAUSTFLOAT min, FAUSTFLOAT max,
                 bool input = true,
                 MetaDataUI::Scale scale = MetaDataUI::kLin,
                 int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), uiConverter(scale, 0., 127., min, max), fKeyOff(key)
    {}
    virtual ~uiMidiKeyOff()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->keyOn(chan, fKeyOff, fConverter->faust2ui(v));
        }
      } else {
        fMidiOut->keyOn(fChan - 1, fKeyOff, fConverter->faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

};

/**
   uiMidiKeyPress does scale (kLin/kLog/kExp) mapping for velocity.
*/
class uiMidiKeyPress : public uiMidiTimedItem, public uiConverter {

  private:

    int fKey;

  public:

    uiMidiKeyPress(midi* midi_out, int key, GUI* ui,
                   FAUSTFLOAT* zone,
                   FAUSTFLOAT min, FAUSTFLOAT max,
                   bool input = true,
                   MetaDataUI::Scale scale = MetaDataUI::kLin,
                   int chan = 0)
      : uiMidiTimedItem(midi_out, ui, zone, input, chan), uiConverter(scale, 0., 127., min, max), fKey(key)
    {}
    virtual ~uiMidiKeyPress()
    {}

    virtual void reflectZone()
    {
      FAUSTFLOAT v = *fZone;
      fCache = v;
      if (fChan == 0) {
        // Send on [0..15] channels on the MIDI layer
        for (int chan = 0; chan < 16; chan++) {
          fMidiOut->keyOn(chan, fKey, fConverter->faust2ui(v));
        }
      } else {
        fMidiOut->keyOn(fChan - 1, fKey, fConverter->faust2ui(v));
      }
    }

    void modifyZone(FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiItem::modifyZone(FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

    void modifyZone(double date, FAUSTFLOAT v)
    {
      if (fInputCtrl) {
        uiMidiTimedItem::modifyZone(date, FAUSTFLOAT(fConverter->ui2faust(v)));
      }
    }

};

/******************************************************************************************
   MidiUI : Faust User Interface
   This class decodes MIDI metadata and maps incoming MIDI messages to them.
   Currently ctrlChange, keyOn/keyOff, keyPress, progChange, chanPress, pitchWheel/pitchBend
   start/stop/clock meta data are handled.

   Maps associating MIDI event ID (like each ctrl number) with all MIDI aware UI items
   are defined and progressively filled when decoding MIDI related metadata.
   MIDI aware UI items are used in both directions:
    - modifying their internal state when receving MIDI input events
    - sending their internal state as MIDI output events
 *******************************************************************************************/

class MidiUI : public GUI, public midi, public midi_interface, public MetaDataUI {

    // Add uiItem subclasses objects are deallocated by the inherited GUI class
    typedef std::map <int, std::vector<uiMidiCtrlChange*> > TCtrlChangeTable;
    typedef std::vector<uiMidiProgChange*>                  TProgChangeTable;
    typedef std::vector<uiMidiChanPress*>                   TChanPressTable;
    typedef std::map <int, std::vector<uiMidiKeyOn*> >      TKeyOnTable;
    typedef std::map <int, std::vector<uiMidiKeyOff*> >     TKeyOffTable;
    typedef std::map <int, std::vector<uiMidiKeyPress*> >   TKeyPressTable;
    typedef std::vector<uiMidiPitchWheel*>                  TPitchWheelTable;

  protected:

    TCtrlChangeTable fCtrlChangeTable;
    TProgChangeTable fProgChangeTable;
    TChanPressTable  fChanPressTable;
    TKeyOnTable      fKeyOnTable;
    TKeyOffTable     fKeyOffTable;
    TKeyOnTable      fKeyTable;
    TKeyPressTable   fKeyPressTable;
    TPitchWheelTable fPitchWheelTable;

    std::vector<uiMidiStart*> fStartTable;
    std::vector<uiMidiStop*>  fStopTable;
    std::vector<uiMidiClock*> fClockTable;

    std::vector<std::pair <std::string, std::string> > fMetaAux;

    midi_handler* fMidiHandler;
    bool fDelete;
    bool fTimeStamp;

    void addGenericZone(FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max, bool input = true)
    {
      if (fMetaAux.size() > 0) {
        for (size_t i = 0; i < fMetaAux.size(); i++) {
          unsigned num;
          unsigned chan;
          if (fMetaAux[i].first == "midi") {
            if (gsscanf(fMetaAux[i].second.c_str(), "ctrl %u %u", &num, &chan) == 2) {
              fCtrlChangeTable[num].push_back(new uiMidiCtrlChange(fMidiHandler, num, this, zone, min, max, input, getScale(zone), chan));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "ctrl %u", &num) == 1) {
              fCtrlChangeTable[num].push_back(new uiMidiCtrlChange(fMidiHandler, num, this, zone, min, max, input, getScale(zone)));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keyon %u %u", &num, &chan) == 2) {
              fKeyOnTable[num].push_back(new uiMidiKeyOn(fMidiHandler, num, this, zone, min, max, input, getScale(zone), chan));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keyon %u", &num) == 1) {
              fKeyOnTable[num].push_back(new uiMidiKeyOn(fMidiHandler, num, this, zone, min, max, input, getScale(zone)));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keyoff %u %u", &num, &chan) == 2) {
              fKeyOffTable[num].push_back(new uiMidiKeyOff(fMidiHandler, num, this, zone, min, max, input, getScale(zone), chan));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keyoff %u", &num) == 1) {
              fKeyOffTable[num].push_back(new uiMidiKeyOff(fMidiHandler, num, this, zone, min, max, input, getScale(zone)));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "key %u %u", &num, &chan) == 2) {
              fKeyTable[num].push_back(new uiMidiKeyOn(fMidiHandler, num, this, zone, min, max, input, getScale(zone), chan));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "key %u", &num) == 1) {
              fKeyTable[num].push_back(new uiMidiKeyOn(fMidiHandler, num, this, zone, min, max, input, getScale(zone)));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keypress %u %u", &num, &chan) == 2) {
              fKeyPressTable[num].push_back(new uiMidiKeyPress(fMidiHandler, num, this, zone, min, max, input, getScale(zone), chan));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "keypress %u", &num) == 1) {
              fKeyPressTable[num].push_back(new uiMidiKeyPress(fMidiHandler, num, this, zone, min, max, input, getScale(zone)));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "pgm %u", &chan) == 1) {
              fProgChangeTable.push_back(new uiMidiProgChange(fMidiHandler, this, zone, min, max, input, chan));
            } else if (strcmp(fMetaAux[i].second.c_str(), "pgm") == 0) {
              fProgChangeTable.push_back(new uiMidiProgChange(fMidiHandler, this, zone, min, max, input));
            } else if (gsscanf(fMetaAux[i].second.c_str(), "chanpress %u", &chan) == 1) {
              fChanPressTable.push_back(new uiMidiChanPress(fMidiHandler, this, zone, min, max, input, getScale(zone), chan));
            } else if ((fMetaAux[i].second == "chanpress")) {
              fChanPressTable.push_back(new uiMidiChanPress(fMidiHandler, this, zone, min, max, input, getScale(zone)));
            } else if ((gsscanf(fMetaAux[i].second.c_str(), "pitchwheel %u", &chan) == 1) || (gsscanf(fMetaAux[i].second.c_str(), "pitchbend %u", &chan) == 1)) {
              fPitchWheelTable.push_back(new uiMidiPitchWheel(fMidiHandler, this, zone, min, max, input, chan));
            } else if ((fMetaAux[i].second == "pitchwheel") || (fMetaAux[i].second == "pitchbend")) {
              fPitchWheelTable.push_back(new uiMidiPitchWheel(fMidiHandler, this, zone, min, max, input));
              // MIDI sync
            } else if (fMetaAux[i].second == "start") {
              fStartTable.push_back(new uiMidiStart(fMidiHandler, this, zone, input));
            } else if (fMetaAux[i].second == "stop") {
              fStopTable.push_back(new uiMidiStop(fMidiHandler, this, zone, input));
            } else if (fMetaAux[i].second == "clock") {
              fClockTable.push_back(new uiMidiClock(fMidiHandler, this, zone, input));
              // Explicit metadata to activate 'timestamp' mode
            } else if (fMetaAux[i].second == "timestamp") {
              fTimeStamp = true;
            }
          }
        }
      }
      fMetaAux.clear();
    }

    template <typename TABLE>
    void updateTable1(TABLE& table, double date, int channel, int val1)
    {
      for (size_t i = 0; i < table.size(); i++) {
        int channel_aux = table[i]->fChan;
        // channel_aux == 0 means "all channels"
        if (channel_aux == 0 || channel == channel_aux - 1) {
          if (fTimeStamp) {
            table[i]->modifyZone(date, FAUSTFLOAT(val1));
          } else {
            table[i]->modifyZone(FAUSTFLOAT(val1));
          }
        }
      }
    }

    template <typename TABLE>
    void updateTable2(TABLE& table, double date, int channel, int val1, int val2)
    {
      if (table.find(val1) != table.end()) {
        for (size_t i = 0; i < table[val1].size(); i++) {
          int channel_aux = table[val1][i]->fChan;
          // channel_aux == 0 means "all channels"
          if (channel_aux == 0 || channel == channel_aux - 1) {
            if (fTimeStamp) {
              table[val1][i]->modifyZone(date, FAUSTFLOAT(val2));
            } else {
              table[val1][i]->modifyZone(FAUSTFLOAT(val2));
            }
          }
        }
      }
    }

  public:

    MidiUI(midi_handler* midi_handler, bool delete_handler = false)
    {
      fMidiHandler = midi_handler;
      fMidiHandler->addMidiIn(this);
      // TODO: use shared_ptr based implementation
      fDelete = delete_handler;
      fTimeStamp = false;
    }

    virtual ~MidiUI()
    {
      // Remove from fMidiHandler
      fMidiHandler->removeMidiIn(this);
      // TODO: use shared_ptr based implementation
      if (fDelete) delete fMidiHandler;
    }

    bool run() {
      return fMidiHandler->startMidi();
    }
    void stop() {
      fMidiHandler->stopMidi();
    }

    void addMidiIn(midi* midi_dsp) {
      fMidiHandler->addMidiIn(midi_dsp);
    }
    void removeMidiIn(midi* midi_dsp) {
      fMidiHandler->removeMidiIn(midi_dsp);
    }

    // -- active widgets

    virtual void addButton(const char* label, FAUSTFLOAT* zone)
    {
      addGenericZone(zone, FAUSTFLOAT(0), FAUSTFLOAT(1));
    }
    virtual void addCheckButton(const char* label, FAUSTFLOAT* zone)
    {
      addGenericZone(zone, FAUSTFLOAT(0), FAUSTFLOAT(1));
    }

    virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      addGenericZone(zone, min, max);
    }
    virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      addGenericZone(zone, min, max);
    }
    virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      addGenericZone(zone, min, max);
    }

    // -- passive widgets

    virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
    {
      addGenericZone(zone, min, max, false);
    }
    virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
    {
      addGenericZone(zone, min, max, false);
    }

    // -- metadata declarations

    virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val)
    {
      MetaDataUI::declare(zone, key, val);
      fMetaAux.push_back(std::make_pair(key, val));
    }

    // -- MIDI API

    void key(double date, int channel, int note, int velocity)
    {
      updateTable2<TKeyOnTable>(fKeyTable, date, channel, note, velocity);
    }

    MapUI* keyOn(double date, int channel, int note, int velocity)
    {
      updateTable2<TKeyOnTable>(fKeyOnTable, date, channel, note, velocity);
      // If note is in fKeyTable, handle it as a keyOn
      key(date, channel, note, velocity);
      return nullptr;
    }

    void keyOff(double date, int channel, int note, int velocity)
    {
      updateTable2<TKeyOffTable>(fKeyOffTable, date, channel, note, velocity);
      // If note is in fKeyTable, handle it as a keyOff with a 0 velocity
      key(date, channel, note, 0);
    }

    void ctrlChange(double date, int channel, int ctrl, int value)
    {
      updateTable2<TCtrlChangeTable>(fCtrlChangeTable, date, channel, ctrl, value);
    }

    void rpn(double date, int channel, int ctrl, int value)
    {
      if (ctrl == midi::PITCH_BEND_RANGE) {
        for (size_t i = 0; i < fPitchWheelTable.size(); i++) {
          // channel_aux == 0 means "all channels"
          int channel_aux = fPitchWheelTable[i]->fChan;
          if (channel_aux == 0 || channel == channel_aux - 1) {
            fPitchWheelTable[i]->setRange(value);
          }
        }
      }
    }

    void progChange(double date, int channel, int pgm)
    {
      updateTable1<TProgChangeTable>(fProgChangeTable, date, channel, pgm);
    }

    void pitchWheel(double date, int channel, int wheel)
    {
      updateTable1<TPitchWheelTable>(fPitchWheelTable, date, channel, wheel);
    }

    void keyPress(double date, int channel, int pitch, int press)
    {
      updateTable2<TKeyPressTable>(fKeyPressTable, date, channel, pitch, press);
    }

    void chanPress(double date, int channel, int press)
    {
      updateTable1<TChanPressTable>(fChanPressTable, date, channel, press);
    }

    void ctrlChange14bits(double date, int channel, int ctrl, int value) {}

    // MIDI sync

    void startSync(double date)
    {
      for (size_t i = 0; i < fStartTable.size(); i++) {
        fStartTable[i]->modifyZone(date, FAUSTFLOAT(1));
      }
    }

    void stopSync(double date)
    {
      for (size_t i = 0; i < fStopTable.size(); i++) {
        fStopTable[i]->modifyZone(date, FAUSTFLOAT(0));
      }
    }

    void clock(double date)
    {
      for (size_t i = 0; i < fClockTable.size(); i++) {
        fClockTable[i]->modifyZone(date, FAUSTFLOAT(1));
      }
    }
};

#endif // FAUST_MIDIUI_H
/**************************  END  MidiUI.h **************************/
/************************** BEGIN teensy-midi.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __teensy_midi__
#define __teensy_midi__

#include <cstdlib>

#include "Arduino.h"

extern usb_midi_class gUSBMIDI;

/**
    MIDI input/output handling for the Teensy: https://www.pjrc.com/teensy/
*/
class teensy_midi : public midi_handler {

  public:

    void processMidi()
    {
      while (gUSBMIDI.read()) {

        int type = gUSBMIDI.getType();       // which MIDI message, 128-255
        int channel = gUSBMIDI.getChannel(); // which MIDI channel, 0-15
        double time = (double)gUSBMIDI.Clock;

        switch (type) {
          case gUSBMIDI.Clock:
            handleClock(time);
            break;
          case usbMIDI.Start:
          // We can consider start and continue as identical messages
          case usbMIDI.Continue:
            handleStart(time);
            break;
          case gUSBMIDI.Stop:
            handleStop(time);
            break;
          case gUSBMIDI.ProgramChange:
            handleProgChange(time, channel, gUSBMIDI.getData1());
            break;
          case gUSBMIDI.AfterTouchChannel:
            handleAfterTouch(time, channel, gUSBMIDI.getData1());
            break;
          case gUSBMIDI.NoteOff:
            handleKeyOff(time, channel, gUSBMIDI.getData1(), gUSBMIDI.getData2());
            break;
          case gUSBMIDI.NoteOn:
            handleKeyOn(time, channel, gUSBMIDI.getData1(), gUSBMIDI.getData2());
            break;
          case gUSBMIDI.ControlChange:
            handleCtrlChange(time, channel, gUSBMIDI.getData1(), gUSBMIDI.getData2());
            break;
          case gUSBMIDI.PitchBend:
            handlePitchWheel(time, channel, gUSBMIDI.getData1(), gUSBMIDI.getData2());
            break;
          case gUSBMIDI.AfterTouchPoly:
            handlePolyAfterTouch(time, channel, gUSBMIDI.getData1(), gUSBMIDI.getData2());
            break;
        }
      }
    }
};

#endif
/**************************  END  teensy-midi.h **************************/
#endif

// for polyphonic synths
#ifdef NVOICES
/************************** BEGIN poly-dsp.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __poly_dsp__
#define __poly_dsp__

#include <stdio.h>
#include <string>
#include <cmath>
#include <algorithm>
#include <functional>
#include <ostream>
#include <sstream>
#include <vector>
#include <limits.h>
#include <float.h>
#include <assert.h>

/************************** BEGIN dsp-combiner.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2019 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __dsp_combiner__
#define __dsp_combiner__

#include <string.h>
#include <string>
#include <assert.h>
#include <sstream>


// Base class and common code for binary combiners

enum Layout { kVerticalGroup, kHorizontalGroup, kTabGroup };

class dsp_binary_combiner : public dsp {

  protected:

    dsp* fDSP1;
    dsp* fDSP2;
    int fBufferSize;
    Layout fLayout;
    std::string fLabel;

    void buildUserInterfaceAux(UI* ui_interface)
    {
      switch (fLayout) {
        case kHorizontalGroup:
          ui_interface->openHorizontalBox(fLabel.c_str());
          fDSP1->buildUserInterface(ui_interface);
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          break;
        case kVerticalGroup:
          ui_interface->openVerticalBox(fLabel.c_str());
          fDSP1->buildUserInterface(ui_interface);
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          break;
        case kTabGroup:
          ui_interface->openTabBox(fLabel.c_str());
          ui_interface->openVerticalBox("DSP1");
          fDSP1->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          ui_interface->openVerticalBox("DSP2");
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          ui_interface->closeBox();
          break;
      }
    }

    FAUSTFLOAT** allocateChannels(int num)
    {
      FAUSTFLOAT** channels = new FAUSTFLOAT*[num];
      for (int chan = 0; chan < num; chan++) {
        channels[chan] = new FAUSTFLOAT[fBufferSize];
        memset(channels[chan], 0, sizeof(FAUSTFLOAT) * fBufferSize);
      }
      return channels;
    }

    void deleteChannels(FAUSTFLOAT** channels, int num)
    {
      for (int chan = 0; chan < num; chan++) {
        delete [] channels[chan];
      }
      delete [] channels;
    }

  public:

    dsp_binary_combiner(dsp* dsp1, dsp* dsp2, int buffer_size, Layout layout, const std::string& label)
      : fDSP1(dsp1), fDSP2(dsp2), fBufferSize(buffer_size), fLayout(layout), fLabel(label)
    {}

    virtual ~dsp_binary_combiner()
    {
      delete fDSP1;
      delete fDSP2;
    }

    virtual int getSampleRate()
    {
      return fDSP1->getSampleRate();
    }
    virtual void init(int sample_rate)
    {
      fDSP1->init(sample_rate);
      fDSP2->init(sample_rate);
    }
    virtual void instanceInit(int sample_rate)
    {
      fDSP1->instanceInit(sample_rate);
      fDSP2->instanceInit(sample_rate);
    }
    virtual void instanceConstants(int sample_rate)
    {
      fDSP1->instanceConstants(sample_rate);
      fDSP2->instanceConstants(sample_rate);
    }

    virtual void instanceResetUserInterface()
    {
      fDSP1->instanceResetUserInterface();
      fDSP2->instanceResetUserInterface();
    }

    virtual void instanceClear()
    {
      fDSP1->instanceClear();
      fDSP2->instanceClear();
    }

    virtual void metadata(Meta* m)
    {
      fDSP1->metadata(m);
      fDSP2->metadata(m);
    }

};

// Combine two 'compatible' DSP in sequence

class dsp_sequencer : public dsp_binary_combiner {

  private:

    FAUSTFLOAT** fDSP1Outputs;

  public:

    dsp_sequencer(dsp* dsp1, dsp* dsp2,
                  int buffer_size = 4096,
                  Layout layout = Layout::kTabGroup,
                  const std::string& label = "Sequencer")
      : dsp_binary_combiner(dsp1, dsp2, buffer_size, layout, label)
    {
      fDSP1Outputs = allocateChannels(fDSP1->getNumOutputs());
    }

    virtual ~dsp_sequencer()
    {
      deleteChannels(fDSP1Outputs, fDSP1->getNumOutputs());
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP2->getNumOutputs();
    }

    virtual void buildUserInterface(UI* ui_interface)
    {
      buildUserInterfaceAux(ui_interface);
    }

    virtual dsp* clone()
    {
      return new dsp_sequencer(fDSP1->clone(), fDSP2->clone(), fBufferSize, fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      fDSP1->compute(count, inputs, fDSP1Outputs);
      fDSP2->compute(count, fDSP1Outputs, outputs);
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }

};

// Combine two DSP in parallel

class dsp_parallelizer : public dsp_binary_combiner {

  private:

    FAUSTFLOAT** fDSP2Inputs;
    FAUSTFLOAT** fDSP2Outputs;

  public:

    dsp_parallelizer(dsp* dsp1, dsp* dsp2,
                     int buffer_size = 4096,
                     Layout layout = Layout::kTabGroup,
                     const std::string& label = "Parallelizer")
      : dsp_binary_combiner(dsp1, dsp2, buffer_size, layout, label)
    {
      fDSP2Inputs = new FAUSTFLOAT*[fDSP2->getNumInputs()];
      fDSP2Outputs = new FAUSTFLOAT*[fDSP2->getNumOutputs()];
    }

    virtual ~dsp_parallelizer()
    {
      delete [] fDSP2Inputs;
      delete [] fDSP2Outputs;
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs() + fDSP2->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP1->getNumOutputs() + fDSP2->getNumOutputs();
    }

    virtual void buildUserInterface(UI* ui_interface)
    {
      buildUserInterfaceAux(ui_interface);
    }

    virtual dsp* clone()
    {
      return new dsp_parallelizer(fDSP1->clone(), fDSP2->clone(), fBufferSize, fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      fDSP1->compute(count, inputs, outputs);

      // Shift inputs/outputs channels for fDSP2
      for (int chan = 0; chan < fDSP2->getNumInputs(); chan++) {
        fDSP2Inputs[chan] = inputs[fDSP1->getNumInputs() + chan];
      }
      for (int chan = 0; chan < fDSP2->getNumOutputs(); chan++) {
        fDSP2Outputs[chan] = outputs[fDSP1->getNumOutputs() + chan];
      }

      fDSP2->compute(count, fDSP2Inputs, fDSP2Outputs);
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }

};

// Combine two 'compatible' DSP in splitter

class dsp_splitter : public dsp_binary_combiner {

  private:

    FAUSTFLOAT** fDSP1Outputs;
    FAUSTFLOAT** fDSP2Inputs;

  public:

    dsp_splitter(dsp* dsp1, dsp* dsp2,
                 int buffer_size = 4096,
                 Layout layout = Layout::kTabGroup,
                 const std::string& label = "Splitter")
      : dsp_binary_combiner(dsp1, dsp2, buffer_size, layout, label)
    {
      fDSP1Outputs = allocateChannels(fDSP1->getNumOutputs());
      fDSP2Inputs = new FAUSTFLOAT*[fDSP2->getNumInputs()];
    }

    virtual ~dsp_splitter()
    {
      deleteChannels(fDSP1Outputs, fDSP1->getNumOutputs());
      delete [] fDSP2Inputs;
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP2->getNumOutputs();
    }

    virtual void buildUserInterface(UI* ui_interface)
    {
      buildUserInterfaceAux(ui_interface);
    }

    virtual dsp* clone()
    {
      return new dsp_splitter(fDSP1->clone(), fDSP2->clone(), fBufferSize, fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      fDSP1->compute(count, inputs, fDSP1Outputs);

      for (int chan = 0; chan < fDSP2->getNumInputs(); chan++) {
        fDSP2Inputs[chan] = fDSP1Outputs[chan % fDSP1->getNumOutputs()];
      }

      fDSP2->compute(count, fDSP2Inputs, outputs);
    }
};

// Combine two 'compatible' DSP in merger

class dsp_merger : public dsp_binary_combiner {

  private:

    FAUSTFLOAT** fDSP1Inputs;
    FAUSTFLOAT** fDSP1Outputs;
    FAUSTFLOAT** fDSP2Inputs;

    void mix(int count, FAUSTFLOAT* dst, FAUSTFLOAT* src)
    {
      for (int frame = 0; frame < count; frame++) {
        dst[frame] += src[frame];
      }
    }

  public:

    dsp_merger(dsp* dsp1, dsp* dsp2,
               int buffer_size = 4096,
               Layout layout = Layout::kTabGroup,
               const std::string& label = "Merger")
      : dsp_binary_combiner(dsp1, dsp2, buffer_size, layout, label)
    {
      fDSP1Inputs = allocateChannels(fDSP1->getNumInputs());
      fDSP1Outputs = allocateChannels(fDSP1->getNumOutputs());
      fDSP2Inputs = new FAUSTFLOAT*[fDSP2->getNumInputs()];
    }

    virtual ~dsp_merger()
    {
      deleteChannels(fDSP1Inputs, fDSP1->getNumInputs());
      deleteChannels(fDSP1Outputs, fDSP1->getNumOutputs());
      delete [] fDSP2Inputs;
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP2->getNumOutputs();
    }

    virtual void buildUserInterface(UI* ui_interface)
    {
      buildUserInterfaceAux(ui_interface);
    }

    virtual dsp* clone()
    {
      return new dsp_merger(fDSP1->clone(), fDSP2->clone(), fBufferSize, fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      fDSP1->compute(count, fDSP1Inputs, fDSP1Outputs);

      memset(fDSP2Inputs, 0, sizeof(FAUSTFLOAT*) * fDSP2->getNumInputs());

      for (int chan = 0; chan < fDSP1->getNumOutputs(); chan++) {
        int mchan = chan % fDSP2->getNumInputs();
        if (fDSP2Inputs[mchan]) {
          mix(count, fDSP2Inputs[mchan], fDSP1Outputs[chan]);
        } else {
          fDSP2Inputs[mchan] = fDSP1Outputs[chan];
        }
      }

      fDSP2->compute(count, fDSP2Inputs, outputs);
    }
};

// Combine two 'compatible' DSP in a recursive way

class dsp_recursiver : public dsp_binary_combiner {

  private:

    FAUSTFLOAT** fDSP1Inputs;
    FAUSTFLOAT** fDSP1Outputs;

    FAUSTFLOAT** fDSP2Inputs;
    FAUSTFLOAT** fDSP2Outputs;

  public:

    dsp_recursiver(dsp* dsp1, dsp* dsp2,
                   Layout layout = Layout::kTabGroup,
                   const std::string& label = "Recursiver")
      : dsp_binary_combiner(dsp1, dsp2, 1, layout, label)
    {
      fDSP1Inputs = allocateChannels(fDSP1->getNumInputs());
      fDSP1Outputs = allocateChannels(fDSP1->getNumOutputs());
      fDSP2Inputs = allocateChannels(fDSP2->getNumInputs());
      fDSP2Outputs = allocateChannels(fDSP2->getNumOutputs());
    }

    virtual ~dsp_recursiver()
    {
      deleteChannels(fDSP1Inputs, fDSP1->getNumInputs());
      deleteChannels(fDSP1Outputs, fDSP1->getNumOutputs());
      deleteChannels(fDSP2Inputs, fDSP2->getNumInputs());
      deleteChannels(fDSP2Outputs, fDSP2->getNumOutputs());
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs() - fDSP2->getNumOutputs();
    }
    virtual int getNumOutputs() {
      return fDSP1->getNumOutputs();
    }

    virtual void buildUserInterface(UI* ui_interface)
    {
      buildUserInterfaceAux(ui_interface);
    }

    virtual dsp* clone()
    {
      return new dsp_recursiver(fDSP1->clone(), fDSP2->clone(), fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      for (int frame = 0; (frame < count); frame++) {

        for (int chan = 0; chan < fDSP2->getNumOutputs(); chan++) {
          fDSP1Inputs[chan][0] = fDSP2Outputs[chan][0];
        }

        for (int chan = 0; chan < fDSP1->getNumInputs() - fDSP2->getNumOutputs(); chan++) {
          fDSP1Inputs[chan + fDSP2->getNumOutputs()][0] = inputs[chan][frame];
        }

        fDSP1->compute(1, fDSP1Inputs, fDSP1Outputs);

        for (int chan = 0; chan < fDSP1->getNumOutputs(); chan++) {
          outputs[chan][frame] = fDSP1Outputs[chan][0];
        }

        for (int chan = 0; chan < fDSP2->getNumInputs(); chan++) {
          fDSP2Inputs[chan][0] = fDSP1Outputs[chan][0];
        }

        fDSP2->compute(1, fDSP2Inputs, fDSP2Outputs);
      }
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }

};

/*
  Crossfade between two DSP.
  When fCrossfade = 1, the first DSP only is computed, when fCrossfade = 0,
  the second DSP only is computed, otherwise both DSPs are computed and mixed.
*/

class dsp_crossfader: public dsp_binary_combiner {

  private:

    FAUSTFLOAT fCrossfade;
    FAUSTFLOAT** fDSPOutputs1;
    FAUSTFLOAT** fDSPOutputs2;

  public:

    dsp_crossfader(dsp* dsp1, dsp* dsp2,
                   Layout layout = Layout::kTabGroup,
                   const std::string& label = "Crossfade")
      : dsp_binary_combiner(dsp1, dsp2, 4096, layout, label), fCrossfade(FAUSTFLOAT(0.5))
    {
      fDSPOutputs1 = allocateChannels(fDSP1->getNumOutputs());
      fDSPOutputs2 = allocateChannels(fDSP1->getNumOutputs());
    }

    virtual ~dsp_crossfader()
    {
      deleteChannels(fDSPOutputs1, fDSP1->getNumInputs());
      deleteChannels(fDSPOutputs2, fDSP1->getNumOutputs());
    }

    virtual int getNumInputs() {
      return fDSP1->getNumInputs();
    }
    virtual int getNumOutputs() {
      return fDSP1->getNumOutputs();
    }

    void buildUserInterface(UI* ui_interface)
    {
      switch (fLayout) {
        case kHorizontalGroup:
          ui_interface->openHorizontalBox(fLabel.c_str());
          ui_interface->addHorizontalSlider("Crossfade", &fCrossfade, FAUSTFLOAT(0.5), FAUSTFLOAT(0), FAUSTFLOAT(1), FAUSTFLOAT(0.01));
          fDSP1->buildUserInterface(ui_interface);
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          break;
        case kVerticalGroup:
          ui_interface->openVerticalBox(fLabel.c_str());
          ui_interface->addHorizontalSlider("Crossfade", &fCrossfade, FAUSTFLOAT(0.5), FAUSTFLOAT(0), FAUSTFLOAT(1), FAUSTFLOAT(0.01));
          fDSP1->buildUserInterface(ui_interface);
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          break;
        case kTabGroup:
          ui_interface->openTabBox(fLabel.c_str());
          ui_interface->openVerticalBox("Crossfade");
          ui_interface->addHorizontalSlider("Crossfade", &fCrossfade, FAUSTFLOAT(0.5), FAUSTFLOAT(0), FAUSTFLOAT(1), FAUSTFLOAT(0.01));
          ui_interface->closeBox();
          ui_interface->openVerticalBox("DSP1");
          fDSP1->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          ui_interface->openVerticalBox("DSP2");
          fDSP2->buildUserInterface(ui_interface);
          ui_interface->closeBox();
          ui_interface->closeBox();
          break;
      }
    }

    virtual dsp* clone()
    {
      return new dsp_crossfader(fDSP1->clone(), fDSP2->clone(), fLayout, fLabel);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      if (fCrossfade == FAUSTFLOAT(1)) {
        fDSP1->compute(count, inputs, outputs);
      } else if (fCrossfade == FAUSTFLOAT(0)) {
        fDSP2->compute(count, inputs, outputs);
      } else {
        // Compute each effect
        fDSP1->compute(count, inputs, fDSPOutputs1);
        fDSP2->compute(count, inputs, fDSPOutputs2);
        // Mix between the two effects
        FAUSTFLOAT gain1 = fCrossfade;
        FAUSTFLOAT gain2 = FAUSTFLOAT(1) - gain1;
        for (int frame = 0; (frame < count); frame++) {
          for (int chan = 0; chan < fDSP1->getNumOutputs(); chan++) {
            outputs[chan][frame] = fDSPOutputs1[chan][frame] * gain1 + fDSPOutputs2[chan][frame] * gain2;
          }
        }
      }
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }
};

#ifndef __dsp_algebra_api__
#define __dsp_algebra_api__

// DSP algebra API
/*
  Each operation takes two DSP and a optional Layout and Label parameters, returns the combined DSPs, or null if failure with an error message.
*/

static dsp* createDSPSequencer(dsp* dsp1, dsp* dsp2,
                               std::string& error,
                               Layout layout = Layout::kTabGroup,
                               const std::string& label = "Sequencer")
{
  if (dsp1->getNumOutputs() != dsp2->getNumInputs()) {
    std::stringstream error_aux;
    error_aux << "Connection error in dsp_sequencer : the number of outputs ("
              << dsp1->getNumOutputs() << ") of A "
              << "must be equal to the number of inputs (" << dsp2->getNumInputs() << ") of B" << std::endl;
    error = error_aux.str();
    return nullptr;
  } else {
    return new dsp_sequencer(dsp1, dsp2, 4096, layout, label);
  }
}

static dsp* createDSPParallelizer(dsp* dsp1, dsp* dsp2,
                                  std::string& error,
                                  Layout layout = Layout::kTabGroup,
                                  const std::string& label = "Parallelizer")
{
  return new dsp_parallelizer(dsp1, dsp2, 4096, layout, label);
}

static dsp* createDSPSplitter(dsp* dsp1, dsp* dsp2, std::string& error, Layout layout = Layout::kTabGroup, const std::string& label = "Splitter")
{
  if (dsp1->getNumOutputs() == 0) {
    error = "Connection error in dsp_splitter : the first expression has no outputs\n";
    return nullptr;
  } else if (dsp2->getNumInputs() == 0) {
    error = "Connection error in dsp_splitter : the second expression has no inputs\n";
    return nullptr;
  } else if (dsp2->getNumInputs() % dsp1->getNumOutputs() != 0) {
    std::stringstream error_aux;
    error_aux << "Connection error in dsp_splitter : the number of outputs (" << dsp1->getNumOutputs()
              << ") of the first expression should be a divisor of the number of inputs ("
              << dsp2->getNumInputs()
              << ") of the second expression" << std::endl;
    error = error_aux.str();
    return nullptr;
  } else if (dsp2->getNumInputs() == dsp1->getNumOutputs()) {
    return new dsp_sequencer(dsp1, dsp2, 4096, layout, label);
  } else {
    return new dsp_splitter(dsp1, dsp2, 4096, layout, label);
  }
}

static dsp* createDSPMerger(dsp* dsp1, dsp* dsp2,
                            std::string& error,
                            Layout layout = Layout::kTabGroup,
                            const std::string& label = "Merger")
{
  if (dsp1->getNumOutputs() == 0) {
    error = "Connection error in dsp_merger : the first expression has no outputs\n";
    return nullptr;
  } else if (dsp2->getNumInputs() == 0) {
    error = "Connection error in dsp_merger : the second expression has no inputs\n";
    return nullptr;
  } else if (dsp1->getNumOutputs() % dsp2->getNumInputs() != 0) {
    std::stringstream error_aux;
    error_aux << "Connection error in dsp_merger : the number of outputs (" << dsp1->getNumOutputs()
              << ") of the first expression should be a multiple of the number of inputs ("
              << dsp2->getNumInputs()
              << ") of the second expression" << std::endl;
    error = error_aux.str();
    return nullptr;
  } else if (dsp2->getNumInputs() == dsp1->getNumOutputs()) {
    return new dsp_sequencer(dsp1, dsp2, 4096, layout, label);
  } else {
    return new dsp_merger(dsp1, dsp2, 4096, layout, label);
  }
}

static dsp* createDSPRecursiver(dsp* dsp1, dsp* dsp2,
                                std::string& error,
                                Layout layout = Layout::kTabGroup,
                                const std::string& label = "Recursiver")
{
  if ((dsp2->getNumInputs() > dsp1->getNumOutputs()) || (dsp2->getNumOutputs() > dsp1->getNumInputs())) {
    std::stringstream error_aux;
    error_aux << "Connection error in : dsp_recursiver" << std::endl;
    if (dsp2->getNumInputs() > dsp1->getNumOutputs()) {
      error_aux << "The number of outputs " << dsp1->getNumOutputs()
                << " of the first expression should be greater or equal to the number of inputs ("
                << dsp2->getNumInputs()
                << ") of the second expression" << std::endl;
    }
    if (dsp2->getNumOutputs() > dsp1->getNumInputs()) {
      error_aux << "The number of inputs " << dsp1->getNumInputs()
                << " of the first expression should be greater or equal to the number of outputs ("
                << dsp2->getNumOutputs()
                << ") of the second expression" << std::endl;
    }
    error = error_aux.str();
    return nullptr;
  } else {
    return new dsp_recursiver(dsp1, dsp2, layout, label);
  }
}

static dsp* createDSPCrossfader(dsp* dsp1, dsp* dsp2,
                                std::string& error,
                                Layout layout = Layout::kTabGroup,
                                const std::string& label = "Crossfade")
{
  if (dsp1->getNumInputs() != dsp2->getNumInputs()) {
    std::stringstream error_aux;
    error_aux << "Connection error in dsp_crossfader : the number of inputs ("
              << dsp1->getNumInputs() << ") of A "
              << "must be equal to the number of inputs (" << dsp2->getNumInputs() << ") of B" << std::endl;
    error = error_aux.str();
    return nullptr;
  } else if (dsp1->getNumOutputs() != dsp2->getNumOutputs()) {
    std::stringstream error_aux;
    error_aux << "Connection error in dsp_crossfader : the number of outputs ("
              << dsp1->getNumOutputs() << ") of A "
              << "must be equal to the number of outputs (" << dsp2->getNumOutputs() << ") of B" << std::endl;
    error = error_aux.str();
    return nullptr;
  } else {
    return new dsp_crossfader(dsp1, dsp2, layout, label);
  }
}

#endif

#endif
/************************** END dsp-combiner.h **************************/
/************************** BEGIN dsp-adapter.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2020 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __dsp_adapter__
#define __dsp_adapter__

#ifndef _WIN32
#include <alloca.h>
#endif
#include <string.h>
#include <cmath>
#include <assert.h>
#include <stdio.h>


// Adapts a DSP for a different number of inputs/outputs
class dsp_adapter : public decorator_dsp {

  private:

    FAUSTFLOAT** fAdaptedInputs;
    FAUSTFLOAT** fAdaptedOutputs;
    int fHWInputs;
    int fHWOutputs;
    int fBufferSize;

    void adaptBuffers(FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      for (int i = 0; i < fHWInputs; i++) {
        fAdaptedInputs[i] = inputs[i];
      }
      for (int i = 0; i < fHWOutputs; i++) {
        fAdaptedOutputs[i] = outputs[i];
      }
    }

  public:

    dsp_adapter(dsp* dsp, int hw_inputs, int hw_outputs, int buffer_size): decorator_dsp(dsp)
    {
      fHWInputs = hw_inputs;
      fHWOutputs = hw_outputs;
      fBufferSize = buffer_size;

      fAdaptedInputs = new FAUSTFLOAT*[dsp->getNumInputs()];
      for (int i = 0; i < dsp->getNumInputs() - fHWInputs; i++) {
        fAdaptedInputs[i + fHWInputs] = new FAUSTFLOAT[buffer_size];
        memset(fAdaptedInputs[i + fHWInputs], 0, sizeof(FAUSTFLOAT) * buffer_size);
      }

      fAdaptedOutputs = new FAUSTFLOAT*[dsp->getNumOutputs()];
      for (int i = 0; i < dsp->getNumOutputs() - fHWOutputs; i++) {
        fAdaptedOutputs[i + fHWOutputs] = new FAUSTFLOAT[buffer_size];
        memset(fAdaptedOutputs[i + fHWOutputs], 0, sizeof(FAUSTFLOAT) * buffer_size);
      }
    }

    virtual ~dsp_adapter()
    {
      for (int i = 0; i < fDSP->getNumInputs() - fHWInputs; i++) {
        delete [] fAdaptedInputs[i + fHWInputs];
      }
      delete [] fAdaptedInputs;

      for (int i = 0; i < fDSP->getNumOutputs() - fHWOutputs; i++) {
        delete [] fAdaptedOutputs[i + fHWOutputs];
      }
      delete [] fAdaptedOutputs;
    }

    virtual int getNumInputs() {
      return fHWInputs;
    }
    virtual int getNumOutputs() {
      return fHWOutputs;
    }

    virtual dsp_adapter* clone() {
      return new dsp_adapter(fDSP->clone(), fHWInputs, fHWOutputs, fBufferSize);
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      adaptBuffers(inputs, outputs);
      fDSP->compute(date_usec, count, fAdaptedInputs, fAdaptedOutputs);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      adaptBuffers(inputs, outputs);
      fDSP->compute(count, fAdaptedInputs, fAdaptedOutputs);
    }
};

// Adapts a DSP for a different sample size
template <typename REAL_INT, typename REAL_EXT>
class dsp_sample_adapter : public decorator_dsp {

  private:

    REAL_INT** fAdaptedInputs;
    REAL_INT** fAdaptedOutputs;

    void adaptInputBuffers(int count, FAUSTFLOAT** inputs)
    {
      for (int chan = 0; chan < fDSP->getNumInputs(); chan++) {
        for (int frame = 0; frame < count; frame++) {
          fAdaptedInputs[chan][frame] = REAL_INT(reinterpret_cast<REAL_EXT**>(inputs)[chan][frame]);
        }
      }
    }

    void adaptOutputsBuffers(int count, FAUSTFLOAT** outputs)
    {
      for (int chan = 0; chan < fDSP->getNumOutputs(); chan++) {
        for (int frame = 0; frame < count; frame++) {
          reinterpret_cast<REAL_EXT**>(outputs)[chan][frame] = REAL_EXT(fAdaptedOutputs[chan][frame]);
        }
      }
    }

  public:

    dsp_sample_adapter(dsp* dsp): decorator_dsp(dsp)
    {
      fAdaptedInputs = new REAL_INT*[dsp->getNumInputs()];
      for (int i = 0; i < dsp->getNumInputs(); i++) {
        fAdaptedInputs[i] = new REAL_INT[4096];
      }

      fAdaptedOutputs = new REAL_INT*[dsp->getNumOutputs()];
      for (int i = 0; i < dsp->getNumOutputs(); i++) {
        fAdaptedOutputs[i] = new REAL_INT[4096];
      }
    }

    virtual ~dsp_sample_adapter()
    {
      for (int i = 0; i < fDSP->getNumInputs(); i++) {
        delete [] fAdaptedInputs[i];
      }
      delete [] fAdaptedInputs;

      for (int i = 0; i < fDSP->getNumOutputs(); i++) {
        delete [] fAdaptedOutputs[i];
      }
      delete [] fAdaptedOutputs;
    }

    virtual dsp_sample_adapter* clone() {
      return new dsp_sample_adapter(fDSP->clone());
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      assert(count <= 4096);
      adaptInputBuffers(count, inputs);
      // DSP base class uses FAUSTFLOAT** type, so reinterpret_cast has to be used even if the real DSP uses REAL_INT
      fDSP->compute(count, reinterpret_cast<FAUSTFLOAT**>(fAdaptedInputs), reinterpret_cast<FAUSTFLOAT**>(fAdaptedOutputs));
      adaptOutputsBuffers(count, outputs);
    }

    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      assert(count <= 4096);
      adaptInputBuffers(count, inputs);
      // DSP base class uses FAUSTFLOAT** type, so reinterpret_cast has to be used even if the real DSP uses REAL_INT
      fDSP->compute(date_usec, count, reinterpret_cast<FAUSTFLOAT**>(fAdaptedInputs), reinterpret_cast<FAUSTFLOAT**>(fAdaptedOutputs));
      adaptOutputsBuffers(count, outputs);
    }
};

// Template used to specialize double parameters expressed as NUM/DENOM
template <int NUM, int DENOM>
struct Double {
  static constexpr double value() {
    return double(NUM) / double(DENOM);
  }
};

// Base class for filters
template <class fVslider0, int fVslider1>
struct Filter {
  inline int getFactor() {
    return fVslider1;
  }
};

// Identity filter: copy input to output
template <class fVslider0, int fVslider1>
struct Identity : public Filter<fVslider0, fVslider1> {
  inline int getFactor() {
    return fVslider1;
  }

  inline void compute(int count, FAUSTFLOAT* input0, FAUSTFLOAT* output0)
  {
    memcpy(output0, input0, count * sizeof(FAUSTFLOAT));
  }
};

// Generated with process = fi.lowpass(3, ma.SR*hslider("FCFactor", 0.4, 0.4, 0.5, 0.01)/hslider("Factor", 2, 2, 8, 1));
template <class fVslider0, int fVslider1, typename REAL>
struct LowPass3 : public Filter<fVslider0, fVslider1> {

  REAL fVec0[2];
  REAL fRec1[2];
  REAL fRec0[3];

  inline REAL LowPass3_faustpower2_f(REAL value)
  {
    return (value * value);
  }

  LowPass3()
  {
    for (int l0 = 0; (l0 < 2); l0 = (l0 + 1)) {
      fVec0[l0] = 0.0;
    }
    for (int l1 = 0; (l1 < 2); l1 = (l1 + 1)) {
      fRec1[l1] = 0.0;
    }
    for (int l2 = 0; (l2 < 3); l2 = (l2 + 1)) {
      fRec0[l2] = 0.0;
    }
  }

  inline void compute(int count, FAUSTFLOAT* input0, FAUSTFLOAT* output0)
  {
    // Computed at template specialization time
    REAL fSlow0 = std::tan((3.1415926535897931 * (REAL(fVslider0::value()) / REAL(fVslider1))));
    REAL fSlow1 = (1.0 / fSlow0);
    REAL fSlow2 = (1.0 / (((fSlow1 + 1.0000000000000002) / fSlow0) + 1.0));
    REAL fSlow3 = (1.0 / (fSlow1 + 1.0));
    REAL fSlow4 = (1.0 - fSlow1);
    REAL fSlow5 = (((fSlow1 + -1.0000000000000002) / fSlow0) + 1.0);
    REAL fSlow6 = (2.0 * (1.0 - (1.0 / LowPass3_faustpower2_f(fSlow0))));
    // Computed at runtime
    for (int i = 0; (i < count); i = (i + 1)) {
      REAL fTemp0 = REAL(input0[i]);
      fVec0[0] = fTemp0;
      fRec1[0] = (0.0 - (fSlow3 * ((fSlow4 * fRec1[1]) - (fTemp0 + fVec0[1]))));
      fRec0[0] = (fRec1[0] - (fSlow2 * ((fSlow5 * fRec0[2]) + (fSlow6 * fRec0[1]))));
      output0[i] = FAUSTFLOAT((fSlow2 * (fRec0[2] + (fRec0[0] + (2.0 * fRec0[1])))));
      fVec0[1] = fVec0[0];
      fRec1[1] = fRec1[0];
      fRec0[2] = fRec0[1];
      fRec0[1] = fRec0[0];
    }
  }
};

// Generated with process = fi.lowpass(4, ma.SR*hslider("FCFactor", 0.4, 0.4, 0.5, 0.01)/hslider("Factor", 2, 2, 8, 1));
template <class fVslider0, int fVslider1, typename REAL>
struct LowPass4 : public Filter<fVslider0, fVslider1> {

  REAL fRec1[3];
  REAL fRec0[3];

  inline REAL LowPass4_faustpower2_f(REAL value)
  {
    return (value * value);
  }

  LowPass4()
  {
    for (int l0 = 0; (l0 < 3); l0 = (l0 + 1)) {
      fRec1[l0] = 0.0f;
    }
    for (int l1 = 0; (l1 < 3); l1 = (l1 + 1)) {
      fRec0[l1] = 0.0f;
    }
  }

  inline void compute(int count, FAUSTFLOAT* input0, FAUSTFLOAT* output0)
  {
    // Computed at template specialization time
    REAL fSlow0 = std::tan((3.1415926535897931 * (REAL(fVslider0::value()) / REAL(fVslider1))));
    REAL fSlow1 = (1.0 / fSlow0);
    REAL fSlow2 = (1.0 / (((fSlow1 + 0.76536686473017945) / fSlow0) + 1.0));
    REAL fSlow3 = (1.0 / (((fSlow1 + 1.8477590650225735) / fSlow0) + 1.0));
    REAL fSlow4 = (((fSlow1 + -1.8477590650225735) / fSlow0) + 1.0);
    REAL fSlow5 = (2.0 * (1.0 - (1.0 / LowPass4_faustpower2_f(fSlow0))));
    REAL fSlow6 = (((fSlow1 + -0.76536686473017945) / fSlow0) + 1.0);
    // Computed at runtime
    for (int i = 0; (i < count); i = (i + 1)) {
      fRec1[0] = (REAL(input0[i]) - (fSlow3 * ((fSlow4 * fRec1[2]) + (fSlow5 * fRec1[1]))));
      fRec0[0] = ((fSlow3 * (fRec1[2] + (fRec1[0] + (2.0 * fRec1[1])))) - (fSlow2 * ((fSlow6 * fRec0[2]) + (fSlow5 * fRec0[1]))));
      output0[i] = FAUSTFLOAT((fSlow2 * (fRec0[2] + (fRec0[0] + (2.0 * fRec0[1])))));
      fRec1[2] = fRec1[1];
      fRec1[1] = fRec1[0];
      fRec0[2] = fRec0[1];
      fRec0[1] = fRec0[0];
    }
  }
};

// Generated with process = fi.lowpass3e(ma.SR*hslider("FCFactor", 0.4, 0.4, 0.5, 0.01)/hslider("Factor", 2, 2, 8, 1));
template <class fVslider0, int fVslider1, typename REAL>
struct LowPass3e : public Filter<fVslider0, fVslider1> {

  REAL fRec1[3];
  REAL fVec0[2];
  REAL fRec0[2];

  inline REAL LowPass3e_faustpower2_f(REAL value)
  {
    return (value * value);
  }

  LowPass3e()
  {
    for (int l0 = 0; (l0 < 3); l0 = (l0 + 1)) {
      fRec1[l0] = 0.0;
    }
    for (int l1 = 0; (l1 < 2); l1 = (l1 + 1)) {
      fVec0[l1] = 0.0;
    }
    for (int l2 = 0; (l2 < 2); l2 = (l2 + 1)) {
      fRec0[l2] = 0.0;
    }
  }

  inline void compute(int count, FAUSTFLOAT* input0, FAUSTFLOAT* output0)
  {
    // Computed at template specialization time
    REAL fSlow0 = std::tan((3.1415926535897931 * (REAL(fVslider0::value()) / REAL(fVslider1))));
    REAL fSlow1 = (1.0 / fSlow0);
    REAL fSlow2 = (1.0 / (fSlow1 + 0.82244590899881598));
    REAL fSlow3 = (0.82244590899881598 - fSlow1);
    REAL fSlow4 = (1.0 / (((fSlow1 + 0.80263676416103003) / fSlow0) + 1.4122708937742039));
    REAL fSlow5 = LowPass3e_faustpower2_f(fSlow0);
    REAL fSlow6 = (0.019809144837788999 / fSlow5);
    REAL fSlow7 = (fSlow6 + 1.1615164189826961);
    REAL fSlow8 = (((fSlow1 + -0.80263676416103003) / fSlow0) + 1.4122708937742039);
    REAL fSlow9 = (2.0 * (1.4122708937742039 - (1.0 / fSlow5)));
    REAL fSlow10 = (2.0 * (1.1615164189826961 - fSlow6));
    // Computed at runtime
    for (int i = 0; (i < count); i = (i + 1)) {
      fRec1[0] = (REAL(input0[i]) - (fSlow4 * ((fSlow8 * fRec1[2]) + (fSlow9 * fRec1[1]))));
      REAL fTemp0 = (fSlow4 * (((fSlow7 * fRec1[0]) + (fSlow10 * fRec1[1])) + (fSlow7 * fRec1[2])));
      fVec0[0] = fTemp0;
      fRec0[0] = (0.0 - (fSlow2 * ((fSlow3 * fRec0[1]) - (fTemp0 + fVec0[1]))));
      output0[i] = FAUSTFLOAT(fRec0[0]);
      fRec1[2] = fRec1[1];
      fRec1[1] = fRec1[0];
      fVec0[1] = fVec0[0];
      fRec0[1] = fRec0[0];
    }
  }
};

// Generated with process = fi.lowpass6e(ma.SR*hslider("FCFactor", 0.4, 0.4, 0.5, 0.01)/hslider("Factor", 2, 2, 8, 1));
template <class fVslider0, int fVslider1, typename REAL>
struct LowPass6e : public Filter<fVslider0, fVslider1> {

  REAL fRec2[3];
  REAL fRec1[3];
  REAL fRec0[3];

  inline REAL LowPass6e_faustpower2_f(REAL value)
  {
    return (value * value);
  }

  LowPass6e()
  {
    for (int l0 = 0; (l0 < 3); l0 = (l0 + 1)) {
      fRec2[l0] = 0.0;
    }
    for (int l1 = 0; (l1 < 3); l1 = (l1 + 1)) {
      fRec1[l1] = 0.0;
    }
    for (int l2 = 0; (l2 < 3); l2 = (l2 + 1)) {
      fRec0[l2] = 0.0;
    }
  }

  inline void compute(int count, FAUSTFLOAT* input0, FAUSTFLOAT* output0)
  {
    // Computed at template specialization time
    REAL fSlow0 = std::tan((3.1415926535897931 * (REAL(fVslider0::value()) / REAL(fVslider1))));
    REAL fSlow1 = (1.0 / fSlow0);
    REAL fSlow2 = (1.0 / (((fSlow1 + 0.16840487111358901) / fSlow0) + 1.0693584077073119));
    REAL fSlow3 = LowPass6e_faustpower2_f(fSlow0);
    REAL fSlow4 = (1.0 / fSlow3);
    REAL fSlow5 = (fSlow4 + 53.536152954556727);
    REAL fSlow6 = (1.0 / (((fSlow1 + 0.51247864188914105) / fSlow0) + 0.68962136448467504));
    REAL fSlow7 = (fSlow4 + 7.6217312988706034);
    REAL fSlow8 = (1.0 / (((fSlow1 + 0.78241304682164503) / fSlow0) + 0.24529150870616001));
    REAL fSlow9 = (9.9999997054999994e-05 / fSlow3);
    REAL fSlow10 = (fSlow9 + 0.00043322720055500002);
    REAL fSlow11 = (((fSlow1 + -0.78241304682164503) / fSlow0) + 0.24529150870616001);
    REAL fSlow12 = (2.0 * (0.24529150870616001 - fSlow4));
    REAL fSlow13 = (2.0 * (0.00043322720055500002 - fSlow9));
    REAL fSlow14 = (((fSlow1 + -0.51247864188914105) / fSlow0) + 0.68962136448467504);
    REAL fSlow15 = (2.0 * (0.68962136448467504 - fSlow4));
    REAL fSlow16 = (2.0 * (7.6217312988706034 - fSlow4));
    REAL fSlow17 = (((fSlow1 + -0.16840487111358901) / fSlow0) + 1.0693584077073119);
    REAL fSlow18 = (2.0 * (1.0693584077073119 - fSlow4));
    REAL fSlow19 = (2.0 * (53.536152954556727 - fSlow4));
    // Computed at runtime
    for (int i = 0; (i < count); i = (i + 1)) {
      fRec2[0] = (REAL(input0[i]) - (fSlow8 * ((fSlow11 * fRec2[2]) + (fSlow12 * fRec2[1]))));
      fRec1[0] = ((fSlow8 * (((fSlow10 * fRec2[0]) + (fSlow13 * fRec2[1])) + (fSlow10 * fRec2[2]))) - (fSlow6 * ((fSlow14 * fRec1[2]) + (fSlow15 * fRec1[1]))));
      fRec0[0] = ((fSlow6 * (((fSlow7 * fRec1[0]) + (fSlow16 * fRec1[1])) + (fSlow7 * fRec1[2]))) - (fSlow2 * ((fSlow17 * fRec0[2]) + (fSlow18 * fRec0[1]))));
      output0[i] = FAUSTFLOAT((fSlow2 * (((fSlow5 * fRec0[0]) + (fSlow19 * fRec0[1])) + (fSlow5 * fRec0[2]))));
      fRec2[2] = fRec2[1];
      fRec2[1] = fRec2[0];
      fRec1[2] = fRec1[1];
      fRec1[1] = fRec1[0];
      fRec0[2] = fRec0[1];
      fRec0[1] = fRec0[0];
    }
  }
};

// A "si.bus(N)" like hard-coded class
struct dsp_bus : public dsp {

  int fChannels;
  int fSampleRate;

  dsp_bus(int channels): fChannels(channels), fSampleRate(-1)
  {}

  virtual int getNumInputs() {
    return fChannels;
  }
  virtual int getNumOutputs() {
    return fChannels;
  }

  virtual int getSampleRate() {
    return fSampleRate;
  }

  virtual void buildUserInterface(UI* ui_interface) {}
  virtual void init(int sample_rate)
  {
    //classInit(sample_rate);
    instanceInit(sample_rate);
  }

  virtual void instanceInit(int sample_rate)
  {
    fSampleRate = sample_rate;
    instanceConstants(sample_rate);
    instanceResetUserInterface();
    instanceClear();
  }

  virtual void instanceConstants(int sample_rate) {}
  virtual void instanceResetUserInterface() {}
  virtual void instanceClear() {}

  virtual dsp* clone() {
    return new dsp_bus(fChannels);
  }

  virtual void metadata(Meta* m) {}

  virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
  {
    for (int chan = 0; chan < fChannels; chan++) {
      memcpy(outputs[chan], inputs[chan], sizeof(FAUSTFLOAT) * count);
    }
  }

  virtual void compute(double /*date_usec*/, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
  {
    compute(count, inputs, outputs);
  }

};

// Base class for sample-rate adapter
template <typename FILTER>
class sr_sampler : public decorator_dsp {

  protected:

    std::vector<FILTER> fInputLowPass;
    std::vector<FILTER> fOutputLowPass;

    inline int getFactor() {
      return this->fOutputLowPass[0].getFactor();
    }

  public:

    sr_sampler(dsp* dsp): decorator_dsp(dsp)
    {
      for (int chan = 0; chan < fDSP->getNumInputs(); chan++) {
        fInputLowPass.push_back(FILTER());
      }
      for (int chan = 0; chan < fDSP->getNumOutputs(); chan++) {
        fOutputLowPass.push_back(FILTER());
      }
    }
};

// Down sample-rate adapter
template <typename FILTER>
class dsp_down_sampler : public sr_sampler<FILTER> {

  public:

    dsp_down_sampler(dsp* dsp): sr_sampler<FILTER>(dsp)
    {}

    virtual void init(int sample_rate)
    {
      this->fDSP->init(sample_rate / this->getFactor());
    }

    virtual void instanceInit(int sample_rate)
    {
      this->fDSP->instanceInit(sample_rate / this->getFactor());
    }

    virtual void instanceConstants(int sample_rate)
    {
      this->fDSP->instanceConstants(sample_rate / this->getFactor());
    }

    virtual dsp_down_sampler* clone() {
      return new dsp_down_sampler(decorator_dsp::clone());
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      int real_count = count / this->getFactor();

      // Adapt inputs
      FAUSTFLOAT** fInputs = (FAUSTFLOAT**)alloca(this->fDSP->getNumInputs() * sizeof(FAUSTFLOAT*));
      for (int chan = 0; chan < this->fDSP->getNumInputs(); chan++) {
        // Lowpass filtering in place on 'inputs'
        this->fInputLowPass[chan].compute(count, inputs[chan], inputs[chan]);
        // Allocate fInputs with 'real_count' frames
        fInputs[chan] = (FAUSTFLOAT*)alloca(sizeof(FAUSTFLOAT) * real_count);
        // Decimate
        for (int frame = 0; frame < real_count; frame++) {
          fInputs[chan][frame] = inputs[chan][frame * this->getFactor()];
        }
      }

      // Allocate fOutputs with 'real_count' frames
      FAUSTFLOAT** fOutputs = (FAUSTFLOAT**)alloca(this->fDSP->getNumOutputs() * sizeof(FAUSTFLOAT*));
      for (int chan = 0; chan < this->fDSP->getNumOutputs(); chan++) {
        fOutputs[chan] = (FAUSTFLOAT*)alloca(sizeof(FAUSTFLOAT) * real_count);
      }

      // Compute at lower rate
      this->fDSP->compute(real_count, fInputs, fOutputs);

      // Adapt outputs
      for (int chan = 0; chan < this->fDSP->getNumOutputs(); chan++) {
        // Puts zeros
        memset(outputs[chan], 0, sizeof(FAUSTFLOAT) * count);
        for (int frame = 0; frame < real_count; frame++) {
          // Copy one sample every 'DownFactor'
          // Apply volume
          //outputs[chan][frame * this->getFactor()] = fOutputs[chan][frame] * this->getFactor();
          outputs[chan][frame * this->getFactor()] = fOutputs[chan][frame];
        }
        // Lowpass filtering in place on 'outputs'
        this->fOutputLowPass[chan].compute(count, outputs[chan], outputs[chan]);
      }
    }

    virtual void compute(double /*date_usec*/, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }
};

// Up sample-rate adapter
template <typename FILTER>
class dsp_up_sampler : public sr_sampler<FILTER> {

  public:

    dsp_up_sampler(dsp* dsp): sr_sampler<FILTER>(dsp)
    {}

    virtual void init(int sample_rate)
    {
      this->fDSP->init(sample_rate * this->getFactor());
    }

    virtual void instanceInit(int sample_rate)
    {
      this->fDSP->instanceInit(sample_rate * this->getFactor());
    }

    virtual void instanceConstants(int sample_rate)
    {
      this->fDSP->instanceConstants(sample_rate * this->getFactor());
    }

    virtual dsp_up_sampler* clone() {
      return new dsp_up_sampler(decorator_dsp::clone());
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      int real_count = count * this->getFactor();

      // Adapt inputs
      FAUSTFLOAT** fInputs = (FAUSTFLOAT**)alloca(this->fDSP->getNumInputs() * sizeof(FAUSTFLOAT*));

      for (int chan = 0; chan < this->fDSP->getNumInputs(); chan++) {
        // Allocate fInputs with 'real_count' frames
        fInputs[chan] = (FAUSTFLOAT*)alloca(sizeof(FAUSTFLOAT) * real_count);
        // Puts zeros
        memset(fInputs[chan], 0, sizeof(FAUSTFLOAT) * real_count);
        for (int frame = 0; frame < count; frame++) {
          // Copy one sample every 'UpFactor'
          fInputs[chan][frame * this->getFactor()] = inputs[chan][frame];
        }
        // Lowpass filtering in place on 'fInputs'
        this->fInputLowPass[chan].compute(real_count, fInputs[chan], fInputs[chan]);
      }

      // Allocate fOutputs with 'real_count' frames
      FAUSTFLOAT** fOutputs = (FAUSTFLOAT**)alloca(this->fDSP->getNumOutputs() * sizeof(FAUSTFLOAT*));

      for (int chan = 0; chan < this->fDSP->getNumOutputs(); chan++) {
        fOutputs[chan] = (FAUSTFLOAT*)alloca(sizeof(FAUSTFLOAT) * real_count);
      }

      // Compute at upper rate
      this->fDSP->compute(real_count, fInputs, fOutputs);

      // Adapt outputs
      for (int chan = 0; chan < this->fDSP->getNumOutputs(); chan++) {
        // Lowpass filtering in place on 'fOutputs'
        this->fOutputLowPass[chan].compute(real_count, fOutputs[chan], fOutputs[chan]);
        // Decimate
        for (int frame = 0; frame < count; frame++) {
          // Apply volume
          //outputs[chan][frame] = fOutputs[chan][frame * this->getFactor()] * this->getFactor();
          outputs[chan][frame] = fOutputs[chan][frame * this->getFactor()];
        }
      }
    }

    virtual void compute(double /*date_usec*/, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      compute(count, inputs, outputs);
    }
};

// Create a UP/DS + Filter adapted DSP
template <typename REAL>
dsp* createSRAdapter(dsp* DSP, int ds = 0, int us = 0, int filter = 0)
{
  if (ds > 0) {
    switch (filter) {
      case 0:
        if (ds == 2) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 2>>(DSP);
        } else if (ds == 3) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 3>>(DSP);
        } else if (ds == 4) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 4>>(DSP);
        } else if (ds == 8) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 8>>(DSP);
        } else if (ds == 16) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 16>>(DSP);
        } else if (ds == 32) {
          return new dsp_down_sampler<Identity<Double<1, 1>, 32>>(DSP);
        } else {
          fprintf(stderr, "ERROR : ds factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 1:
        if (ds == 2) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 2, REAL>>(DSP);
        } else if (ds == 3) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 3, REAL>>(DSP);
        } else if (ds == 4) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 4, REAL>>(DSP);
        } else if (ds == 8) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 8, REAL>>(DSP);
        } else if (ds == 16) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 16, REAL>>(DSP);
        } else if (ds == 32) {
          return new dsp_down_sampler<LowPass3<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : ds factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 2:
        if (ds == 2) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 2, REAL>>(DSP);
        } else if (ds == 3) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 3, REAL>>(DSP);
        } else if (ds == 4) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 4, REAL>>(DSP);
        } else if (ds == 8) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 8, REAL>>(DSP);
        } else if (ds == 16) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 16, REAL>>(DSP);
        } else if (ds == 32) {
          return new dsp_down_sampler<LowPass4<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : ds factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 3:
        if (ds == 2) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 2, REAL>>(DSP);
        } else if (ds == 3) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 3, REAL>>(DSP);
        } else if (ds == 4) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 4, REAL>>(DSP);
        } else if (ds == 8) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 8, REAL>>(DSP);
        } else if (ds == 16) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 16, REAL>>(DSP);
        } else if (ds == 32) {
          return new dsp_down_sampler<LowPass3e<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : ds factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 4:
        if (ds == 2) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 2, REAL>>(DSP);
        } else if (ds == 3) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 3, REAL>>(DSP);
        } else if (ds == 4) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 4, REAL>>(DSP);
        } else if (ds == 8) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 8, REAL>>(DSP);
        } else if (ds == 16) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 16, REAL>>(DSP);
        } else if (ds == 32) {
          return new dsp_down_sampler<LowPass6e<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : ds factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      default:
        fprintf(stderr, "ERROR : filter type must be in [0..4] range\n");
        assert(false);
        return nullptr;
    }
  } else if (us > 0) {

    switch (filter) {
      case 0:
        if (us == 2) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 2>>(DSP);
        } else if (us == 3) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 3>>(DSP);
        } else if (us == 4) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 4>>(DSP);
        } else if (us == 8) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 8>>(DSP);
        } else if (us == 16) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 16>>(DSP);
        } else if (us == 32) {
          return new dsp_up_sampler<Identity<Double<1, 1>, 32>>(DSP);
        } else {
          fprintf(stderr, "ERROR : us factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 1:
        if (us == 2) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 2, REAL>>(DSP);
        } else if (us == 3) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 3, REAL>>(DSP);
        } else if (us == 4) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 4, REAL>>(DSP);
        } else if (us == 8) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 8, REAL>>(DSP);
        } else if (us == 16) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 16, REAL>>(DSP);
        } else if (us == 32) {
          return new dsp_up_sampler<LowPass3<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : us factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 2:
        if (us == 2) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 2, REAL>>(DSP);
        } else if (us == 3) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 3, REAL>>(DSP);
        } else if (us == 4) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 4, REAL>>(DSP);
        } else if (us == 8) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 8, REAL>>(DSP);
        } else if (us == 16) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 16, REAL>>(DSP);
        } else if (us == 32) {
          return new dsp_up_sampler<LowPass4<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : us factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 3:
        if (us == 2) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 2, REAL>>(DSP);
        } else if (us == 3) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 3, REAL>>(DSP);
        } else if (us == 4) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 4, REAL>>(DSP);
        } else if (us == 8) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 8, REAL>>(DSP);
        } else if (us == 16) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 16, REAL>>(DSP);
        } else if (us == 32) {
          return new dsp_up_sampler<LowPass3e<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : us factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      case 4:
        if (us == 2) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 2, REAL>>(DSP);
        } else if (us == 3) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 3, REAL>>(DSP);
        } else if (us == 4) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 4, REAL>>(DSP);
        } else if (us == 8) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 8, REAL>>(DSP);
        } else if (us == 16) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 16, REAL>>(DSP);
        } else if (us == 32) {
          return new dsp_up_sampler<LowPass6e<Double<45, 100>, 32, REAL>>(DSP);
        } else {
          fprintf(stderr, "ERROR : us factor type must be in [2..32] range\n");
          assert(false);
          return nullptr;
        }
      default:
        fprintf(stderr, "ERROR : filter type must be in [0..4] range\n");
        assert(false);
        return nullptr;
    }
  } else {
    return DSP;
  }
}

#endif
/************************** END dsp-adapter.h **************************/
/************************** BEGIN proxy-dsp.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __proxy_dsp__
#define __proxy_dsp__

#include <vector>
#include <map>

/************************** BEGIN JSONUIDecoder.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2020 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __JSONUIDecoder__
#define __JSONUIDecoder__

#include <vector>
#include <map>
#include <utility>
#include <cstdlib>
#include <sstream>
#include <functional>

/************************** BEGIN CGlue.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2018 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef CGLUE_H
#define CGLUE_H

/************************** BEGIN CInterface.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2018 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef CINTERFACE_H
#define CINTERFACE_H

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

struct Soundfile;

/*******************************************************************************
   UI, Meta and MemoryManager structures for C code.
 ******************************************************************************/

// -- widget's layouts

typedef void (* openTabBoxFun) (void* ui_interface, const char* label);
typedef void (* openHorizontalBoxFun) (void* ui_interface, const char* label);
typedef void (* openVerticalBoxFun) (void* ui_interface, const char* label);
typedef void (* closeBoxFun) (void* ui_interface);

// -- active widgets

typedef void (* addButtonFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone);
typedef void (* addCheckButtonFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone);
typedef void (* addVerticalSliderFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step);
typedef void (* addHorizontalSliderFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step);
typedef void (* addNumEntryFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step);

// -- passive widgets

typedef void (* addHorizontalBargraphFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max);
typedef void (* addVerticalBargraphFun) (void* ui_interface, const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max);

// -- soundfiles

typedef void (* addSoundfileFun) (void* ui_interface, const char* label, const char* url, struct Soundfile** sf_zone);

typedef void (* declareFun) (void* ui_interface, FAUSTFLOAT* zone, const char* key, const char* value);

typedef struct {

  void* uiInterface;

  openTabBoxFun openTabBox;
  openHorizontalBoxFun openHorizontalBox;
  openVerticalBoxFun openVerticalBox;
  closeBoxFun closeBox;
  addButtonFun addButton;
  addCheckButtonFun addCheckButton;
  addVerticalSliderFun addVerticalSlider;
  addHorizontalSliderFun addHorizontalSlider;
  addNumEntryFun addNumEntry;
  addHorizontalBargraphFun addHorizontalBargraph;
  addVerticalBargraphFun addVerticalBargraph;
  addSoundfileFun addSoundfile;
  declareFun declare;

} UIGlue;

typedef void (* metaDeclareFun) (void* ui_interface, const char* key, const char* value);

typedef struct {

  void* metaInterface;

  metaDeclareFun declare;

} MetaGlue;

/***************************************
    Interface for the DSP object
 ***************************************/

typedef char dsp_imp;

typedef dsp_imp* (* newDspFun) ();
typedef void (* destroyDspFun) (dsp_imp* dsp);
typedef int (* getNumInputsFun) (dsp_imp* dsp);
typedef int (* getNumOutputsFun) (dsp_imp* dsp);
typedef void (* buildUserInterfaceFun) (dsp_imp* dsp, UIGlue* ui);
typedef int (* getSampleRateFun) (dsp_imp* dsp);
typedef void (* initFun) (dsp_imp* dsp, int sample_rate);
typedef void (* classInitFun) (int sample_rate);
typedef void (* instanceInitFun) (dsp_imp* dsp, int sample_rate);
typedef void (* instanceConstantsFun) (dsp_imp* dsp, int sample_rate);
typedef void (* instanceResetUserInterfaceFun) (dsp_imp* dsp);
typedef void (* instanceClearFun) (dsp_imp* dsp);
typedef void (* computeFun) (dsp_imp* dsp, int len, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs);
typedef void (* metadataFun) (MetaGlue* meta);

/***************************************
   DSP memory manager functions
 ***************************************/

typedef void* (* allocateFun) (void* manager_interface, size_t size);
typedef void (* destroyFun) (void* manager_interface, void* ptr);

typedef struct {

  void* managerInterface;

  allocateFun allocate;
  destroyFun destroy;

} MemoryManagerGlue;

#ifdef __cplusplus
}
#endif

#endif
/**************************  END  CInterface.h **************************/

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
   UI glue code
 ******************************************************************************/

class UIFloat
{

  public:

    UIFloat() {}

    virtual ~UIFloat() {}

    // -- widget's layouts

    virtual void openTabBox(const char* label) = 0;
    virtual void openHorizontalBox(const char* label) = 0;
    virtual void openVerticalBox(const char* label) = 0;
    virtual void closeBox() = 0;

    // -- active widgets

    virtual void addButton(const char* label, float* zone) = 0;
    virtual void addCheckButton(const char* label, float* zone) = 0;
    virtual void addVerticalSlider(const char* label, float* zone, float init, float min, float max, float step) = 0;
    virtual void addHorizontalSlider(const char* label, float* zone, float init, float min, float max, float step) = 0;
    virtual void addNumEntry(const char* label, float* zone, float init, float min, float max, float step) = 0;

    // -- passive widgets

    virtual void addHorizontalBargraph(const char* label, float* zone, float min, float max) = 0;
    virtual void addVerticalBargraph(const char* label, float* zone, float min, float max) = 0;

    // -- soundfiles

    virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) = 0;

    // -- metadata declarations

    virtual void declare(float* zone, const char* key, const char* val) {}
};

static void openTabBoxGlueFloat(void* cpp_interface, const char* label)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->openTabBox(label);
}

static void openHorizontalBoxGlueFloat(void* cpp_interface, const char* label)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->openHorizontalBox(label);
}

static void openVerticalBoxGlueFloat(void* cpp_interface, const char* label)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->openVerticalBox(label);
}

static void closeBoxGlueFloat(void* cpp_interface)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->closeBox();
}

static void addButtonGlueFloat(void* cpp_interface, const char* label, float* zone)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addButton(label, zone);
}

static void addCheckButtonGlueFloat(void* cpp_interface, const char* label, float* zone)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addCheckButton(label, zone);
}

static void addVerticalSliderGlueFloat(void* cpp_interface, const char* label, float* zone, float init, float min, float max, float step)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addVerticalSlider(label, zone, init, min, max, step);
}

static void addHorizontalSliderGlueFloat(void* cpp_interface, const char* label, float* zone, float init, float min, float max, float step)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addHorizontalSlider(label, zone, init, min, max, step);
}

static void addNumEntryGlueFloat(void* cpp_interface, const char* label, float* zone, float init, float min, float max, float step)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addNumEntry(label, zone, init, min, max, step);
}

static void addHorizontalBargraphGlueFloat(void* cpp_interface, const char* label, float* zone, float min, float max)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addHorizontalBargraph(label, zone, min, max);
}

static void addVerticalBargraphGlueFloat(void* cpp_interface, const char* label, float* zone, float min, float max)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addVerticalBargraph(label, zone, min, max);
}

static void addSoundfileGlueFloat(void* cpp_interface, const char* label, const char* url, Soundfile** sf_zone)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->addSoundfile(label, url, sf_zone);
}

static void declareGlueFloat(void* cpp_interface, float* zone, const char* key, const char* value)
{
  UIFloat* ui_interface = static_cast<UIFloat*>(cpp_interface);
  ui_interface->declare(zone, key, value);
}

class UIDouble
{

  public:

    UIDouble() {}

    virtual ~UIDouble() {}

    // -- widget's layouts

    virtual void openTabBox(const char* label) = 0;
    virtual void openHorizontalBox(const char* label) = 0;
    virtual void openVerticalBox(const char* label) = 0;
    virtual void closeBox() = 0;

    // -- active widgets

    virtual void addButton(const char* label, double* zone) = 0;
    virtual void addCheckButton(const char* label, double* zone) = 0;
    virtual void addVerticalSlider(const char* label, double* zone, double init, double min, double max, double step) = 0;
    virtual void addHorizontalSlider(const char* label, double* zone, double init, double min, double max, double step) = 0;
    virtual void addNumEntry(const char* label, double* zone, double init, double min, double max, double step) = 0;

    // -- passive widgets

    virtual void addHorizontalBargraph(const char* label, double* zone, double min, double max) = 0;
    virtual void addVerticalBargraph(const char* label, double* zone, double min, double max) = 0;

    // -- soundfiles

    virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) = 0;

    // -- metadata declarations

    virtual void declare(double* zone, const char* key, const char* val) {}
};

static void openTabBoxGlueDouble(void* cpp_interface, const char* label)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->openTabBox(label);
}

static void openHorizontalBoxGlueDouble(void* cpp_interface, const char* label)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->openHorizontalBox(label);
}

static void openVerticalBoxGlueDouble(void* cpp_interface, const char* label)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->openVerticalBox(label);
}

static void closeBoxGlueDouble(void* cpp_interface)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->closeBox();
}

static void addButtonGlueDouble(void* cpp_interface, const char* label, double* zone)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addButton(label, zone);
}

static void addCheckButtonGlueDouble(void* cpp_interface, const char* label, double* zone)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addCheckButton(label, zone);
}

static void addVerticalSliderGlueDouble(void* cpp_interface, const char* label, double* zone, double init, double min, double max, double step)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addVerticalSlider(label, zone, init, min, max, step);
}

static void addHorizontalSliderGlueDouble(void* cpp_interface, const char* label, double* zone, double init, double min, double max, double step)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addHorizontalSlider(label, zone, init, min, max, step);
}

static void addNumEntryGlueDouble(void* cpp_interface, const char* label, double* zone, double init, double min, double max, double step)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addNumEntry(label, zone, init, min, max, step);
}

static void addHorizontalBargraphGlueDouble(void* cpp_interface, const char* label, double* zone, double min, double max)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addHorizontalBargraph(label, zone, min, max);
}

static void addVerticalBargraphGlueDouble(void* cpp_interface, const char* label, double* zone, double min, double max)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addVerticalBargraph(label, zone, min, max);
}

static void addSoundfileGlueDouble(void* cpp_interface, const char* label, const char* url, Soundfile** sf_zone)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->addSoundfile(label, url, sf_zone);
}

static void declareGlueDouble(void* cpp_interface, double* zone, const char* key, const char* value)
{
  UIDouble* ui_interface = static_cast<UIDouble*>(cpp_interface);
  ui_interface->declare(zone, key, value);
}

static void buildUIGlue(UIGlue* glue, UI* ui_interface, bool is_double)
{
  glue->uiInterface = ui_interface;

  if (is_double) {
    glue->openTabBox = reinterpret_cast<openTabBoxFun>(openTabBoxGlueDouble);
    glue->openHorizontalBox = reinterpret_cast<openHorizontalBoxFun>(openHorizontalBoxGlueDouble);
    glue->openVerticalBox = reinterpret_cast<openVerticalBoxFun>(openVerticalBoxGlueDouble);
    glue->closeBox = reinterpret_cast<closeBoxFun>(closeBoxGlueDouble);
    glue->addButton = reinterpret_cast<addButtonFun>(addButtonGlueDouble);
    glue->addCheckButton = reinterpret_cast<addCheckButtonFun>(addCheckButtonGlueDouble);
    glue->addVerticalSlider = reinterpret_cast<addVerticalSliderFun>(addVerticalSliderGlueDouble);
    glue->addHorizontalSlider = reinterpret_cast<addHorizontalSliderFun>(addHorizontalSliderGlueDouble);
    glue->addNumEntry = reinterpret_cast<addNumEntryFun>(addNumEntryGlueDouble);
    glue->addHorizontalBargraph = reinterpret_cast<addHorizontalBargraphFun>(addHorizontalBargraphGlueDouble);
    glue->addVerticalBargraph = reinterpret_cast<addVerticalBargraphFun>(addVerticalBargraphGlueDouble);
    glue->addSoundfile = reinterpret_cast<addSoundfileFun>(addSoundfileGlueDouble);
    glue->declare = reinterpret_cast<declareFun>(declareGlueDouble);
  } else {
    glue->openTabBox = reinterpret_cast<openTabBoxFun>(openTabBoxGlueFloat);
    glue->openHorizontalBox = reinterpret_cast<openHorizontalBoxFun>(openHorizontalBoxGlueFloat);
    glue->openVerticalBox = reinterpret_cast<openVerticalBoxFun>(openVerticalBoxGlueFloat);
    glue->closeBox = reinterpret_cast<closeBoxFun>(closeBoxGlueFloat);
    glue->addButton = reinterpret_cast<addButtonFun>(addButtonGlueFloat);
    glue->addCheckButton = reinterpret_cast<addCheckButtonFun>(addCheckButtonGlueFloat);
    glue->addVerticalSlider = reinterpret_cast<addVerticalSliderFun>(addVerticalSliderGlueFloat);
    glue->addHorizontalSlider = reinterpret_cast<addHorizontalSliderFun>(addHorizontalSliderGlueFloat);
    glue->addNumEntry = reinterpret_cast<addNumEntryFun>(addNumEntryGlueFloat);
    glue->addHorizontalBargraph = reinterpret_cast<addHorizontalBargraphFun>(addHorizontalBargraphGlueFloat);
    glue->addVerticalBargraph = reinterpret_cast<addVerticalBargraphFun>(addVerticalBargraphGlueFloat);
    glue->addSoundfile = reinterpret_cast<addSoundfileFun>(addSoundfileGlueFloat);
    glue->declare = reinterpret_cast<declareFun>(declareGlueFloat);
  }
}

struct UITemplate
{

  void* fCPPInterface;

  UITemplate(void* cpp_interface): fCPPInterface(cpp_interface)
  {}

  virtual ~UITemplate() {}

  // -- widget's layouts

  virtual void openTabBox(const char* label)
  {
    openTabBoxGlueFloat(fCPPInterface, label);
  }
  virtual void openHorizontalBox(const char* label)
  {
    openHorizontalBoxGlueFloat(fCPPInterface, label);
  }
  virtual void openVerticalBox(const char* label)
  {
    openVerticalBoxGlueFloat(fCPPInterface, label);
  }
  virtual void closeBox()
  {
    closeBoxGlueFloat(fCPPInterface);
  }

  // float version

  // -- active widgets

  virtual void addButton(const char* label, float* zone)
  {
    addButtonGlueFloat(fCPPInterface, label, zone);
  }
  virtual void addCheckButton(const char* label, float* zone)
  {
    addCheckButtonGlueFloat(fCPPInterface, label, zone);
  }

  virtual void addVerticalSlider(const char* label, float* zone, float init, float min, float max, float step)
  {
    addVerticalSliderGlueFloat(fCPPInterface, label, zone, init, min, max, step);
  }

  virtual void addHorizontalSlider(const char* label, float* zone, float init, float min, float max, float step)
  {
    addHorizontalSliderGlueFloat(fCPPInterface, label, zone, init, min, max, step);
  }

  virtual void addNumEntry(const char* label, float* zone, float init, float min, float max, float step)
  {
    addNumEntryGlueFloat(fCPPInterface, label, zone, init, min, max, step);
  }

  // -- passive widgets

  virtual void addHorizontalBargraph(const char* label, float* zone, float min, float max)
  {
    addHorizontalBargraphGlueFloat(fCPPInterface, label, zone, min, max);
  }

  virtual void addVerticalBargraph(const char* label, float* zone, float min, float max)
  {
    addVerticalBargraphGlueFloat(fCPPInterface, label, zone, min, max);
  }

  // -- metadata declarations

  virtual void declare(float* zone, const char* key, const char* val)
  {
    declareGlueFloat(fCPPInterface, zone, key, val);
  }

  // double version

  virtual void addButton(const char* label, double* zone)
  {
    addButtonGlueDouble(fCPPInterface, label, zone);
  }
  virtual void addCheckButton(const char* label, double* zone)
  {
    addCheckButtonGlueDouble(fCPPInterface, label, zone);
  }

  virtual void addVerticalSlider(const char* label, double* zone, double init, double min, double max, double step)
  {
    addVerticalSliderGlueDouble(fCPPInterface, label, zone, init, min, max, step);
  }

  virtual void addHorizontalSlider(const char* label, double* zone, double init, double min, double max, double step)
  {
    addHorizontalSliderGlueDouble(fCPPInterface, label, zone, init, min, max, step);
  }

  virtual void addNumEntry(const char* label, double* zone, double init, double min, double max, double step)
  {
    addNumEntryGlueDouble(fCPPInterface, label, zone, init, min, max, step);
  }

  // -- soundfiles

  virtual void addSoundfile(const char* label, const char* url, Soundfile** sf_zone)
  {
    addSoundfileGlueFloat(fCPPInterface, label, url, sf_zone);
  }

  // -- passive widgets

  virtual void addHorizontalBargraph(const char* label, double* zone, double min, double max)
  {
    addHorizontalBargraphGlueDouble(fCPPInterface, label, zone, min, max);
  }

  virtual void addVerticalBargraph(const char* label, double* zone, double min, double max)
  {
    addVerticalBargraphGlueDouble(fCPPInterface, label, zone, min, max);
  }

  // -- metadata declarations

  virtual void declare(double* zone, const char* key, const char* val)
  {
    declareGlueDouble(fCPPInterface, zone, key, val);
  }

};

/*******************************************************************************
   Meta glue code
 ******************************************************************************/

static void declareMetaGlue(void* cpp_interface, const char* key, const char* value)
{
  Meta* meta_interface = static_cast<Meta*>(cpp_interface);
  meta_interface->declare(key, value);
}

static void buildMetaGlue(MetaGlue* glue, Meta* meta)
{
  glue->metaInterface = meta;
  glue->declare = declareMetaGlue;
}

/*******************************************************************************
   Memory manager glue code
 ******************************************************************************/

static void* allocateMemoryManagerGlue(void* cpp_interface, size_t size)
{
  dsp_memory_manager* manager_interface = static_cast<dsp_memory_manager*>(cpp_interface);
  return manager_interface->allocate(size);
}

static void destroyMemoryManagerGlue(void* cpp_interface, void* ptr)
{
  dsp_memory_manager* manager_interface = static_cast<dsp_memory_manager*>(cpp_interface);
  manager_interface->destroy(ptr);
}

static void buildManagerGlue(MemoryManagerGlue* glue, dsp_memory_manager* manager)
{
  glue->managerInterface = manager;
  glue->allocate = allocateMemoryManagerGlue;
  glue->destroy = destroyMemoryManagerGlue;
}

#ifdef __cplusplus
}
#endif

#endif
/**************************  END  CGlue.h **************************/

#ifdef _WIN32
#include <windows.h>
#define snprintf _snprintf
#endif

//------------------------------------------------------------------------------------------
//  Decode a dsp JSON description and implement 'buildUserInterface' and 'metadata' methods
//------------------------------------------------------------------------------------------

#define REAL_UI(ui_interface) reinterpret_cast<UIReal<REAL>*>(ui_interface)
#define REAL_ADR(index)      reinterpret_cast<REAL*>(&memory_block[index])
#define REAL_EXT_ADR(index)  reinterpret_cast<FAUSTFLOAT*>(&memory_block[index])
#define SOUNDFILE_ADR(index) reinterpret_cast<Soundfile**>(&memory_block[index])

typedef std::function<void(double)> ReflectFunction;
typedef std::function<double()> ModifyFunction;

struct ExtZoneParam {

  virtual void reflectZone() = 0;
  virtual void modifyZone() = 0;

  virtual void setReflectZoneFun(ReflectFunction reflect) = 0;
  virtual void setModifyZoneFun(ModifyFunction modify) = 0;

  virtual ~ExtZoneParam()
  {}

};

// Templated decoder

struct JSONUIDecoderBase
{
  virtual ~JSONUIDecoderBase()
  {}

  virtual void metadata(Meta* m) = 0;
  virtual void metadata(MetaGlue* glue) = 0;
  virtual int getDSPSize() = 0;
  virtual std::string getName() = 0;
  virtual std::string getLibVersion() = 0;
  virtual std::string getCompileOptions() = 0;
  virtual std::vector<std::string> getLibraryList() = 0;
  virtual std::vector<std::string> getIncludePathnames() = 0;
  virtual int getNumInputs() = 0;
  virtual int getNumOutputs() = 0;
  virtual int getSampleRate(char* memory_block) = 0;
  virtual void setReflectZoneFun(int index, ReflectFunction fun) = 0;
  virtual void setModifyZoneFun(int index, ModifyFunction fun) = 0;
  virtual void setupDSPProxy(UI* ui_interface, char* memory_block) = 0;
  virtual bool hasDSPProxy() = 0;
  virtual std::vector<ExtZoneParam*>& getInputControls() = 0;
  virtual std::vector<ExtZoneParam*>& getOutputControls() = 0;
  virtual void resetUserInterface() = 0;
  virtual void resetUserInterface(char* memory_block, Soundfile* defaultsound = nullptr) = 0;
  virtual void buildUserInterface(UI* ui_interface) = 0;
  virtual void buildUserInterface(UI* ui_interface, char* memory_block) = 0;
  virtual void buildUserInterface(UIGlue* ui_interface, char* memory_block) = 0;
  virtual bool hasCompileOption(const std::string& option) = 0;
};

template <typename REAL>
struct JSONUIDecoderReal : public JSONUIDecoderBase {

    struct ZoneParam : public ExtZoneParam {

      FAUSTFLOAT fZone;
      ReflectFunction fReflect;
      ModifyFunction fModify;

#if defined(TARGET_OS_IPHONE) || defined(WIN32)
      ZoneParam(ReflectFunction reflect = nullptr, ModifyFunction modify = nullptr)
        : fReflect(reflect), fModify(modify)
      {}
      void reflectZone() {
        if (fReflect) fReflect(fZone);
      }
      void modifyZone() {
        if (fModify) fZone = fModify();
      }
#else
      ZoneParam(ReflectFunction reflect = [](REAL value) {}, ModifyFunction modify = []() {
        return REAL(-1);
      })
        : fReflect(reflect), fModify(modify)
      {}
      void reflectZone() {
        fReflect(fZone);
      }
      void modifyZone() {
        fZone = fModify();
      }
#endif

      void setReflectZoneFun(ReflectFunction reflect) {
        fReflect = reflect;
      }
      void setModifyZoneFun(ModifyFunction modify) {
        fModify = modify;
      }

    };

    typedef std::vector<ExtZoneParam*> controlMap;

    std::string fName;
    std::string fFileName;
    std::string fJSON;
    std::string fVersion;
    std::string fCompileOptions;

    std::map<std::string, std::string> fMetadata;
    std::vector<itemInfo> fUiItems;

    std::vector<std::string> fLibraryList;
    std::vector<std::string> fIncludePathnames;

    int fNumInputs, fNumOutputs, fSRIndex;
    int fDSPSize;
    bool fDSPProxy;

    controlMap fPathInputTable;     // [path, ZoneParam]
    controlMap fPathOutputTable;    // [path, ZoneParam]

    bool startWith(const std::string& str, const std::string& prefix)
    {
      return (str.substr(0, prefix.size()) == prefix);
    }

    bool isInput(const std::string& type)
    {
      return (type == "vslider" || type == "hslider" || type == "nentry" || type == "button" || type == "checkbox");
    }
    bool isOutput(const std::string& type) {
      return (type == "hbargraph" || type == "vbargraph");
    }
    bool isSoundfile(const std::string& type) {
      return (type == "soundfile");
    }

    std::string getString(std::map<std::string, std::pair<std::string, double> >& map, const std::string& key)
    {
      return (map.find(key) != map.end()) ? map[key].first : "";
    }

    int getInt(std::map<std::string, std::pair<std::string, double> >& map, const std::string& key)
    {
      return (map.find(key) != map.end()) ? int(map[key].second) : -1;
    }

    void setReflectZoneFun(int index, ReflectFunction fun)
    {
      fPathInputTable[index]->setReflectZoneFun(fun);
    }

    void setModifyZoneFun(int index, ModifyFunction fun)
    {
      fPathOutputTable[index]->setModifyZoneFun(fun);
    }

    JSONUIDecoderReal(const std::string& json)
    {
      fJSON = json;
      const char* p = fJSON.c_str();
      std::map<std::string, std::pair<std::string, double> > meta_data1;
      std::map<std::string, std::vector<std::string> > meta_data2;
      parseJson(p, meta_data1, fMetadata, meta_data2, fUiItems);

      // meta_data1 contains <name : val>, <inputs : val>, <ouputs : val> pairs etc...
      fName = getString(meta_data1, "name");
      fFileName = getString(meta_data1, "filename");
      fVersion = getString(meta_data1, "version");
      fCompileOptions = getString(meta_data1, "compile_options");

      if (meta_data2.find("library_list") != meta_data2.end()) {
        fLibraryList = meta_data2["library_list"];
      } else {
        // 'library_list' is coded as successive 'library_pathN' metadata
        for (const auto& it : fMetadata) {
          if (startWith(it.first, "library_path")) {
            fLibraryList.push_back(it.second);
          }
        }
      }
      if (meta_data2.find("include_pathnames") != meta_data2.end()) {
        fIncludePathnames = meta_data2["include_pathnames"];
      }

      fDSPSize = getInt(meta_data1, "size");
      fNumInputs = getInt(meta_data1, "inputs");
      fNumOutputs = getInt(meta_data1, "outputs");
      fSRIndex = getInt(meta_data1, "sr_index");
      fDSPProxy = false;

      // Prepare the fPathTable and init zone
      for (const auto& it : fUiItems) {
        std::string type = it.type;
        // Meta data declaration for input items
        if (isInput(type)) {
          ZoneParam* param = new ZoneParam();
          fPathInputTable.push_back(param);
          param->fZone = it.init;
        }
        // Meta data declaration for output items
        else if (isOutput(type)) {
          ZoneParam* param = new ZoneParam();
          fPathOutputTable.push_back(param);
          param->fZone = REAL(0);
        }
      }
    }

    virtual ~JSONUIDecoderReal()
    {
      for (const auto& it : fPathInputTable) {
        delete it;
      }
      for (const auto& it : fPathOutputTable) {
        delete it;
      }
    }

    void metadata(Meta* m)
    {
      for (const auto& it : fMetadata) {
        m->declare(it.first.c_str(), it.second.c_str());
      }
    }

    void metadata(MetaGlue* m)
    {
      for (const auto& it : fMetadata) {
        m->declare(m->metaInterface, it.first.c_str(), it.second.c_str());
      }
    }

    void resetUserInterface()
    {
      int item = 0;
      for (const auto& it : fUiItems) {
        if (isInput(it.type)) {
          static_cast<ZoneParam*>(fPathInputTable[item++])->fZone = it.init;
        }
      }
    }

    void resetUserInterface(char* memory_block, Soundfile* defaultsound = nullptr)
    {
      for (const auto& it : fUiItems) {
        int index = it.index;
        if (isInput(it.type)) {
          *REAL_ADR(index) = it.init;
        } else if (isSoundfile(it.type)) {
          if (*SOUNDFILE_ADR(index) == nullptr) {
            *SOUNDFILE_ADR(index) = defaultsound;
          }
        }
      }
    }

    int getSampleRate(char* memory_block)
    {
      return *reinterpret_cast<int*>(&memory_block[fSRIndex]);
    }

    void setupDSPProxy(UI* ui_interface, char* memory_block)
    {
      if (!fDSPProxy) {
        fDSPProxy = true;
        int countIn = 0;
        int countOut = 0;
        for (const auto& it : fUiItems) {
          std::string type = it.type;
          int index = it.index;
          if (isInput(type)) {
            fPathInputTable[countIn++]->setReflectZoneFun([ = ](REAL value) {
              *REAL_ADR(index) = value;
            });
          } else if (isOutput(type)) {
            fPathOutputTable[countOut++]->setModifyZoneFun([ = ]() {
              return *REAL_ADR(index);
            });
          }
        }
      }

      // Setup soundfile in any case
      for (const auto& it : fUiItems) {
        if (isSoundfile(it.type)) {
          ui_interface->addSoundfile(it.label.c_str(), it.url.c_str(), SOUNDFILE_ADR(it.index));
        }
      }
    }

    bool hasDSPProxy() {
      return fDSPProxy;
    }

    void buildUserInterface(UI* ui_interface)
    {
      // MANDATORY: to be sure floats or double are correctly parsed
      char* tmp_local = setlocale(LC_ALL, nullptr);
      if (tmp_local != NULL) {
        tmp_local = strdup(tmp_local);
      }
      setlocale(LC_ALL, "C");

      int countIn = 0;
      int countOut = 0;
      int countSound = 0;

      for (const auto& it : fUiItems) {

        std::string type = it.type;
        REAL init = REAL(it.init);
        REAL min = REAL(it.fmin);
        REAL max = REAL(it.fmax);
        REAL step = REAL(it.step);

        // Meta data declaration for input items
        if (isInput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(&static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone, it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for output items
        else if (isOutput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(&static_cast<ZoneParam*>(fPathOutputTable[countOut])->fZone, it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for group opening or closing
        else {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(0, it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }

        if (type == "hgroup") {
          ui_interface->openHorizontalBox(it.label.c_str());
        } else if (type == "vgroup") {
          ui_interface->openVerticalBox(it.label.c_str());
        } else if (type == "tgroup") {
          ui_interface->openTabBox(it.label.c_str());
        } else if (type == "vslider") {
          ui_interface->addVerticalSlider(it.label.c_str(), &static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone, init, min, max, step);
        } else if (type == "hslider") {
          ui_interface->addHorizontalSlider(it.label.c_str(), &static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone, init, min, max, step);
        } else if (type == "checkbox") {
          ui_interface->addCheckButton(it.label.c_str(), &static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone);
        } else if (type == "soundfile") {
          // Nothing
        } else if (type == "hbargraph") {
          ui_interface->addHorizontalBargraph(it.label.c_str(), &static_cast<ZoneParam*>(fPathOutputTable[countOut])->fZone, min, max);
        } else if (type == "vbargraph") {
          ui_interface->addVerticalBargraph(it.label.c_str(), &static_cast<ZoneParam*>(fPathOutputTable[countOut])->fZone, min, max);
        } else if (type == "nentry") {
          ui_interface->addNumEntry(it.label.c_str(), &static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone, init, min, max, step);
        } else if (type == "button") {
          ui_interface->addButton(it.label.c_str(), &static_cast<ZoneParam*>(fPathInputTable[countIn])->fZone);
        } else if (type == "close") {
          ui_interface->closeBox();
        }

        if (isInput(type)) {
          countIn++;
        } else if (isOutput(type)) {
          countOut++;
        } else if (isSoundfile(type)) {
          countSound++;
        }
      }

      if (tmp_local != NULL) {
        setlocale(LC_ALL, tmp_local);
        free(tmp_local);
      }
    }

    void buildUserInterface(UI* ui_interface, char* memory_block)
    {
      // MANDATORY: to be sure floats or double are correctly parsed
      char* tmp_local = setlocale(LC_ALL, nullptr);
      if (tmp_local != NULL) {
        tmp_local = strdup(tmp_local);
      }
      setlocale(LC_ALL, "C");

      for (const auto& it : fUiItems) {

        std::string type = it.type;
        int index = it.index;
        REAL init = REAL(it.init);
        REAL min = REAL(it.fmin);
        REAL max = REAL(it.fmax);
        REAL step = REAL(it.step);

        // Meta data declaration for input items
        if (isInput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            REAL_UI(ui_interface)->declare(REAL_ADR(index), it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for output items
        else if (isOutput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            REAL_UI(ui_interface)->declare(REAL_ADR(index), it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for group opening or closing
        else {
          for (size_t i = 0; i < it.meta.size(); i++) {
            REAL_UI(ui_interface)->declare(0, it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }

        if (type == "hgroup") {
          REAL_UI(ui_interface)->openHorizontalBox(it.label.c_str());
        } else if (type == "vgroup") {
          REAL_UI(ui_interface)->openVerticalBox(it.label.c_str());
        } else if (type == "tgroup") {
          REAL_UI(ui_interface)->openTabBox(it.label.c_str());
        } else if (type == "vslider") {
          REAL_UI(ui_interface)->addVerticalSlider(it.label.c_str(), REAL_ADR(index), init, min, max, step);
        } else if (type == "hslider") {
          REAL_UI(ui_interface)->addHorizontalSlider(it.label.c_str(), REAL_ADR(index), init, min, max, step);
        } else if (type == "checkbox") {
          REAL_UI(ui_interface)->addCheckButton(it.label.c_str(), REAL_ADR(index));
        } else if (type == "soundfile") {
          REAL_UI(ui_interface)->addSoundfile(it.label.c_str(), it.url.c_str(), SOUNDFILE_ADR(index));
        } else if (type == "hbargraph") {
          REAL_UI(ui_interface)->addHorizontalBargraph(it.label.c_str(), REAL_ADR(index), min, max);
        } else if (type == "vbargraph") {
          REAL_UI(ui_interface)->addVerticalBargraph(it.label.c_str(), REAL_ADR(index), min, max);
        } else if (type == "nentry") {
          REAL_UI(ui_interface)->addNumEntry(it.label.c_str(), REAL_ADR(index), init, min, max, step);
        } else if (type == "button") {
          REAL_UI(ui_interface)->addButton(it.label.c_str(), REAL_ADR(index));
        } else if (type == "close") {
          REAL_UI(ui_interface)->closeBox();
        }
      }

      if (tmp_local != NULL) {
        setlocale(LC_ALL, tmp_local);
        free(tmp_local);
      }
    }

    void buildUserInterface(UIGlue* ui_interface, char* memory_block)
    {
      // MANDATORY: to be sure floats or double are correctly parsed
      char* tmp_local = setlocale(LC_ALL, nullptr);
      if (tmp_local != NULL) {
        tmp_local = strdup(tmp_local);
      }
      setlocale(LC_ALL, "C");

      for (const auto& it : fUiItems) {

        std::string type = it.type;
        int index = it.index;
        REAL init = REAL(it.init);
        REAL min = REAL(it.fmin);
        REAL max = REAL(it.fmax);
        REAL step = REAL(it.step);

        // Meta data declaration for input items
        if (isInput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(ui_interface->uiInterface, REAL_EXT_ADR(index), it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for output items
        else if (isOutput(type)) {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(ui_interface->uiInterface, REAL_EXT_ADR(index), it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }
        // Meta data declaration for group opening or closing
        else {
          for (size_t i = 0; i < it.meta.size(); i++) {
            ui_interface->declare(ui_interface->uiInterface, 0, it.meta[i].first.c_str(), it.meta[i].second.c_str());
          }
        }

        if (type == "hgroup") {
          ui_interface->openHorizontalBox(ui_interface->uiInterface, it.label.c_str());
        } else if (type == "vgroup") {
          ui_interface->openVerticalBox(ui_interface->uiInterface, it.label.c_str());
        } else if (type == "tgroup") {
          ui_interface->openTabBox(ui_interface->uiInterface, it.label.c_str());
        } else if (type == "vslider") {
          ui_interface->addVerticalSlider(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index), init, min, max, step);
        } else if (type == "hslider") {
          ui_interface->addHorizontalSlider(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index), init, min, max, step);
        } else if (type == "checkbox") {
          ui_interface->addCheckButton(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index));
        } else if (type == "soundfile") {
          ui_interface->addSoundfile(ui_interface->uiInterface, it.label.c_str(), it.url.c_str(), SOUNDFILE_ADR(index));
        } else if (type == "hbargraph") {
          ui_interface->addHorizontalBargraph(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index), min, max);
        } else if (type == "vbargraph") {
          ui_interface->addVerticalBargraph(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index), min, max);
        } else if (type == "nentry") {
          ui_interface->addNumEntry(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index), init, min, max, step);
        } else if (type == "button") {
          ui_interface->addButton(ui_interface->uiInterface, it.label.c_str(), REAL_EXT_ADR(index));
        } else if (type == "close") {
          ui_interface->closeBox(ui_interface->uiInterface);
        }
      }

      if (tmp_local != NULL) {
        setlocale(LC_ALL, tmp_local);
        free(tmp_local);
      }
    }

    bool hasCompileOption(const std::string& option)
    {
      std::istringstream iss(fCompileOptions);
      std::string token;
      while (std::getline(iss, token, ' ')) {
        if (token == option) return true;
      }
      return false;
    }

    int getDSPSize() {
      return fDSPSize;
    }
    std::string getName() {
      return fName;
    }
    std::string getLibVersion() {
      return fVersion;
    }
    std::string getCompileOptions() {
      return fCompileOptions;
    }
    std::vector<std::string> getLibraryList() {
      return fLibraryList;
    }
    std::vector<std::string> getIncludePathnames() {
      return fIncludePathnames;
    }
    int getNumInputs() {
      return fNumInputs;
    }
    int getNumOutputs() {
      return fNumOutputs;
    }

    std::vector<ExtZoneParam*>& getInputControls()
    {
      return fPathInputTable;
    }
    std::vector<ExtZoneParam*>& getOutputControls()
    {
      return fPathOutputTable;
    }

};

// FAUSTFLOAT templated decoder

struct JSONUIDecoder : public JSONUIDecoderReal<FAUSTFLOAT>
{
  JSONUIDecoder(const std::string& json): JSONUIDecoderReal<FAUSTFLOAT>(json)
  {}
};

// Generic factory

static JSONUIDecoderBase* createJSONUIDecoder(const std::string& json)
{
  JSONUIDecoder decoder(json);
  if (decoder.hasCompileOption("-double")) {
    return new JSONUIDecoderReal<double>(json);
  } else {
    return new JSONUIDecoderReal<float>(json);
  }
}

#endif
/**************************  END  JSONUIDecoder.h **************************/

/**
   Proxy dsp definition created from the DSP JSON description.
   This class allows a 'proxy' dsp to control a real dsp
   possibly running somewhere else.
*/
class proxy_dsp : public dsp {

  protected:

    JSONUIDecoder* fDecoder;
    int fSampleRate;

    void init(const std::string& json)
    {
      fDecoder = new JSONUIDecoder(json);
      fSampleRate = -1;
    }

  public:

    proxy_dsp(): fDecoder(nullptr), fSampleRate(-1)
    {}

    proxy_dsp(const std::string& json)
    {
      init(json);
    }

    proxy_dsp(dsp* dsp)
    {
      JSONUI builder(dsp->getNumInputs(), dsp->getNumOutputs());
      dsp->metadata(&builder);
      dsp->buildUserInterface(&builder);
      fSampleRate = dsp->getSampleRate();
      fDecoder = new JSONUIDecoder(builder.JSON());
    }

    virtual ~proxy_dsp()
    {
      delete fDecoder;
    }

    virtual int getNumInputs() {
      return fDecoder->fNumInputs;
    }
    virtual int getNumOutputs() {
      return fDecoder->fNumOutputs;
    }

    virtual void buildUserInterface(UI* ui) {
      fDecoder->buildUserInterface(ui);
    }

    // To possibly implement in a concrete proxy dsp
    virtual void init(int sample_rate)
    {
      instanceInit(sample_rate);
    }
    virtual void instanceInit(int sample_rate)
    {
      instanceConstants(sample_rate);
      instanceResetUserInterface();
      instanceClear();
    }
    virtual void instanceConstants(int sample_rate) {
      fSampleRate = sample_rate;
    }
    virtual void instanceResetUserInterface() {
      fDecoder->resetUserInterface();
    }
    virtual void instanceClear() {}

    virtual int getSampleRate() {
      return fSampleRate;
    }

    virtual proxy_dsp* clone() {
      return new proxy_dsp(fDecoder->fJSON);
    }
    virtual void metadata(Meta* m) {
      fDecoder->metadata(m);
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {}
    virtual void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {}

};

#endif
/************************** END proxy-dsp.h **************************/

/************************** BEGIN DecoratorUI.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2003-2017 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef Decorator_UI_H
#define Decorator_UI_H


//----------------------------------------------------------------
//  Generic UI empty implementation
//----------------------------------------------------------------

class GenericUI : public UI
{

  public:

    GenericUI() {}
    virtual ~GenericUI() {}

    // -- widget's layouts
    virtual void openTabBox(const char* label) {}
    virtual void openHorizontalBox(const char* label) {}
    virtual void openVerticalBox(const char* label) {}
    virtual void closeBox() {}

    // -- active widgets
    virtual void addButton(const char* label, FAUSTFLOAT* zone) {}
    virtual void addCheckButton(const char* label, FAUSTFLOAT* zone) {}
    virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
    virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}
    virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step) {}

    // -- passive widgets
    virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}
    virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max) {}

    // -- soundfiles
    virtual void addSoundfile(const char* label, const char* soundpath, Soundfile** sf_zone) {}

    virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val) {}

};

//----------------------------------------------------------------
//  Generic UI decorator
//----------------------------------------------------------------

class DecoratorUI : public UI
{

  protected:

    UI* fUI;

  public:

    DecoratorUI(UI* ui = 0): fUI(ui) {}
    virtual ~DecoratorUI() {
      delete fUI;
    }

    // -- widget's layouts
    virtual void openTabBox(const char* label)          {
      fUI->openTabBox(label);
    }
    virtual void openHorizontalBox(const char* label)   {
      fUI->openHorizontalBox(label);
    }
    virtual void openVerticalBox(const char* label)     {
      fUI->openVerticalBox(label);
    }
    virtual void closeBox()                             {
      fUI->closeBox();
    }

    // -- active widgets
    virtual void addButton(const char* label, FAUSTFLOAT* zone)         {
      fUI->addButton(label, zone);
    }
    virtual void addCheckButton(const char* label, FAUSTFLOAT* zone)    {
      fUI->addCheckButton(label, zone);
    }
    virtual void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      fUI->addVerticalSlider(label, zone, init, min, max, step);
    }
    virtual void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      fUI->addHorizontalSlider(label, zone, init, min, max, step);
    }
    virtual void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT min, FAUSTFLOAT max, FAUSTFLOAT step)
    {
      fUI->addNumEntry(label, zone, init, min, max, step);
    }

    // -- passive widgets
    virtual void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
    {
      fUI->addHorizontalBargraph(label, zone, min, max);
    }
    virtual void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT min, FAUSTFLOAT max)
    {
      fUI->addVerticalBargraph(label, zone, min, max);
    }

    // -- soundfiles
    virtual void addSoundfile(const char* label, const char* filename, Soundfile** sf_zone) {
      fUI->addSoundfile(label, filename, sf_zone);
    }

    virtual void declare(FAUSTFLOAT* zone, const char* key, const char* val) {
      fUI->declare(zone, key, val);
    }

};

// Defined here to simplify header #include inclusion
class SoundUIInterface : public GenericUI {};

#endif
/**************************  END  DecoratorUI.h **************************/
/************************** BEGIN JSONControl.h **************************/
/************************************************************************
  FAUST Architecture File
  Copyright (C) 2019 GRAME, Centre National de Creation Musicale
  ---------------------------------------------------------------------
  This Architecture section is free software; you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3 of
  the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.

  EXCEPTION : As a special exception, you may create a larger work
  that contains this FAUST architecture section and distribute
  that work under terms of your choice, so long as this FAUST
  architecture section is not modified.
 ************************************************************************/

#ifndef __JSON_CONTROL__
#define __JSON_CONTROL__

#include <string>

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

struct JSONControl {

  virtual std::string getJSON() {
    return "";
  }

  virtual void setParamValue(const std::string& path, FAUSTFLOAT value) {}

  virtual FAUSTFLOAT getParamValue(const std::string& path) {
    return 0;
  }

  virtual ~JSONControl()
  {}

};

#endif
/**************************  END  JSONControl.h **************************/

#define kActiveVoice    0
#define kFreeVoice     -1
#define kReleaseVoice  -2
#define kLegatoVoice   -3
#define kNoVoice       -4

#define VOICE_STOP_LEVEL  0.0005    // -70 db
#define MIX_BUFFER_SIZE   4096

/**
   Allows to control zones in a grouped manner.
*/
class GroupUI : public GUI, public PathBuilder {

  private:

    std::map<std::string, uiGroupItem*> fLabelZoneMap;

    void insertMap(std::string label, FAUSTFLOAT* zone)
    {
      if (!MapUI::endsWith(label, "/gate")
          && !MapUI::endsWith(label, "/freq")
          && !MapUI::endsWith(label, "/key")
          && !MapUI::endsWith(label, "/gain")
          && !MapUI::endsWith(label, "/vel")
          && !MapUI::endsWith(label, "/velocity")) {

        // Groups all controllers except 'freq/key', 'gate', and 'gain/vel|velocity'
        if (fLabelZoneMap.find(label) != fLabelZoneMap.end()) {
          fLabelZoneMap[label]->addZone(zone);
        } else {
          fLabelZoneMap[label] = new uiGroupItem(this, zone);
        }
      }
    }

    uiCallbackItem* fPanic;

  public:

    GroupUI(FAUSTFLOAT* zone, uiCallback cb, void* arg)
    {
      fPanic = new uiCallbackItem(this, zone, cb, arg);
    }

    virtual ~GroupUI()
    {
      // 'fPanic' is kept and deleted in GUI, so do not delete here
    }

    // -- widget's layouts
    void openTabBox(const char* label)
    {
      pushLabel(label);
    }
    void openHorizontalBox(const char* label)
    {
      pushLabel(label);
    }
    void openVerticalBox(const char* label)
    {
      pushLabel(label);
    }
    void closeBox()
    {
      popLabel();
    }

    // -- active widgets
    void addButton(const char* label, FAUSTFLOAT* zone)
    {
      insertMap(buildPath(label), zone);
    }
    void addCheckButton(const char* label, FAUSTFLOAT* zone)
    {
      insertMap(buildPath(label), zone);
    }
    void addVerticalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      insertMap(buildPath(label), zone);
    }
    void addHorizontalSlider(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      insertMap(buildPath(label), zone);
    }
    void addNumEntry(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT init, FAUSTFLOAT fmin, FAUSTFLOAT fmax, FAUSTFLOAT step)
    {
      insertMap(buildPath(label), zone);
    }

    // -- passive widgets
    void addHorizontalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
    {
      insertMap(buildPath(label), zone);
    }
    void addVerticalBargraph(const char* label, FAUSTFLOAT* zone, FAUSTFLOAT fmin, FAUSTFLOAT fmax)
    {
      insertMap(buildPath(label), zone);
    }

};

/**
   One voice of polyphony.
*/
struct dsp_voice : public MapUI, public decorator_dsp {

  typedef std::function<double(int)> TransformFunction;

  static double midiToFreq(double note)
  {
    return 440.0 * std::pow(2.0, (note - 69.0) / 12.0);
  }

  int fCurNote;                       // Playing note pitch
  int fNextNote;                      // In kLegatoVoice state, next note to play
  int fNextVel;                       // In kLegatoVoice state, next velocity to play
  int fDate;                          // KeyOn date
  int fRelease;                       // Current number of samples used in release mode to detect end of note
  FAUSTFLOAT fLevel;                  // Last audio block level
  std::vector<std::string> fGatePath; // Paths of 'gate' control
  std::vector<std::string> fGainPath; // Paths of 'gain/vel|velocity' control
  std::vector<std::string> fFreqPath; // Paths of 'freq/key' control
  TransformFunction        fKeyFun;   // MIDI key to freq conversion function
  TransformFunction        fVelFun;   // MIDI velocity to gain conversion function

  FAUSTFLOAT** fInputsSlice;
  FAUSTFLOAT** fOutputsSlice;

  dsp_voice(dsp* dsp): decorator_dsp(dsp)
  {
    // Default versions
    fVelFun = [](int velocity) {
      return double(velocity) / 127.0;
    };
    fKeyFun = [](int pitch) {
      return midiToFreq(pitch);
    };
    dsp->buildUserInterface(this);
    fCurNote = kFreeVoice;
    fNextNote = fNextVel = -1;
    fLevel = FAUSTFLOAT(0);
    fDate = fRelease = 0;
    extractPaths(fGatePath, fFreqPath, fGainPath);
  }
  virtual ~dsp_voice()
  {}

  void computeSlice(int offset, int slice, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
  {
    FAUSTFLOAT** inputsSlice = static_cast<FAUSTFLOAT**>(alloca(sizeof(FAUSTFLOAT*) * getNumInputs()));
    for (int chan = 0; chan < getNumInputs(); chan++) {
      inputsSlice[chan] = &(inputs[chan][offset]);
    }
    FAUSTFLOAT** outputsSlice = static_cast<FAUSTFLOAT**>(alloca(sizeof(FAUSTFLOAT*) * getNumOutputs()));
    for (int chan = 0; chan < getNumOutputs(); chan++) {
      outputsSlice[chan] = &(outputs[chan][offset]);
    }
    compute(slice, inputsSlice, outputsSlice);
  }

  void computeLegato(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
  {
    int slice = count / 2;

    // Reset envelops
    for (size_t i = 0; i < fGatePath.size(); i++) {
      setParamValue(fGatePath[i], FAUSTFLOAT(0));
    }

    // Compute current voice on half buffer
    computeSlice(0, slice, inputs, outputs);

    // Start next keyOn
    keyOn(fNextNote, fNextVel);

    // Compute on second half buffer
    computeSlice(slice, slice, inputs, outputs);
  }

  void extractPaths(std::vector<std::string>& gate, std::vector<std::string>& freq, std::vector<std::string>& gain)
  {
    // Keep gain/vel|velocity, freq/key and gate labels
    for (const auto& it : getMap()) {
      std::string path = it.first;
      if (endsWith(path, "/gate")) {
        gate.push_back(path);
      } else if (endsWith(path, "/freq")) {
        fKeyFun = [](int pitch) {
          return midiToFreq(pitch);
        };
        freq.push_back(path);
      } else if (endsWith(path, "/key")) {
        fKeyFun = [](int pitch) {
          return pitch;
        };
        freq.push_back(path);
      } else if (endsWith(path, "/gain")) {
        fVelFun = [](int velocity) {
          return double(velocity) / 127.0;
        };
        gain.push_back(path);
      } else if (endsWith(path, "/vel") || endsWith(path, "/velocity")) {
        fVelFun = [](int velocity) {
          return double(velocity);
        };
        gain.push_back(path);
      }
    }
  }

  void instanceClear()
  {
    decorator_dsp::instanceClear();
    fCurNote = kFreeVoice;
    fNextNote = fNextVel = -1;
    fLevel = FAUSTFLOAT(0);
    fDate = fRelease = 0;
  }

  // Keep 'pitch' and 'velocity' to fadeOut the current voice and start next one in the next buffer
  void keyOn(int pitch, int velocity, bool legato = false)
  {
    if (legato) {
      fNextNote = pitch;
      fNextVel = velocity;
    } else {
      keyOn(pitch, fVelFun(velocity));
    }
  }

  // Normalized MIDI velocity [0..1]
  void keyOn(int pitch, double velocity)
  {
    for (size_t i = 0; i < fFreqPath.size(); i++) {
      setParamValue(fFreqPath[i], fKeyFun(pitch));
    }
    for (size_t i = 0; i < fGatePath.size(); i++) {
      setParamValue(fGatePath[i], FAUSTFLOAT(1));
    }
    for (size_t i = 0; i < fGainPath.size(); i++) {
      setParamValue(fGainPath[i], velocity);
    }

    fCurNote = pitch;
  }

  void keyOff(bool hard = false)
  {
    // No use of velocity for now...
    for (size_t i = 0; i < fGatePath.size(); i++) {
      setParamValue(fGatePath[i], FAUSTFLOAT(0));
    }

    if (hard) {
      // Immediately stop voice
      fCurNote = kFreeVoice;
    } else {
      // Release voice
      fRelease = fDSP->getSampleRate() / 2; // Half sec used in release mode to detect end of note
      fCurNote = kReleaseVoice;
    }
  }

};

/**
   A group of voices.
*/
struct dsp_voice_group {

  GroupUI fGroups;

  std::vector<dsp_voice*> fVoiceTable; // Individual voices
  dsp* fVoiceGroup;                    // Voices group to be used for GUI grouped control

  FAUSTFLOAT fPanic;

  bool fVoiceControl;
  bool fGroupControl;

  dsp_voice_group(uiCallback cb, void* arg, bool control, bool group)
    : fGroups(&fPanic, cb, arg),
      fVoiceGroup(0), fPanic(FAUSTFLOAT(0)),
      fVoiceControl(control), fGroupControl(group)
  {}

  virtual ~dsp_voice_group()
  {
    for (size_t i = 0; i < fVoiceTable.size(); i++) {
      delete fVoiceTable[i];
    }
    delete fVoiceGroup;
  }

  void addVoice(dsp_voice* voice)
  {
    fVoiceTable.push_back(voice);
  }

  void clearVoices()
  {
    fVoiceTable.clear();
  }

  void init()
  {
    // Groups all uiItem for a given path
    fVoiceGroup = new proxy_dsp(fVoiceTable[0]);
    fVoiceGroup->buildUserInterface(&fGroups);
    for (size_t i = 0; i < fVoiceTable.size(); i++) {
      fVoiceTable[i]->buildUserInterface(&fGroups);
    }
  }

  void instanceResetUserInterface()
  {
    for (size_t i = 0; i < fVoiceTable.size(); i++) {
      fVoiceTable[i]->instanceResetUserInterface();
    }
  }

  void buildUserInterface(UI* ui_interface)
  {
    if (fVoiceTable.size() > 1) {
      ui_interface->openTabBox("Polyphonic");

      // Grouped voices UI
      ui_interface->openVerticalBox("Voices");
      ui_interface->addButton("Panic", &fPanic);
      fVoiceGroup->buildUserInterface(ui_interface);
      ui_interface->closeBox();

      // If not grouped, also add individual voices UI
      if (!fGroupControl || dynamic_cast<SoundUIInterface*>(ui_interface)) {
        for (size_t i = 0; i < fVoiceTable.size(); i++) {
          char buffer[32];
          snprintf(buffer, 32, ((fVoiceTable.size() < 8) ? "Voice%ld" : "V%ld"), long(i + 1));
          ui_interface->openHorizontalBox(buffer);
          fVoiceTable[i]->buildUserInterface(ui_interface);
          ui_interface->closeBox();
        }
      }

      ui_interface->closeBox();
    } else {
      fVoiceTable[0]->buildUserInterface(ui_interface);
    }
  }

};

/**
   Base class for MIDI controllable polyphonic DSP.
*/
#ifdef EMCC
#endif

class dsp_poly : public decorator_dsp, public midi, public JSONControl {

  protected:

#ifdef EMCC
    MapUI fMapUI;
    std::string fJSON;
    midi_handler fMidiHandler;
    MidiUI fMIDIUI;
#endif

  public:

#ifdef EMCC
    dsp_poly(dsp* dsp): decorator_dsp(dsp), fMIDIUI(&fMidiHandler)
    {
      JSONUI jsonui(getNumInputs(), getNumOutputs());
      buildUserInterface(&jsonui);
      fJSON = jsonui.JSON(true);
      buildUserInterface(&fMapUI);
      buildUserInterface(&fMIDIUI);
    }
#else
    dsp_poly(dsp* dsp): decorator_dsp(dsp)
    {}
#endif

    virtual ~dsp_poly() {}

    // Reimplemented for EMCC
#ifdef EMCC
    virtual int getNumInputs() {
      return decorator_dsp::getNumInputs();
    }
    virtual int getNumOutputs() {
      return decorator_dsp::getNumOutputs();
    }
    virtual void buildUserInterface(UI* ui_interface) {
      decorator_dsp::buildUserInterface(ui_interface);
    }
    virtual int getSampleRate() {
      return decorator_dsp::getSampleRate();
    }
    virtual void init(int sample_rate) {
      decorator_dsp::init(sample_rate);
    }
    virtual void instanceInit(int sample_rate) {
      decorator_dsp::instanceInit(sample_rate);
    }
    virtual void instanceConstants(int sample_rate) {
      decorator_dsp::instanceConstants(sample_rate);
    }
    virtual void instanceResetUserInterface() {
      decorator_dsp::instanceResetUserInterface();
    }
    virtual void instanceClear() {
      decorator_dsp::instanceClear();
    }
    virtual dsp_poly* clone() {
      return new dsp_poly(fDSP->clone());
    }
    virtual void metadata(Meta* m) {
      decorator_dsp::metadata(m);
    }

    // Additional API
    std::string getJSON()
    {
      return fJSON;
    }

    virtual void setParamValue(const std::string& path, FAUSTFLOAT value)
    {
      fMapUI.setParamValue(path, value);
      GUI::updateAllGuis();
    }

    virtual FAUSTFLOAT getParamValue(const std::string& path) {
      return fMapUI.getParamValue(path);
    }

    virtual void computeJS(int count, uintptr_t inputs, uintptr_t outputs)
    {
      decorator_dsp::compute(count, reinterpret_cast<FAUSTFLOAT**>(inputs), reinterpret_cast<FAUSTFLOAT**>(outputs));
    }
#endif

    virtual MapUI* keyOn(int channel, int pitch, int velocity)
    {
      return midi::keyOn(channel, pitch, velocity);
    }
    virtual void keyOff(int channel, int pitch, int velocity)
    {
      midi::keyOff(channel, pitch, velocity);
    }
    virtual void keyPress(int channel, int pitch, int press)
    {
      midi::keyPress(channel, pitch, press);
    }
    virtual void chanPress(int channel, int press)
    {
      midi::chanPress(channel, press);
    }
    virtual void ctrlChange(int channel, int ctrl, int value)
    {
      midi::ctrlChange(channel, ctrl, value);
    }
    virtual void ctrlChange14bits(int channel, int ctrl, int value)
    {
      midi::ctrlChange14bits(channel, ctrl, value);
    }
    virtual void pitchWheel(int channel, int wheel)
    {
#ifdef EMCC
      fMIDIUI.pitchWheel(0., channel, wheel);
      GUI::updateAllGuis();
#else
      midi::pitchWheel(channel, wheel);
#endif
    }
    virtual void progChange(int channel, int pgm)
    {
      midi::progChange(channel, pgm);
    }

};

/**
   Polyphonic DSP: groups a set of DSP to be played together or triggered by MIDI.

   All voices are preallocated by cloning the single DSP voice given at creation time.
   Dynamic voice allocation is done in 'getFreeVoice'
*/
class mydsp_poly : public dsp_voice_group, public dsp_poly {

  private:

    FAUSTFLOAT** fMixBuffer;
    FAUSTFLOAT** fOutBuffer;
    midi_interface* fMidiHandler; // The midi_interface the DSP is connected to
    int fDate;

    void fadeOut(int count, FAUSTFLOAT** outBuffer)
    {
      // FadeOut on half buffer
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        double factor = 1., step = 1. / double(count);
        for (int frame = 0; frame < count; frame++) {
          outBuffer[chan][frame] *= factor;
          factor -= step;
        }
      }
    }

    FAUSTFLOAT mixCheckVoice(int count, FAUSTFLOAT** mixBuffer, FAUSTFLOAT** outBuffer)
    {
      FAUSTFLOAT level = 0;
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        FAUSTFLOAT* mixChannel = mixBuffer[chan];
        FAUSTFLOAT* outChannel = outBuffer[chan];
        for (int frame = 0; frame < count; frame++) {
          level = std::max<FAUSTFLOAT>(level, (FAUSTFLOAT)fabs(mixChannel[frame]));
          outChannel[frame] += mixChannel[frame];
        }
      }
      return level;
    }

    void mixVoice(int count, FAUSTFLOAT** mixBuffer, FAUSTFLOAT** outBuffer)
    {
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        FAUSTFLOAT* mixChannel = mixBuffer[chan];
        FAUSTFLOAT* outChannel = outBuffer[chan];
        for (int frame = 0; frame < count; frame++) {
          outChannel[frame] += mixChannel[frame];
        }
      }
    }

    void copy(int count, FAUSTFLOAT** mixBuffer, FAUSTFLOAT** outBuffer)
    {
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        memcpy(outBuffer[chan], mixBuffer[chan], count * sizeof(FAUSTFLOAT));
      }
    }

    void clear(int count, FAUSTFLOAT** outBuffer)
    {
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        memset(outBuffer[chan], 0, count * sizeof(FAUSTFLOAT));
      }
    }

    int getPlayingVoice(int pitch)
    {
      int voice_playing = kNoVoice;
      int oldest_date_playing = INT_MAX;

      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        if (fVoiceTable[i]->fCurNote == pitch) {
          // Keeps oldest playing voice
          if (fVoiceTable[i]->fDate < oldest_date_playing) {
            oldest_date_playing = fVoiceTable[i]->fDate;
            voice_playing = int(i);
          }
        }
      }

      return voice_playing;
    }

    int allocVoice(int voice, int type)
    {
      fVoiceTable[voice]->fDate++;
      fVoiceTable[voice]->fCurNote = type;
      return voice;
    }

    // Always returns a voice
    int getFreeVoice()
    {
      // Looks for the first available voice
      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        if (fVoiceTable[i]->fCurNote == kFreeVoice) {
          return allocVoice(i, kActiveVoice);
        }
      }

      // Otherwise steal one
      int voice_release = kNoVoice;
      int voice_playing = kNoVoice;
      int oldest_date_release = INT_MAX;
      int oldest_date_playing = INT_MAX;

      // Scan all voices
      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        if (fVoiceTable[i]->fCurNote == kReleaseVoice) {
          // Keeps oldest release voice
          if (fVoiceTable[i]->fDate < oldest_date_release) {
            oldest_date_release = fVoiceTable[i]->fDate;
            voice_release = int(i);
          }
        } else {
          // Otherwise keeps oldest playing voice
          if (fVoiceTable[i]->fDate < oldest_date_playing) {
            oldest_date_playing = fVoiceTable[i]->fDate;
            voice_playing = int(i);
          }
        }
      }

      // Then decide which one to steal
      if (oldest_date_release != INT_MAX) {
        fprintf(stderr, "Steal release voice : voice_date = %d cur_date = %d voice = %d \n",
                fVoiceTable[voice_release]->fDate,
                fDate,
                voice_release);
        return allocVoice(voice_release, kLegatoVoice);
      } else if (oldest_date_playing != INT_MAX) {
        fprintf(stderr, "Steal playing voice : voice_date = %d cur_date = %d voice = %d \n",
                fVoiceTable[voice_playing]->fDate,
                fDate,
                voice_release);
        return allocVoice(voice_playing, kLegatoVoice);
      } else {
        assert(false);
        return kNoVoice;
      }
    }

    static void panic(FAUSTFLOAT val, void* arg)
    {
      if (val == FAUSTFLOAT(1)) {
        static_cast<mydsp_poly*>(arg)->allNotesOff(true);
      }
    }

    bool checkPolyphony()
    {
      if (fVoiceTable.size() > 0) {
        return true;
      } else {
        fprintf(stderr, "DSP is not polyphonic...\n");
        return false;
      }
    }

  public:

    /**
       Constructor.

       @param dsp - the dsp to be used for one voice. Beware: mydsp_poly will use and finally delete the pointer.
       @param nvoices - number of polyphony voices, should be at least 1
       @param control - whether voices will be dynamically allocated and controlled (typically by a MIDI controler).
                      If false all voices are always running.
       @param group - if true, voices are not individually accessible, a global "Voices" tab will automatically dispatch
                      a given control on all voices, assuming GUI::updateAllGuis() is called.
                      If false, all voices can be individually controlled.

    */
    mydsp_poly(dsp* dsp,
               int nvoices,
               bool control = false,
               bool group = true)
      : dsp_voice_group(panic, this, control, group), dsp_poly(dsp) // dsp parameter is deallocated by ~dsp_poly
    {
      fDate = 0;
      fMidiHandler = nullptr;

      // Create voices
      assert(nvoices > 0);
      for (int i = 0; i < nvoices; i++) {
        addVoice(new dsp_voice(dsp->clone()));
      }

      // Init audio output buffers
      fMixBuffer = new FAUSTFLOAT*[getNumOutputs()];
      fOutBuffer = new FAUSTFLOAT*[getNumOutputs()];
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        fMixBuffer[chan] = new FAUSTFLOAT[MIX_BUFFER_SIZE];
        fOutBuffer[chan] = new FAUSTFLOAT[MIX_BUFFER_SIZE];
      }

      dsp_voice_group::init();
    }

    virtual ~mydsp_poly()
    {
      // Remove from fMidiHandler
      if (fMidiHandler) fMidiHandler->removeMidiIn(this);
      for (int chan = 0; chan < getNumOutputs(); chan++) {
        delete[] fMixBuffer[chan];
        delete[] fOutBuffer[chan];
      }
      delete[] fMixBuffer;
      delete[] fOutBuffer;

    }

    // DSP API
    void buildUserInterface(UI* ui_interface)
    {
      // MidiUI ui_interface contains the midi_handler connected to the MIDI driver
      if (dynamic_cast<midi_interface*>(ui_interface)) {
        fMidiHandler = dynamic_cast<midi_interface*>(ui_interface);
        fMidiHandler->addMidiIn(this);
      }
      dsp_voice_group::buildUserInterface(ui_interface);
    }

    void init(int sample_rate)
    {
      decorator_dsp::init(sample_rate);
      fVoiceGroup->init(sample_rate);
      fPanic = FAUSTFLOAT(0);

      // Init voices
      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        fVoiceTable[i]->init(sample_rate);
      }
    }

    void instanceInit(int samplingFreq)
    {
      instanceConstants(samplingFreq);
      instanceResetUserInterface();
      instanceClear();
    }

    void instanceConstants(int sample_rate)
    {
      decorator_dsp::instanceConstants(sample_rate);
      fVoiceGroup->instanceConstants(sample_rate);

      // Init voices
      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        fVoiceTable[i]->instanceConstants(sample_rate);
      }
    }

    void instanceResetUserInterface()
    {
      decorator_dsp::instanceResetUserInterface();
      fVoiceGroup->instanceResetUserInterface();
      fPanic = FAUSTFLOAT(0);

      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        fVoiceTable[i]->instanceResetUserInterface();
      }
    }

    void instanceClear()
    {
      decorator_dsp::instanceClear();
      fVoiceGroup->instanceClear();

      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        fVoiceTable[i]->instanceClear();
      }
    }

    virtual mydsp_poly* clone()
    {
      return new mydsp_poly(fDSP->clone(), int(fVoiceTable.size()), fVoiceControl, fGroupControl);
    }

    void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      assert(count <= MIX_BUFFER_SIZE);

      // First clear the intermediate fOutBuffer
      clear(count, fOutBuffer);

      if (fVoiceControl) {
        // Mix all playing voices
        for (size_t i = 0; i < fVoiceTable.size(); i++) {
          dsp_voice* voice = fVoiceTable[i];
          if (voice->fCurNote == kLegatoVoice) {
            // Play from current note and next note
            voice->computeLegato(count, inputs, fMixBuffer);
            // FadeOut on first half buffer
            fadeOut(count / 2, fMixBuffer);
            // Mix it in result
            voice->fLevel = mixCheckVoice(count, fMixBuffer, fOutBuffer);
          } else if (voice->fCurNote != kFreeVoice) {
            // Compute current note
            voice->compute(count, inputs, fMixBuffer);
            // Mix it in result
            voice->fLevel = mixCheckVoice(count, fMixBuffer, fOutBuffer);
            // Check the level to possibly set the voice in kFreeVoice again
            voice->fRelease -= count;
            if ((voice->fCurNote == kReleaseVoice)
                && (voice->fRelease < 0)
                && (voice->fLevel < VOICE_STOP_LEVEL)) {
              voice->fCurNote = kFreeVoice;
            }
          }
        }
      } else {
        // Mix all voices
        for (size_t i = 0; i < fVoiceTable.size(); i++) {
          fVoiceTable[i]->compute(count, inputs, fMixBuffer);
          mixVoice(count, fMixBuffer, fOutBuffer);
        }
      }

      // Finally copy intermediate buffer to outputs
      copy(count, fOutBuffer, outputs);
    }

    void compute(double date_usec, int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs)
    {
      compute(count, inputs, outputs);
    }

    // Terminate all active voices, gently or immediately (depending of 'hard' value)
    void allNotesOff(bool hard = false)
    {
      for (size_t i = 0; i < fVoiceTable.size(); i++) {
        fVoiceTable[i]->keyOff(hard);
      }
    }

    // Additional polyphonic API
    MapUI* newVoice()
    {
      return fVoiceTable[getFreeVoice()];
    }

    void deleteVoice(MapUI* voice)
    {
      auto it = find(fVoiceTable.begin(), fVoiceTable.end(), reinterpret_cast<dsp_voice*>(voice));
      if (it != fVoiceTable.end()) {
        (*it)->keyOff();
      } else {
        fprintf(stderr, "Voice not found\n");
      }
    }

    // MIDI API
    MapUI* keyOn(int channel, int pitch, int velocity)
    {
      if (checkPolyphony()) {
        int voice = getFreeVoice();
        fVoiceTable[voice]->keyOn(pitch, velocity, fVoiceTable[voice]->fCurNote == kLegatoVoice);
        return fVoiceTable[voice];
      } else {
        return 0;
      }
    }

    void keyOff(int channel, int pitch, int velocity = 127)
    {
      if (checkPolyphony()) {
        int voice = getPlayingVoice(pitch);
        if (voice != kNoVoice) {
          fVoiceTable[voice]->keyOff();
        } else {
          fprintf(stderr, "Playing pitch = %d not found\n", pitch);
        }
      }
    }

    void ctrlChange(int channel, int ctrl, int value)
    {
      if (ctrl == ALL_NOTES_OFF || ctrl == ALL_SOUND_OFF) {
        allNotesOff();
      }
    }

};

/**
   Polyphonic DSP with an integrated effect.
*/
class dsp_poly_effect : public dsp_poly {

  private:

    // fPolyDSP will respond to MIDI messages.
    dsp_poly* fPolyDSP;

  public:

    dsp_poly_effect(dsp_poly* voice, dsp* combined)
      : dsp_poly(combined), fPolyDSP(voice)
    {}

    virtual ~dsp_poly_effect()
    {
      // dsp_poly_effect is also a decorator_dsp, which will free fPolyDSP
    }

    // MIDI API
    MapUI* keyOn(int channel, int pitch, int velocity)
    {
      return fPolyDSP->keyOn(channel, pitch, velocity);
    }
    void keyOff(int channel, int pitch, int velocity)
    {
      fPolyDSP->keyOff(channel, pitch, velocity);
    }
    void keyPress(int channel, int pitch, int press)
    {
      fPolyDSP->keyPress(channel, pitch, press);
    }
    void chanPress(int channel, int press)
    {
      fPolyDSP->chanPress(channel, press);
    }
    void ctrlChange(int channel, int ctrl, int value)
    {
      fPolyDSP->ctrlChange(channel, ctrl, value);
    }
    void ctrlChange14bits(int channel, int ctrl, int value)
    {
      fPolyDSP->ctrlChange14bits(channel, ctrl, value);
    }
    void pitchWheel(int channel, int wheel)
    {
      fPolyDSP->pitchWheel(channel, wheel);
    }
    void progChange(int channel, int pgm)
    {
      fPolyDSP->progChange(channel, pgm);
    }

};

/**
   Polyphonic DSP factory class. Helper code to support polyphonic DSP source with an integrated effect.
*/
struct dsp_poly_factory : public dsp_factory {

  dsp_factory* fProcessFactory;
  dsp_factory* fEffectFactory;

  dsp* adaptDSP(dsp* dsp, bool is_double)
  {
    return (is_double) ? new dsp_sample_adapter<double, float>(dsp) : dsp;
  }

  dsp_poly_factory(dsp_factory* process_factory = nullptr,
                   dsp_factory* effect_factory = nullptr):
    fProcessFactory(process_factory)
    , fEffectFactory(effect_factory)
  {}

  virtual ~dsp_poly_factory()
  {}

  virtual std::string getName() {
    return fProcessFactory->getName();
  }
  virtual std::string getSHAKey() {
    return fProcessFactory->getSHAKey();
  }
  virtual std::string getDSPCode() {
    return fProcessFactory->getDSPCode();
  }
  virtual std::string getCompileOptions() {
    return fProcessFactory->getCompileOptions();
  }
  virtual std::vector<std::string> getLibraryList() {
    return fProcessFactory->getLibraryList();
  }
  virtual std::vector<std::string> getIncludePathnames() {
    return fProcessFactory->getIncludePathnames();
  }

  std::string getEffectCode(const std::string& dsp_content)
  {
    std::stringstream effect_code;
    effect_code << "adapt(1,1) = _; adapt(2,2) = _,_; adapt(1,2) = _ <: _,_; adapt(2,1) = _,_ :> _;";
    effect_code << "adaptor(F,G) = adapt(outputs(F),inputs(G)); dsp_code = environment{ " << dsp_content << " };";
    effect_code << "process = adaptor(dsp_code.process, dsp_code.effect) : dsp_code.effect;";
    return effect_code.str();
  }

  virtual void setMemoryManager(dsp_memory_manager* manager)
  {
    fProcessFactory->setMemoryManager(manager);
    if (fEffectFactory) {
      fEffectFactory->setMemoryManager(manager);
    }
  }
  virtual dsp_memory_manager* getMemoryManager() {
    return fProcessFactory->getMemoryManager();
  }

  /* Create a new polyphonic DSP instance with global effect, to be deleted with C++ 'delete'

     @param nvoices - number of polyphony voices, should be at least 1
     @param control - whether voices will be dynamically allocated and controlled (typically by a MIDI controler).
                    If false all voices are always running.
     @param group - if true, voices are not individually accessible, a global "Voices" tab will automatically dispatch
                    a given control on all voices, assuming GUI::updateAllGuis() is called.
                    If false, all voices can be individually controlled.
     @param is_double - if true, internally allocated DSPs will be adapted to receive 'double' samples.
  */
  dsp_poly* createPolyDSPInstance(int nvoices, bool control, bool group, bool is_double = false)
  {
    dsp_poly* dsp_poly = new mydsp_poly(adaptDSP(fProcessFactory->createDSPInstance(), is_double), nvoices, control, group);
    if (fEffectFactory) {
      // the 'dsp_poly' object has to be controlled with MIDI, so kept separated from new dsp_sequencer(...) object
      return new dsp_poly_effect(dsp_poly, new dsp_sequencer(dsp_poly, adaptDSP(fEffectFactory->createDSPInstance(), is_double)));
    } else {
      return new dsp_poly_effect(dsp_poly, dsp_poly);
    }
  }

  /* Create a new DSP instance, to be deleted with C++ 'delete' */
  dsp* createDSPInstance()
  {
    return fProcessFactory->createDSPInstance();
  }

};

#endif // __poly_dsp__
/************************** END poly-dsp.h **************************/
#endif

// we require macro declarations
#define FAUST_UIMACROS

// but we will ignore most of them
#define FAUST_ADDBUTTON(l,f)
#define FAUST_ADDCHECKBOX(l,f)
#define FAUST_ADDVERTICALSLIDER(l,f,i,a,b,s)
#define FAUST_ADDHORIZONTALSLIDER(l,f,i,a,b,s)
#define FAUST_ADDNUMENTRY(l,f,i,a,b,s)
#define FAUST_ADDVERTICALBARGRAPH(l,f,a,b)
#define FAUST_ADDHORIZONTALBARGRAPH(l,f,a,b)

/******************************************************************************
 *******************************************************************************

  VECTOR INTRINSICS

 *******************************************************************************
 *******************************************************************************/


/********************END ARCHITECTURE SECTION (part 1/2)****************/

/**************************BEGIN USER SECTION **************************/

#ifndef FAUSTFLOAT
#define FAUSTFLOAT float
#endif

#include <algorithm>
#include <cmath>
#include <cstdint>
#include <math.h>

class mydspSIG0 {

  public:

    int iVec0[2];
    int iRec22[2];

  public:

    int getNumInputsmydspSIG0() {
      return 0;
    }
    int getNumOutputsmydspSIG0() {
      return 1;
    }

    void instanceInitmydspSIG0(int sample_rate) {
      for (int l2 = 0; (l2 < 2); l2 = (l2 + 1)) {
        iVec0[l2] = 0;
      }
      for (int l3 = 0; (l3 < 2); l3 = (l3 + 1)) {
        iRec22[l3] = 0;
      }
    }

    void fillmydspSIG0(int count, float* table) {
      for (int i1 = 0; (i1 < count); i1 = (i1 + 1)) {
        iVec0[0] = 1;
        iRec22[0] = ((iVec0[1] + iRec22[1]) % 65536);
        table[i1] = std::sin((9.58738019e-05f * float(iRec22[0])));
        iVec0[1] = iVec0[0];
        iRec22[1] = iRec22[0];
      }
    }

};

static mydspSIG0* newmydspSIG0() {
  return (mydspSIG0*)new mydspSIG0();
}
static void deletemydspSIG0(mydspSIG0* dsp) {
  delete dsp;
}

static float ftbl0mydspSIG0[65536];
static float mydsp_faustpower2_f(float value) {
  return (value * value);
}

#ifndef FAUSTCLASS
#define FAUSTCLASS mydsp
#endif

#ifdef __APPLE__
#define exp10f __exp10f
#define exp10 __exp10
#endif

class mydsp : public dsp {

  public:

    FAUSTFLOAT fHslider0;
    int iRec15[2];
    float fRec21[2];
    FAUSTFLOAT fHslider1;
    int fSampleRate;
    float fConst1;
    FAUSTFLOAT fHslider2;
    float fRec23[2];
    float fConst2;
    FAUSTFLOAT fHslider3;
    float fConst3;
    float fRec24[2];
    FAUSTFLOAT fHslider4;
    float fConst4;
    FAUSTFLOAT fHslider5;
    int iRec26[2];
    float fRec25[3];
    float fRec27[2];
    int IOTA;
    float fRec28[2048];
    float fConst5;
    float fConst6;
    FAUSTFLOAT fHslider6;
    float fRec29[2];
    FAUSTFLOAT fHslider7;
    float fRec30[2];
    float fVec1[2];
    float fVec2[2048];
    float fVec3[2];
    float fRec20[2];
    float fRec11[2048];
    float fRec7[2];
    float fRec3[2048];
    float fRec1[2];
    float fRec2[2];
    float fRec0[2];

  public:

    void metadata(Meta* m) {
      m->declare("basics.lib/name", "Faust Basic Element Library");
      m->declare("basics.lib/version", "0.3");
      m->declare("compile_options", "-a /usr/local/share/faust/teensy/teensy.cpp -lang cpp -es 1 -single -ftz 0");
      m->declare("copyright", "(c)Romain Michon, CCRMA (Stanford University), GRAME");
      m->declare("delays.lib/name", "Faust Delay Library");
      m->declare("delays.lib/version", "0.1");
      m->declare("description", "Simple flute physical model with physical parameters.");
      m->declare("filename", "flute.dsp");
      m->declare("filters.lib/dcblocker:author", "Julius O. Smith III");
      m->declare("filters.lib/dcblocker:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/dcblocker:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/fir:author", "Julius O. Smith III");
      m->declare("filters.lib/fir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/fir:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/iir:author", "Julius O. Smith III");
      m->declare("filters.lib/iir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/iir:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
      m->declare("filters.lib/lowpass:author", "Julius O. Smith III");
      m->declare("filters.lib/lowpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/lowpass:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/name", "Faust Filters Library");
      m->declare("filters.lib/pole:author", "Julius O. Smith III");
      m->declare("filters.lib/pole:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/pole:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/tf2:author", "Julius O. Smith III");
      m->declare("filters.lib/tf2:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/tf2:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/tf2s:author", "Julius O. Smith III");
      m->declare("filters.lib/tf2s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/tf2s:license", "MIT-style STK-4.3 license");
      m->declare("filters.lib/version", "0.3");
      m->declare("filters.lib/zero:author", "Julius O. Smith III");
      m->declare("filters.lib/zero:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
      m->declare("filters.lib/zero:license", "MIT-style STK-4.3 license");
      m->declare("license", "MIT");
      m->declare("maths.lib/author", "GRAME");
      m->declare("maths.lib/copyright", "GRAME");
      m->declare("maths.lib/license", "LGPL with exception");
      m->declare("maths.lib/name", "Faust Math Library");
      m->declare("maths.lib/version", "2.5");
      m->declare("name", "flute");
      m->declare("noises.lib/name", "Faust Noise Generator Library");
      m->declare("noises.lib/version", "0.2");
      m->declare("oscillators.lib/name", "Faust Oscillator Library");
      m->declare("oscillators.lib/version", "0.1");
      m->declare("physmodels.lib/name", "Faust Physical Models Library");
      m->declare("physmodels.lib/version", "0.1");
      m->declare("platform.lib/name", "Generic Platform Library");
      m->declare("platform.lib/version", "0.2");
      m->declare("routes.lib/name", "Faust Signal Routing Library");
      m->declare("routes.lib/version", "0.2");
      m->declare("signals.lib/name", "Faust Signal Routing Library");
      m->declare("signals.lib/version", "0.1");
    }

    virtual int getNumInputs() {
      return 0;
    }
    virtual int getNumOutputs() {
      return 2;
    }

    static void classInit(int sample_rate) {
      mydspSIG0* sig0 = newmydspSIG0();
      sig0->instanceInitmydspSIG0(sample_rate);
      sig0->fillmydspSIG0(65536, ftbl0mydspSIG0);
      deletemydspSIG0(sig0);
    }

    virtual void instanceConstants(int sample_rate) {
      fSampleRate = sample_rate;
      float fConst0 = std::min<float>(192000.0f, std::max<float>(1.0f, float(fSampleRate)));
      fConst1 = (1.0f / fConst0);
      fConst2 = (44.0999985f / fConst0);
      fConst3 = (1.0f - fConst2);
      fConst4 = (3.14159274f / fConst0);
      fConst5 = (0.00882352982f * fConst0);
      fConst6 = (0.00147058826f * fConst0);
    }

    virtual void instanceResetUserInterface() {
      fHslider0 = FAUSTFLOAT(0.5f);
      fHslider1 = FAUSTFLOAT(0.25f);
      fHslider2 = FAUSTFLOAT(5.0f);
      fHslider3 = FAUSTFLOAT(0.0f);
      fHslider4 = FAUSTFLOAT(0.10000000000000001f);
      fHslider5 = FAUSTFLOAT(2000.0f);
      fHslider6 = FAUSTFLOAT(0.80000000000000004f);
      fHslider7 = FAUSTFLOAT(0.5f);
    }

    virtual void instanceClear() {
      for (int l0 = 0; (l0 < 2); l0 = (l0 + 1)) {
        iRec15[l0] = 0;
      }
      for (int l1 = 0; (l1 < 2); l1 = (l1 + 1)) {
        fRec21[l1] = 0.0f;
      }
      for (int l4 = 0; (l4 < 2); l4 = (l4 + 1)) {
        fRec23[l4] = 0.0f;
      }
      for (int l5 = 0; (l5 < 2); l5 = (l5 + 1)) {
        fRec24[l5] = 0.0f;
      }
      for (int l6 = 0; (l6 < 2); l6 = (l6 + 1)) {
        iRec26[l6] = 0;
      }
      for (int l7 = 0; (l7 < 3); l7 = (l7 + 1)) {
        fRec25[l7] = 0.0f;
      }
      for (int l8 = 0; (l8 < 2); l8 = (l8 + 1)) {
        fRec27[l8] = 0.0f;
      }
      IOTA = 0;
      for (int l9 = 0; (l9 < 2048); l9 = (l9 + 1)) {
        fRec28[l9] = 0.0f;
      }
      for (int l10 = 0; (l10 < 2); l10 = (l10 + 1)) {
        fRec29[l10] = 0.0f;
      }
      for (int l11 = 0; (l11 < 2); l11 = (l11 + 1)) {
        fRec30[l11] = 0.0f;
      }
      for (int l12 = 0; (l12 < 2); l12 = (l12 + 1)) {
        fVec1[l12] = 0.0f;
      }
      for (int l13 = 0; (l13 < 2048); l13 = (l13 + 1)) {
        fVec2[l13] = 0.0f;
      }
      for (int l14 = 0; (l14 < 2); l14 = (l14 + 1)) {
        fVec3[l14] = 0.0f;
      }
      for (int l15 = 0; (l15 < 2); l15 = (l15 + 1)) {
        fRec20[l15] = 0.0f;
      }
      for (int l16 = 0; (l16 < 2048); l16 = (l16 + 1)) {
        fRec11[l16] = 0.0f;
      }
      for (int l17 = 0; (l17 < 2); l17 = (l17 + 1)) {
        fRec7[l17] = 0.0f;
      }
      for (int l18 = 0; (l18 < 2048); l18 = (l18 + 1)) {
        fRec3[l18] = 0.0f;
      }
      for (int l19 = 0; (l19 < 2); l19 = (l19 + 1)) {
        fRec1[l19] = 0.0f;
      }
      for (int l20 = 0; (l20 < 2); l20 = (l20 + 1)) {
        fRec2[l20] = 0.0f;
      }
      for (int l21 = 0; (l21 < 2); l21 = (l21 + 1)) {
        fRec0[l21] = 0.0f;
      }
    }

    virtual void init(int sample_rate) {
      classInit(sample_rate);
      instanceInit(sample_rate);
    }
    virtual void instanceInit(int sample_rate) {
      instanceConstants(sample_rate);
      instanceResetUserInterface();
      instanceClear();
    }

    virtual mydsp* clone() {
      return new mydsp();
    }

    virtual int getSampleRate() {
      return fSampleRate;
    }

    virtual void buildUserInterface(UI* ui_interface) {
      ui_interface->openHorizontalBox("flute");
      ui_interface->openVerticalBox("blower");
      ui_interface->declare(&fHslider3, "0", "");
      ui_interface->addHorizontalSlider("pressure", &fHslider3, FAUSTFLOAT(0.0f), FAUSTFLOAT(0.0f), FAUSTFLOAT(1.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->declare(&fHslider4, "1", "");
      ui_interface->addHorizontalSlider("breathGain", &fHslider4, FAUSTFLOAT(0.100000001f), FAUSTFLOAT(0.0f), FAUSTFLOAT(1.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->declare(&fHslider5, "2", "");
      ui_interface->addHorizontalSlider("breathCutoff", &fHslider5, FAUSTFLOAT(2000.0f), FAUSTFLOAT(20.0f), FAUSTFLOAT(20000.0f), FAUSTFLOAT(0.100000001f));
      ui_interface->declare(&fHslider2, "3", "");
      ui_interface->addHorizontalSlider("vibratoFreq", &fHslider2, FAUSTFLOAT(5.0f), FAUSTFLOAT(0.100000001f), FAUSTFLOAT(10.0f), FAUSTFLOAT(0.100000001f));
      ui_interface->declare(&fHslider1, "4", "");
      ui_interface->addHorizontalSlider("vibratoGain", &fHslider1, FAUSTFLOAT(0.25f), FAUSTFLOAT(0.0f), FAUSTFLOAT(1.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->closeBox();
      ui_interface->openVerticalBox("fluteModel");
      ui_interface->declare(&fHslider6, "0", "");
      ui_interface->addHorizontalSlider("tubeLength", &fHslider6, FAUSTFLOAT(0.800000012f), FAUSTFLOAT(0.00999999978f), FAUSTFLOAT(3.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->declare(&fHslider7, "1", "");
      ui_interface->addHorizontalSlider("mouthPosition", &fHslider7, FAUSTFLOAT(0.5f), FAUSTFLOAT(0.0f), FAUSTFLOAT(1.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->declare(&fHslider0, "2", "");
      ui_interface->addHorizontalSlider("outGain", &fHslider0, FAUSTFLOAT(0.5f), FAUSTFLOAT(0.0f), FAUSTFLOAT(1.0f), FAUSTFLOAT(0.00999999978f));
      ui_interface->closeBox();
      ui_interface->closeBox();
    }

    virtual void compute(int count, FAUSTFLOAT** inputs, FAUSTFLOAT** outputs) {
      FAUSTFLOAT* output0 = outputs[0];
      FAUSTFLOAT* output1 = outputs[1];
      float fSlow0 = float(fHslider0);
      float fSlow1 = (0.0299999993f * float(fHslider1));
      float fSlow2 = (fConst1 * float(fHslider2));
      float fSlow3 = (fConst2 * float(fHslider3));
      float fSlow4 = std::tan((fConst4 * float(fHslider5)));
      float fSlow5 = (1.0f / fSlow4);
      float fSlow6 = (((fSlow5 + 1.41421354f) / fSlow4) + 1.0f);
      float fSlow7 = (0.0500000007f * (float(fHslider4) / fSlow6));
      float fSlow8 = (1.0f / fSlow6);
      float fSlow9 = (((fSlow5 + -1.41421354f) / fSlow4) + 1.0f);
      float fSlow10 = (2.0f * (1.0f - (1.0f / mydsp_faustpower2_f(fSlow4))));
      float fSlow11 = (fConst2 * float(fHslider6));
      float fSlow12 = (fConst2 * float(fHslider7));
      for (int i0 = 0; (i0 < count); i0 = (i0 + 1)) {
        iRec15[0] = 0;
        fRec21[0] = ((0.699999988f * fRec21[1]) + (0.284999996f * fRec20[1]));
        float fRec19 = (fRec21[0] + float(iRec15[1]));
        fRec23[0] = (fSlow2 + (fRec23[1] - std::floor((fSlow2 + fRec23[1]))));
        fRec24[0] = (fSlow3 + (fConst3 * fRec24[1]));
        iRec26[0] = ((1103515245 * iRec26[1]) + 12345);
        fRec25[0] = ((4.65661287e-10f * float(iRec26[0])) - (fSlow8 * ((fSlow9 * fRec25[2]) + (fSlow10 * fRec25[1]))));
        fRec27[0] = fRec1[1];
        fRec28[(IOTA & 2047)] = (0.949999988f * fRec27[1]);
        fRec29[0] = (fSlow11 + (fConst3 * fRec29[1]));
        float fTemp0 = (fRec29[0] + 0.270000011f);
        fRec30[0] = (fSlow12 + (fConst3 * fRec30[1]));
        float fTemp1 = (0.400000006f * (fRec30[0] + -0.5f));
        float fTemp2 = (fConst6 * (fTemp0 * (fTemp1 + 0.270000011f)));
        float fTemp3 = (fTemp2 + -1.49999499f);
        int iTemp4 = int(fTemp3);
        int iTemp5 = (int(std::min<float>(fConst5, float(std::max<int>(0, iTemp4)))) + 1);
        float fTemp6 = std::floor(fTemp3);
        float fTemp7 = (fTemp2 + (-1.0f - fTemp6));
        float fTemp8 = (0.0f - fTemp7);
        float fTemp9 = (fTemp2 + (-2.0f - fTemp6));
        float fTemp10 = (0.0f - (0.5f * fTemp9));
        float fTemp11 = (fTemp2 + (-3.0f - fTemp6));
        float fTemp12 = (0.0f - (0.333333343f * fTemp11));
        float fTemp13 = (fTemp2 + (-4.0f - fTemp6));
        float fTemp14 = (0.0f - (0.25f * fTemp13));
        float fTemp15 = (fTemp2 - fTemp6);
        int iTemp16 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp4 + 1))))) + 1);
        float fTemp17 = (0.0f - fTemp9);
        float fTemp18 = (0.0f - (0.5f * fTemp11));
        float fTemp19 = (0.0f - (0.333333343f * fTemp13));
        int iTemp20 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp4 + 2))))) + 1);
        float fTemp21 = (0.0f - fTemp11);
        float fTemp22 = (0.0f - (0.5f * fTemp13));
        float fTemp23 = (fTemp7 * fTemp9);
        int iTemp24 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp4 + 3))))) + 1);
        float fTemp25 = (0.0f - fTemp13);
        float fTemp26 = (fTemp23 * fTemp11);
        int iTemp27 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp4 + 4))))) + 1);
        fVec1[0] = (((((fRec28[((IOTA - iTemp5) & 2047)] * fTemp8) * fTemp10) * fTemp12) * fTemp14) + (fTemp15 * ((((((fRec28[((IOTA - iTemp16) & 2047)] * fTemp17) * fTemp18) * fTemp19) + (0.5f * (((fTemp7 * fRec28[((IOTA - iTemp20) & 2047)]) * fTemp21) * fTemp22))) + (0.166666672f * ((fTemp23 * fRec28[((IOTA - iTemp24) & 2047)]) * fTemp25))) + (0.0416666679f * (fTemp26 * fRec28[((IOTA - iTemp27) & 2047)])))));
        float fTemp28 = (((fSlow1 * ftbl0mydspSIG0[int((65536.0f * fRec23[0]))]) + (fRec24[0] * ((fSlow7 * (fRec25[2] + (fRec25[0] + (2.0f * fRec25[1])))) + 1.0f))) - (0.5f * fVec1[1]));
        float fTemp29 = ((0.5f * fRec7[1]) + std::max<float>(-1.0f, std::min<float>(1.0f, (fTemp28 * (mydsp_faustpower2_f(fTemp28) + -1.0f)))));
        fVec2[(IOTA & 2047)] = fTemp29;
        float fTemp30 = (fConst6 * (fTemp0 * (0.730000019f - fTemp1)));
        float fTemp31 = (fTemp30 + -1.49999499f);
        int iTemp32 = int(fTemp31);
        int iTemp33 = (int(std::min<float>(fConst5, float(std::max<int>(0, iTemp32)))) + 1);
        float fTemp34 = std::floor(fTemp31);
        float fTemp35 = (fTemp30 + (-1.0f - fTemp34));
        float fTemp36 = (0.0f - fTemp35);
        float fTemp37 = (fTemp30 + (-2.0f - fTemp34));
        float fTemp38 = (0.0f - (0.5f * fTemp37));
        float fTemp39 = (fTemp30 + (-3.0f - fTemp34));
        float fTemp40 = (0.0f - (0.333333343f * fTemp39));
        float fTemp41 = (fTemp30 + (-4.0f - fTemp34));
        float fTemp42 = (0.0f - (0.25f * fTemp41));
        float fTemp43 = (fTemp30 - fTemp34);
        int iTemp44 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp32 + 1))))) + 1);
        float fTemp45 = (0.0f - fTemp37);
        float fTemp46 = (0.0f - (0.5f * fTemp39));
        float fTemp47 = (0.0f - (0.333333343f * fTemp41));
        int iTemp48 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp32 + 2))))) + 1);
        float fTemp49 = (0.0f - fTemp39);
        float fTemp50 = (0.0f - (0.5f * fTemp41));
        float fTemp51 = (fTemp35 * fTemp37);
        int iTemp52 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp32 + 3))))) + 1);
        float fTemp53 = (0.0f - fTemp41);
        float fTemp54 = (fTemp51 * fTemp39);
        int iTemp55 = (int(std::min<float>(fConst5, float(std::max<int>(0, (iTemp32 + 4))))) + 1);
        fVec3[0] = (((((fVec2[((IOTA - iTemp33) & 2047)] * fTemp36) * fTemp38) * fTemp40) * fTemp42) + (fTemp43 * ((((((fVec2[((IOTA - iTemp44) & 2047)] * fTemp45) * fTemp46) * fTemp47) + (0.5f * (((fTemp35 * fVec2[((IOTA - iTemp48) & 2047)]) * fTemp49) * fTemp50))) + (0.166666672f * ((fTemp51 * fVec2[((IOTA - iTemp52) & 2047)]) * fTemp53))) + (0.0416666679f * (fTemp54 * fVec2[((IOTA - iTemp55) & 2047)])))));
        fRec20[0] = fVec3[1];
        float fRec16 = fRec19;
        float fRec17 = fRec20[0];
        float fRec18 = fRec20[0];
        fRec11[(IOTA & 2047)] = fRec16;
        float fRec12 = (((((fTemp36 * fTemp38) * fTemp40) * fTemp42) * fRec11[((IOTA - iTemp33) & 2047)]) + (fTemp43 * ((((((fTemp45 * fTemp46) * fTemp47) * fRec11[((IOTA - iTemp44) & 2047)]) + (0.5f * (((fTemp35 * fTemp49) * fTemp50) * fRec11[((IOTA - iTemp48) & 2047)]))) + (0.166666672f * ((fTemp51 * fTemp53) * fRec11[((IOTA - iTemp52) & 2047)]))) + (0.0416666679f * (fTemp54 * fRec11[((IOTA - iTemp55) & 2047)])))));
        float fRec13 = fRec17;
        float fRec14 = fRec18;
        fRec7[0] = fRec12;
        float fRec8 = fRec7[1];
        float fRec9 = fRec13;
        float fRec10 = fRec14;
        fRec3[(IOTA & 2047)] = fRec8;
        float fRec4 = (((((fTemp8 * fTemp10) * fTemp12) * fTemp14) * fRec3[((IOTA - iTemp5) & 2047)]) + (fTemp15 * ((((((fTemp17 * fTemp18) * fTemp19) * fRec3[((IOTA - iTemp16) & 2047)]) + (0.5f * (((fTemp7 * fTemp21) * fTemp22) * fRec3[((IOTA - iTemp20) & 2047)]))) + (0.166666672f * ((fTemp23 * fTemp25) * fRec3[((IOTA - iTemp24) & 2047)]))) + (0.0416666679f * (fTemp26 * fRec3[((IOTA - iTemp27) & 2047)])))));
        float fRec5 = fRec9;
        float fRec6 = fRec10;
        fRec1[0] = fRec4;
        fRec2[0] = fRec6;
        fRec0[0] = ((fRec2[0] + (0.995000005f * fRec0[1])) - fRec2[1]);
        float fTemp56 = (fSlow0 * fRec0[0]);
        output0[i0] = FAUSTFLOAT(fTemp56);
        output1[i0] = FAUSTFLOAT(fTemp56);
        iRec15[1] = iRec15[0];
        fRec21[1] = fRec21[0];
        fRec23[1] = fRec23[0];
        fRec24[1] = fRec24[0];
        iRec26[1] = iRec26[0];
        fRec25[2] = fRec25[1];
        fRec25[1] = fRec25[0];
        fRec27[1] = fRec27[0];
        IOTA = (IOTA + 1);
        fRec29[1] = fRec29[0];
        fRec30[1] = fRec30[0];
        fVec1[1] = fVec1[0];
        fVec3[1] = fVec3[0];
        fRec20[1] = fRec20[0];
        fRec7[1] = fRec7[0];
        fRec1[1] = fRec1[0];
        fRec2[1] = fRec2[0];
        fRec0[1] = fRec0[0];
      }
    }

};

#ifdef FAUST_UIMACROS

#define FAUST_FILE_NAME "flute.dsp"
#define FAUST_CLASS_NAME "mydsp"
#define FAUST_INPUTS 0
#define FAUST_OUTPUTS 2
#define FAUST_ACTIVES 8
#define FAUST_PASSIVES 0

FAUST_ADDHORIZONTALSLIDER("flute/blower/pressure", fHslider3, 0.0f, 0.0f, 1.0f, 0.01f);
FAUST_ADDHORIZONTALSLIDER("flute/blower/breathGain", fHslider4, 0.10000000000000001f, 0.0f, 1.0f, 0.01f);
FAUST_ADDHORIZONTALSLIDER("flute/blower/breathCutoff", fHslider5, 2000.0f, 20.0f, 20000.0f, 0.10000000000000001f);
FAUST_ADDHORIZONTALSLIDER("flute/blower/vibratoFreq", fHslider2, 5.0f, 0.10000000000000001f, 10.0f, 0.10000000000000001f);
FAUST_ADDHORIZONTALSLIDER("flute/blower/vibratoGain", fHslider1, 0.25f, 0.0f, 1.0f, 0.01f);
FAUST_ADDHORIZONTALSLIDER("flute/fluteModel/tubeLength", fHslider6, 0.80000000000000004f, 0.01f, 3.0f, 0.01f);
FAUST_ADDHORIZONTALSLIDER("flute/fluteModel/mouthPosition", fHslider7, 0.5f, 0.0f, 1.0f, 0.01f);
FAUST_ADDHORIZONTALSLIDER("flute/fluteModel/outGain", fHslider0, 0.5f, 0.0f, 1.0f, 0.01f);

#define FAUST_LIST_ACTIVES(p) \
  p(HORIZONTALSLIDER, pressure, "flute/blower/pressure", fHslider3, 0.0f, 0.0f, 1.0f, 0.01f) \
  p(HORIZONTALSLIDER, breathGain, "flute/blower/breathGain", fHslider4, 0.10000000000000001f, 0.0f, 1.0f, 0.01f) \
  p(HORIZONTALSLIDER, breathCutoff, "flute/blower/breathCutoff", fHslider5, 2000.0f, 20.0f, 20000.0f, 0.10000000000000001f) \
  p(HORIZONTALSLIDER, vibratoFreq, "flute/blower/vibratoFreq", fHslider2, 5.0f, 0.10000000000000001f, 10.0f, 0.10000000000000001f) \
  p(HORIZONTALSLIDER, vibratoGain, "flute/blower/vibratoGain", fHslider1, 0.25f, 0.0f, 1.0f, 0.01f) \
  p(HORIZONTALSLIDER, tubeLength, "flute/fluteModel/tubeLength", fHslider6, 0.80000000000000004f, 0.01f, 3.0f, 0.01f) \
  p(HORIZONTALSLIDER, mouthPosition, "flute/fluteModel/mouthPosition", fHslider7, 0.5f, 0.0f, 1.0f, 0.01f) \
  p(HORIZONTALSLIDER, outGain, "flute/fluteModel/outGain", fHslider0, 0.5f, 0.0f, 1.0f, 0.01f) \

#define FAUST_LIST_PASSIVES(p) \

#endif

/***************************END USER SECTION ***************************/

/*******************BEGIN ARCHITECTURE SECTION (part 2/2)***************/

#define MULT_16 2147483647
#define DIV_16 4.6566129e-10

unsigned __exidx_start;
unsigned __exidx_end;

#if MIDICTRL
std::list<GUI*> GUI::fGuiList;
ztimedmap GUI::gTimedZoneMap;
#endif

flute::flute() : AudioStream(FAUST_INPUTS, new audio_block_t*[FAUST_INPUTS])
{
#ifdef NVOICES
  int nvoices = NVOICES;
  fDSP =  new mydsp_poly(new mydsp(), nvoices, true, true);
#else
  fDSP = new mydsp();
#endif

  fDSP->init(AUDIO_SAMPLE_RATE_EXACT);

  fUI = new MapUI();
  fDSP->buildUserInterface(fUI);

  // allocating Faust inputs
  if (fDSP->getNumInputs() > 0) {
    fInChannel = new float*[fDSP->getNumInputs()];
    for (int i = 0; i < fDSP->getNumInputs(); i++) {
      fInChannel[i] = new float[AUDIO_BLOCK_SAMPLES];
    }
  } else {
    fInChannel = NULL;
  }

  // allocating Faust outputs
  if (fDSP->getNumOutputs() > 0) {
    fOutChannel = new float*[fDSP->getNumOutputs()];
    for (int i = 0; i < fDSP->getNumOutputs(); i++) {
      fOutChannel[i] = new float[AUDIO_BLOCK_SAMPLES];
    }
  } else {
    fOutChannel = NULL;
  }

#if MIDICTRL
  fMIDIHandler = new teensy_midi();
  fMIDIInterface = new MidiUI(fMIDIHandler);
  fDSP->buildUserInterface(fMIDIInterface);
  fMIDIInterface->run();
#endif
}

flute::~flute()
{
  delete fDSP;
  delete fUI;
  for (int i = 0; i < fDSP->getNumInputs(); i++) {
    delete[] fInChannel[i];
  }
  delete [] fInChannel;
  for (int i = 0; i < fDSP->getNumOutputs(); i++) {
    delete[] fOutChannel[i];
  }
  delete [] fOutChannel;
#if MIDICTRL
  delete fMIDIInterface;
  delete fMIDIHandler;
#endif
}

template <int INPUTS, int OUTPUTS>
void flute::updateImp(void)
{
#if MIDICTRL
  // Process the MIDI messages received by the Teensy
  fMIDIHandler->processMidi();
  // Synchronize all GUI controllers
  GUI::updateAllGuis();
#endif

  if (INPUTS > 0) {
    audio_block_t* inBlock[INPUTS];
    for (int channel = 0; channel < INPUTS; channel++) {
      inBlock[channel] = receiveReadOnly(channel);
      if (inBlock[channel]) {
        for (int i = 0; i < AUDIO_BLOCK_SAMPLES; i++) {
          int32_t val = inBlock[channel]->data[i] << 16;
          fInChannel[channel][i] = val * DIV_16;
        }
        release(inBlock[channel]);
      } else {
        memset(fInChannel[channel], 0, AUDIO_BLOCK_SAMPLES * sizeof(float));
      }
    }
  }

  fDSP->compute(AUDIO_BLOCK_SAMPLES, fInChannel, fOutChannel);

  for (int channel = 0; channel < OUTPUTS; channel++) {
    audio_block_t* outBlock[OUTPUTS];
    outBlock[channel] = allocate();
    if (outBlock[channel]) {
      for (int i = 0; i < AUDIO_BLOCK_SAMPLES; i++) {
        int32_t val = fOutChannel[channel][i] * MULT_16;
        outBlock[channel]->data[i] = val >> 16;
      }
      transmit(outBlock[channel], channel);
      release(outBlock[channel]);
    }
  }
}

void flute::update(void) {
  updateImp<FAUST_INPUTS, FAUST_OUTPUTS>();
}

void flute::setParamValue(const std::string& path, float value)
{
  fUI->setParamValue(path, value);
}

float flute::getParamValue(const std::string& path)
{
  return fUI->getParamValue(path);
}

/********************END ARCHITECTURE SECTION (part 2/2)****************/

#endif
